///////////////////////////////////
// t@CNXCFILE`t@C
///////////////////////////////////

class CFILE
{
private:	//o[ϐ
	HGLOBAL	m_hMem;					//[ubNnh
	char	m_FileName[MAX_PATH];	//t@C
	char*	m_FilePtr;				//O[o[ւ̃|C^[i^j
public:	//o[ϐ
	DWORD	m_FileSize;				//t@CTCY
	char*	m_Ptr;					//obt@̃|C^[i^j

public:		//o[֐
	CFILE();						//RXgN^[iȏj
	CFILE(char*, DWORD);			//RXgN^[it@Cj
	~CFILE();						//fXgN^[
	char*	OpenFile(char*, DWORD);	//t@CJ
	char*	LoadFile(char*);		//t@Cǂݍ
	char*	SetFileSize(DWORD);		//t@CTCYݒ
	bool	SaveFile();				//t@Cނ
	bool	CloseFile();			//t@C߂
	bool	KillFile();				//t@C
	bool	RenFile(char*);			//t@C̕ύX
	char*	GoTop();				//t@C̐擪֍s
	char*	GoBottom();				//t@C̏Iɂ䂭
	char*	Read();					//t@Cobt@̕ǂ
	char*	Write(char*);			//t@Cobt@ɕ
	char*	Find(char*);			//t@Cobt@݈̕ʒuT
	bool	Replace(char*, char*);	//t@Cobt@̕u
	DWORD	GetTextSize();			//t@Cobt@̒̕Ԃ
	bool	GetEditText(HWND);		//GfBbgRg[當荞
	bool	PutEditText(HWND);		//GfBbgRg[ɕ\
};

//RXgN^[iȏj
CFILE::CFILE() {

	m_hMem = 0;					//t@Cnh
	*m_FileName = NULL;			//t@C
	m_FilePtr = m_Ptr = NULL;	//O[o[ւ̃|C^[i^j
	m_FileSize = 0;				//t@CTCY
}

//RXgN^[it@Cj
CFILE::CFILE(char* FileName, DWORD FileSize) {

	OpenFile(FileName, FileSize);
}

//fXgN^[
CFILE::~CFILE() {

	GlobalFree(m_hMem);	//O[o[̉
}

//t@C
char* CFILE::OpenFile(char* FileName, DWORD FileSize) {

	if(m_hMem) {		//Ƀt@C݂Ă鎞
		CloseFile();	//āAO[o[
	}
	if(lstrlen(FileName) > MAX_PATH)	FileName[MAX_PATH] = NULL;
	lstrcpy(m_FileName, FileName);	//pXEt@CMAX_PATH܂
	m_FileSize = FileSize;			//t@CTCYL^
	m_hMem = GlobalAlloc(GHND, m_FileSize + 1);
	if(!m_hMem == NULL)
		return (m_Ptr = m_FilePtr = (char*)GlobalLock(m_hMem));
	else {
		MessageBox(NULL, "t@CI[vł܂ł", "G[",
					MB_OK | MB_ICONSTOP);
		return (m_Ptr = m_FilePtr = NULL);
	}
}

//t@Cǂݍ
char* CFILE::LoadFile(char* FileName) {

	if(m_hMem) {		//Ƀt@C݂Ă鎞
		CloseFile();	//āAO[o[
	}
	if(lstrlen(FileName) > MAX_PATH)	FileName[MAX_PATH] = NULL;
	lstrcpy(m_FileName, FileName);	//pXEt@CMAX_PATH܂
	HANDLE hFile = CreateFile(m_FileName, GENERIC_READ,
						FILE_SHARE_READ, NULL,
						OPEN_ALWAYS, NULL, NULL);	//t@CǍŃI[v
	if(hFile != INVALID_HANDLE_VALUE) {	//I[vł
		m_FileSize = GetFileSize(hFile, NULL);		//t@CTCY
		if(m_FileSize != 0xFFFFFFFF) {				//-1(0xFFFFFFFF)G[
			m_hMem = GlobalAlloc(GHND, m_FileSize + 1);
			if(m_hMem != NULL) {
				m_FilePtr = (char*)GlobalLock(m_hMem);
				if(m_FilePtr) {	//obt@[ݒłH
					DWORD dwRead;
					ReadFile(hFile, m_FilePtr, m_FileSize, &dwRead, NULL);
					m_FilePtr[m_FileSize] = 0; //t@C̏I[NULLu
				}
			}
		}
		CloseHandle(hFile);				//t@C̃N[Y
		return (m_Ptr = m_FilePtr);
	}
	MessageBox(NULL, "t@Cǂݍ߂܂ł", "G[",
				MB_OK | MB_ICONSTOP);
	m_hMem = 0;
	return NULL;
}

//t@CTCYݒ
char* CFILE::SetFileSize(DWORD NewSize) {

	m_FileSize = NewSize;
	m_hMem = GlobalReAlloc(m_hMem, m_FileSize + 1,
							GMEM_MOVEABLE | GMEM_ZEROINIT);
	if(m_hMem != NULL) {
		m_FilePtr[m_FileSize] = 0; //t@C̏I[NULLu
		return (m_Ptr = m_FilePtr = (char*)GlobalLock(m_hMem));
	}
	else {
		MessageBox(NULL, "t@CTCYύXł܂ł", "G[",
					MB_OK | MB_ICONSTOP);
		return NULL;
	}
}

//t@CZ[u
bool CFILE::SaveFile() {

	bool bSuccess = FALSE;
	HANDLE hFile = CreateFile(m_FileName, GENERIC_WRITE,
						FILE_SHARE_READ, NULL,
						OPEN_ALWAYS, NULL, NULL);	//t@CǍŃI[v
	if(hFile != INVALID_HANDLE_VALUE) {				//I[vł
		if(GetLastError() == ERROR_ALREADY_EXISTS) {	//t@C݃tOL^
			if(MessageBox(NULL, "㏑܂H", "㏑mF",
							MB_YESNO) == IDNO) {
				CloseHandle(hFile);					//t@C̃N[Y
				return bSuccess;
			}
		}
		DWORD dwWritten;
		SetFilePointer(hFile, 0, NULL, FILE_BEGIN);
		m_FileSize = GetTextSize();
		if(WriteFile(hFile, m_FilePtr, m_FileSize, &dwWritten, NULL))
			bSuccess = TRUE;
		CloseHandle(hFile);							//t@C̃N[Y
	}
	else {
		MessageBox(NULL, "t@C߂܂ł", "G[",
					MB_OK | MB_ICONSTOP);
	}
	return bSuccess;
}

//t@C߂
bool CFILE::CloseFile() {

	GlobalFree(m_hMem);		//O[o[̉
	m_hMem = 0;				//t@Cnh
	*m_FileName = NULL;		//t@C
	m_FilePtr = m_Ptr = 0;	//O[o[ւ̃|C^[i^j
	m_FileSize = 0;			//t@CTCY
	return TRUE;
}

//t@C
bool CFILE::KillFile() {

	if(MessageBox(NULL, "t@C܂H", "mF",
					MB_YESNO)  == IDNO)
		return FALSE;
	CloseFile();				//t@C߂
	DeleteFile(m_FileName);		//t@C폜
	return TRUE;
}

//t@C̕ύX
bool CFILE::RenFile(char* NewFile) {

	return lstrcpy(m_FileName, NewFile);
}

//t@C̐擪֍s
char*	CFILE::GoTop() {

	return (m_Ptr = m_FilePtr);
}

//t@Cit@C̃eLXgj̏Iɂ䂭
char*	CFILE::GoBottom() {

	char* cp = m_FilePtr;
	while(*cp) cp++;
	m_Ptr = cp > (m_FilePtr + m_FileSize) ? (m_FilePtr + m_FileSize) : cp;
	return m_Ptr;
}

//obt@̕ǂ
char*	CFILE::Read() {

	return m_Ptr;
}

//obt@ɕ
char*	CFILE::Write(char* str) {

	if(lstrlen(str) > (m_FilePtr + m_FileSize - m_Ptr)) {
		MessageBox(NULL, "񂪒܂", "G[",
					MB_OK | MB_ICONSTOP);
		return NULL;
	}
	for(int i = 0, j = lstrlen(str); i < j; i++) {
		*m_Ptr = str[i];
		m_Ptr++;
	}
	return m_Ptr;	//񂾕񕪐ɐi񂾃|C^[Ԃ
}

//obt@݈̕ʒuT
char*	CFILE::Find(char* str) {

	return strstr(m_Ptr, str);
}

//t@Cobt@̕u
bool CFILE::Replace(char* org, char* sub) {

	char* cp = m_Ptr;
	int orglen = lstrlen(org);
	int sublen = lstrlen(sub);
	int lendiff = sublen - orglen;
	bool bSuccess = FALSE;
	while((cp = strstr(cp, org))) {	//orgT
		//L΃obt@TCYύXāA񒷂̕ړ
		if(lendiff >= 0) {
			int offset = cp - m_Ptr;	//[ubN𑝂₷ꍇ
			SetFileSize(m_FileSize + lendiff);
			cp = m_Ptr + offset;		//m_Ptrς蓾̂ōĐݒ肷
			MoveMemory (cp + sublen, cp + orglen, lstrlen(cp + orglen));
			for(int i = 0, j = lstrlen(sub); i < j; i++) cp[i] = sub[i];
		}
		else {
			MoveMemory (cp + sublen, cp + orglen, lstrlen(cp + orglen));
			for(int i = 0, j = lstrlen(sub); i < j; i++) cp[i] = sub[i];
			SetFileSize(m_FileSize + lendiff);	//ꍇ͗vȂ
		}
		bSuccess =TRUE;
	}
	return bSuccess;
}

//t@Cobt@̒̕Ԃ
DWORD CFILE::GetTextSize() {

	return (GoBottom() - m_FilePtr + 1); 
}

//GfBbgRg[當荞
bool CFILE::GetEditText(HWND hWnd) {

	SetFileSize(SendMessage(hWnd, WM_GETTEXTLENGTH, 0, 0));
	return SendMessage(hWnd, WM_GETTEXT, m_FileSize + 1, (LPARAM)m_FilePtr);
}

//GfBbgRg[ɕ\
bool CFILE::PutEditText(HWND hWnd) {

	return SendMessage(hWnd, WM_SETTEXT, 0, (LPARAM)m_FilePtr);
}
