////////////////////////////////
// CIMGLISTNX(`t@Cj
//iBitmap̂݁j
////////////////////////////////

class CIMGLIST
{
public:
	HIMAGELIST m_hImgList;	//C[WXgnh
	UINT m_flag;			//C[WXg̃tbO
	int	m_w;				//C[W̕
	int	m_h;				//C[W̍
	int m_ImgNum;			//őC[W
	int m_ImgIndex;			//݂̃C[WCfbNX
	bool m_fDragging;		//hbOtOisTRUEj
	POINT m_ptHotSpot;		//C[W̃zbgX|bg
	HWND m_hWnd;			//\ΏۃEBhEnh
	CANVAS* m_cvs;			//\pEBhEzEBhE
	int m_cxOffset	;		//EBhEOƃNCAg̈̍
	int m_cyOffset	;		//EBhEOƃNCAg̈̍

	CIMGLIST();											//RXgN^[iPj
	CIMGLIST(HWND, int, int, UINT, int, int, CANVAS*);	//RXgN^[iQj
	~CIMGLIST();										//fXgN^[
	bool Init(HWND, int, int, UINT, int, int, CANVAS*);	//ImageList̏
	bool GetInfo(int, IMAGEINFO*);						//C[W
	bool AddImage(HBITMAP, HBITMAP);					//C[W̒ǉiPj
	bool AddMasked(HBITMAP, COLORREF);					//C[W̒ǉiQj
	bool Replace(int, HBITMAP, HBITMAP);				//C[W̌iPj
	void Exchange(int, int);							//C[W̌iQj
	void ReArrange(int, int);							//C[W̕ёւ
	bool DeleteImage(int);								//C[W̍폜
	int Count();										//݂ۗ̕LC[W
	bool ShowImage(int, int, int);						//C[W̕\
	void ShowAll(int, int);								//SC[W̕\
	bool StartDragging(int, int, int, int, int);		//C[WhbOJn
	bool MoveImage(int, int);							//C[W𓮂
	bool StopDragging(int, int);						//hbOI
};

//RXgN^[iPj
CIMGLIST::CIMGLIST() {

	m_hImgList = 0;
	m_hWnd = 0;
	m_ImgNum = 0;
}

//RXgN^[iQj
CIMGLIST::CIMGLIST(HWND hWnd, int w, int h, UINT flag = ILC_COLOR,
					int ininum = 32, int addnum = 8, CANVAS* cvs = 0) {

	Init(hWnd, w, h, flag, ininum, addnum, cvs);	//Ō̃C[W͍Ɨp
}

//fXgN^[iC[WXg̔jj
CIMGLIST::~CIMGLIST() {

	ImageList_Destroy(m_hImgList);
}

//ImageList̏
bool CIMGLIST::Init(HWND hWnd, int w, int h, UINT flag = ILC_COLOR,
					int ininum = 32, int addnum = 8, CANVAS* cvs = 0) {

	m_hWnd = hWnd;
	m_ImgNum = ininum;
	m_w = w;
	m_h = h;
	m_cvs = cvs;
	//EBhEOƓ𑪂
	RECT winrect, clrect;
	GetWindowRect(m_hWnd, &winrect);
	GetClientRect(m_hWnd, &clrect);
	m_cxOffset = ((winrect.right - winrect.left) -
					(clrect.right - clrect.left)) / 2;		//E̕
	m_cyOffset = ((winrect.bottom - winrect.top) -
					(clrect.bottom - clrect.top)) -			//LvVAj[
					m_cxOffset;								//E̍
	return m_hImgList  = ImageList_Create(w, h, m_flag = flag, ininum, addnum);
}

//C[W
bool CIMGLIST::GetInfo(int num, IMAGEINFO* lpImgInfo) {

	return ImageList_GetImageInfo(m_hImgList, num, lpImgInfo);
}

//C[W̒ǉiPj
bool CIMGLIST::AddImage(HBITMAP hbmImage, HBITMAP hbmMask = NULL) {

	bool bSuccess = ImageList_Add(m_hImgList, hbmImage, hbmMask);
	m_ImgIndex = Count();
	return bSuccess;
}

//C[W̒ǉiQj
bool CIMGLIST::AddMasked(HBITMAP hbmImage, COLORREF crMask) {

	bool bSuccess = ImageList_AddMasked(m_hImgList, hbmImage, crMask);
	m_ImgIndex = Count();
	return bSuccess;
}

//C[W̌iPj
bool CIMGLIST::Replace(int num, HBITMAP hbmImage, HBITMAP hbmMask) {

	return ImageList_Replace(m_hImgList, num, hbmImage, hbmMask);
}

//C[W̌iQj
void CIMGLIST::Exchange(int num1, int num2) {

	//̍sŁu֐ȂvG[ol"-D_WIN32_WINNT=0x400"IvV^ĂB
	ImageList_Copy(m_hImgList, num1, m_hImgList, num2, ILCF_SWAP);
}

//C[W̕ёւ
void CIMGLIST::ReArrange(int num1, int num2) {

	if(num1 > num2) {
		for(int i = num1; i > num2; i--)
			Exchange(i - 1, i);
	}
	else {
		for(int i = num1; i < num2; i++)
			Exchange(i, i + 1);
	}
}

//C[W̍폜
bool CIMGLIST::DeleteImage(int num) {

	bool bSuccess = ImageList_Remove(m_hImgList, num);
	m_ImgIndex = Count();
	return bSuccess;
}

//݂ۗ̕LC[W
int CIMGLIST::Count() {

	return ImageList_GetImageCount(m_hImgList);
}

//C[W̕\iPj
bool CIMGLIST::ShowImage(int x, int y, int i) {

	if (m_cvs)
		return ImageList_Draw(m_hImgList, i, m_cvs->hDC(), x, y, ILD_TRANSPARENT);
	else {
		HDC hDC = GetDC(m_hWnd);
		return ImageList_Draw(m_hImgList, i, hDC, x, y, ILD_TRANSPARENT);
		ReleaseDC(m_hWnd, hDC);
	}
}

//C[W̕\iQj
void CIMGLIST::ShowAll(int x, int y) {

	if (m_cvs)
		for(int i = 0, j = Count(); i < j; i++) {
			ImageList_Draw(m_hImgList, i, m_cvs->hDC(), x + i * m_w, y, ILD_TRANSPARENT);
		}
	else {
		HDC hDC = GetDC(m_hWnd);
		for(int i = 0, j = Count(); i < j; i++) {
			ImageList_Draw(m_hImgList, i, hDC, x + i * m_w, y, ILD_TRANSPARENT);
		}
		ReleaseDC(m_hWnd, hDC);
	}
}

//C[WhbOJn
bool CIMGLIST::StartDragging(int Imgx, int Imgy, int mx, int my, int num) { 

	//}EXLv`[
	SetCapture(m_hWnd);
	//zbgX|bgʒǔvZƋL^
	m_ptHotSpot.x = mx - Imgx;
	m_ptHotSpot.y = my - Imgy;
	//hbOJn
	if (!ImageList_BeginDrag(m_hImgList, m_ImgIndex = num,
					m_ptHotSpot.x, m_ptHotSpot.y))
		return FALSE;
	ImageList_DragEnter(m_hWnd, mx + m_cxOffset, my + m_cyOffset);
	//hbOtO^
	m_fDragging = TRUE; 
	//EBhE`XV
	InvalidateRect(m_hWnd, NULL, TRUE);
	UpdateWindow(m_hWnd);
	return TRUE; 
}

//C[W𓮂
bool CIMGLIST::MoveImage(int x, int y) {

	if (!ImageList_DragMove(x + m_cxOffset, y + m_cyOffset))
		return FALSE;
	return TRUE;
}

//hbOI
bool CIMGLIST::StopDragging(int x, int y) {

	ImageList_EndDrag();
	ImageList_DragLeave(m_hWnd);
	m_fDragging = FALSE;
	ReleaseCapture();
	return TRUE;
}
