///////////////////////////////////////
// CMNDLGNXwb_[i`t@Cj
///////////////////////////////////////

class CMNDLG
{
public:	//o[ϐ
	char		m_FileName[MAX_PATH];	//t@C̊i[ꏊ
   	char		m_Path[MAX_PATH];		//t@CpX̊i[ꏊ
	COLORREF	m_Color;				//F̊i[ꏊ
	HFONT		m_Font;					//tHgnh̊i[ꏊ

public:	//o[֐
	CMNDLG();								//RXgN^[
	~CMNDLG();								//fXgN^[
	char* GetFileName(HWND, char*, bool, char*, char*, char*, DWORD);
	COLORREF GetColor(HWND);
	HFONT GetFont(HWND);
	char* GetPath(HWND, char*);
};

//RXgN^[
CMNDLG::CMNDLG() {
	*m_FileName = NULL;
	m_Color = 0;
	m_Font = 0;
}

//fXgN^[
CMNDLG::~CMNDLG() {
	if(m_Font)
		DeleteObject(m_Font);
}

char* CMNDLG::GetFileName(HWND hWnd, char* Filter, bool Open = TRUE,
				char* Ext = NULL, char* IniDir = NULL, char* Title = NULL,
				DWORD Flag = OFN_EXPLORER | OFN_FILEMUSTEXIST | 
				OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT) {

	if(IniDir)	*m_FileName = NULL;	//m_FileNameĂKv
	bool success = FALSE;
	OPENFILENAME ofn;				//I[vt@C_CAO\
	ZeroMemory(&ofn, sizeof(ofn));	//[
	ofn.lStructSize		= sizeof(ofn);
	ofn.hwndOwner		= hWnd;
	ofn.lpstrFilter		= Filter;
	ofn.nFilterIndex	= 1;
	ofn.lpstrFile		= m_FileName;
	ofn.nMaxFile		= MAX_PATH;
	ofn.lpstrTitle		= Title;
	ofn.lpstrInitialDir = IniDir;
	ofn.Flags			= Flag;
	ofn.lpstrDefExt		= Ext;
	if(Open)
		success = GetOpenFileName(&ofn);
    else
		success = GetSaveFileName(&ofn);
	if(success)		return m_FileName;
	else			return 0;
}

COLORREF CMNDLG::GetColor(HWND hWnd) {

	static	CHOOSECOLOR clr;
	static	COLORREF cref[16];

	clr.lStructSize		= sizeof(CHOOSECOLOR);
	clr.hwndOwner		= hWnd;
	clr.hInstance		= 0;
	clr.rgbResult		= m_Color; //CC_RGBINITtbOƂꂪftHgɂȂ
	clr.lpCustColors	= cref;
	clr.Flags			= CC_RGBINIT;
	clr.lCustData		= 0L;
	clr.lpfnHook		= NULL;
	clr.lpTemplateName	= NULL;
	if(ChooseColor(&clr))
		return (m_Color = clr.rgbResult);
	 else
     	return NULL;
}

HFONT CMNDLG::GetFont(HWND hWnd) {

	if(m_Font)
    	DeleteObject(m_Font);
	//tHgChooseFont_CAO\̂瓾
	static	CHOOSEFONT	cf;
	static	LOGFONT		lf;
	cf.lStructSize		= sizeof(CHOOSEFONT);
	cf.hwndOwner		= hWnd;
	cf.hDC				= 0;
	cf.lpLogFont		= &lf; //Ǐʂ͂ɓ
	cf.iPointSize		= 12;
	cf.Flags			= CF_EFFECTS | CF_SCREENFONTS;
	cf.rgbColors		= 0; //tHgF|_CAOłg
	cf.lCustData		= 0L;
	cf.lpfnHook			= NULL;
	cf.lpTemplateName	= NULL;
	cf.hInstance		= 0;
	cf.lpszStyle		= NULL;
	cf.nFontType		= SCREEN_FONTTYPE | REGULAR_FONTTYPE | BOLD_FONTTYPE | ITALIC_FONTTYPE;
	cf.nSizeMin			= 0;
	cf.nSizeMax			= 0;
	if(!ChooseFont(&cf)) 	//CHOOSEFONT\̂ւ̃|C^[
		return NULL;
	return (m_Font = CreateFontIndirect(cf.lpLogFont));
}

char* CMNDLG::GetPath(HWND hWnd, char* Title) {

	BROWSEINFO BrowsingInfo;
	LPITEMIDLIST ItemID;
	ZeroMemory(&BrowsingInfo, sizeof(BROWSEINFO));
	BrowsingInfo.hwndOwner		= hWnd;
	BrowsingInfo.pszDisplayName	= m_Path;
	BrowsingInfo.lpszTitle		= Title;
	BrowsingInfo.ulFlags		= BIF_USENEWUI;	//CoInitialize֐ɂCOMKv
	ItemID=SHBrowseForFolder(&BrowsingInfo);
	if(SHGetPathFromIDList(ItemID, m_Path)) {
		GlobalFreePtr(ItemID);
		return m_Path;
	}
	else
		return NULL;
}
