//-----------------------
//        CSTR.h
// Copyright January 2002
// 		By K. Yoshida
// 		Version 1.0A
// CSTR Class wb_[
//-----------------------
#ifndef	_CSTR_
#define _CSTR_

class CSTR {

	char*	m_str;

public:
	CSTR();									//RXgN^[ij
	CSTR(const char*);						//RXgN^[ij
	CSTR(const CSTR&);						//RXgN^[iCSTRj
	CSTR(const long);						//RXgN^[ij
	~CSTR();								//fXgN^[
	CSTR& operator = (const char*);			//operator = (B) ---> = B;
	CSTR& operator = (const CSTR&);			//operator = (B) ---> = B;
	CSTR& operator = (const long);			//operator = (B) ---> = B;
	char* ToChar() {return m_str;}			//|C^[ƂĕԂ
	void Print();							//m_str󎚂
	friend CSTR operator + (const CSTR&, const CSTR&);	//A operator + (B) --->= A + B;
	friend bool operator == (const CSTR&, const CSTR&);	//A operator == (B) --->= A == B;
	friend bool operator == (const CSTR&, const char*);	//A operator == (B) --->= A == B;
	friend bool operator != (const CSTR&, const CSTR&);	//A operator == (B) --->= A != B;
	friend bool operator != (const CSTR&, const char*);	//A operator == (B) --->= A != B;
	bool FromFile(char*, char*, HWND);		//t@C̓Ǎ
	bool FromFile(char*);					//t@C̓Ǎ
	bool ToFile(char* , char* , HWND);		//t@Cւ̏
	bool ToFile(char*);						//t@Cւ̏
	bool Next(CSTR&);						//m_str̒P؂o
	bool GetLine(CSTR&);					//̍s܂Ői
	bool NextLine();						//̍s܂Ői
	char* Find(char*, char*);				//̌
	char* Replace(char*, char*, char*);		//̒u
	void ReplaceAll(char*, char*, char*);	//̑Su
};

//RXgN^[ij
CSTR::CSTR() {

	m_str = new char[1];
	*m_str = NULL;
}

//RXgN^[ij
CSTR::CSTR(const char* string) {

	m_str = new char[lstrlen(string) + 1];
	lstrcpy(m_str, string);
}

//RXgN^[iCSTRj
CSTR::CSTR(const CSTR& cst) {

	m_str = new char[lstrlen(cst.m_str) + 1];
	lstrcpy(m_str, cst.m_str);
}

//RXgN^[ij
CSTR::CSTR(const long i) {

	char sbuff[MAX_PATH / 8];
	wsprintf(sbuff, "%d", i);
	m_str = new char[lstrlen(sbuff) + 1];
	lstrcpy(m_str, sbuff);
}

//fXgN^[
CSTR::~CSTR() {

	delete [] m_str;
}

//chaȓ
CSTR& CSTR::operator = (const char* str) {

	delete [] m_str;
	m_str = new char[lstrlen(str) + 1];
	lstrcpy(m_str, str);
	return *this;
}

//CSTȒ
CSTR& CSTR::operator = (const CSTR& cst) {

	if(&cst != this) {	//You can't copy yourself
		delete [] m_str;
		m_str = new char[lstrlen(cst.m_str) + 1];
		lstrcpy(m_str, cst.m_str);
	}
	return *this;
}

//̑
CSTR& CSTR::operator = (const long i) {

	char sbuff[MAX_PATH / 8];
	wsprintf(sbuff, "%d", i);
	delete [] m_str;
	m_str = new char[lstrlen(sbuff) + 1];
	lstrcpy(m_str, sbuff);
	return *this;
}

//m_str󎚂
void CSTR::Print() {

	MessageBox(NULL, m_str, "CSTR Message", MB_OK);
}

//ǉZq̒`
CSTR operator + (const CSTR& cst1, const CSTR& cst2) {

	CSTR CSTR;
	delete [] CSTR.m_str;
	CSTR.m_str = new char[lstrlen(cst1.m_str) + lstrlen(cst2.m_str) + 1];
	lstrcpy(CSTR.m_str, cst1.m_str);
	lstrcat(CSTR.m_str, cst2.m_str);
	return CSTR;
}

//rZq̒`iPj
bool operator == (const CSTR& cst1, const CSTR& cst2) {

	return !lstrcmp(cst1.m_str, cst2.m_str);
}

//rZq̒`iQj
bool operator == (const CSTR& cst, const char* str) {

	return !lstrcmp(cst.m_str, str);
}

//rZq̒`iRj
bool operator != (const CSTR& cst1, const CSTR& cst2) {

	return lstrcmp(cst1.m_str, cst2.m_str);
}

//rZq̒`iSj
bool operator != (const CSTR& cst, const char* str) {

	return lstrcmp(cst.m_str, str);
}

//t@C̓Ǎ
bool CSTR::FromFile(char* Filter, char* FilePath, HWND hWnd = NULL) {

	char FileName[MAX_PATH];
	char file_path[MAX_PATH];
	lstrcpy(file_path, FilePath);	//Default Path
	OPENFILENAME ofn;				//I[vt@C_CAO\

	ZeroMemory(&ofn, sizeof(ofn));	//[
	FileName[0] = NULL;

	ofn.lStructSize		= sizeof(ofn);
	ofn.hwndOwner		= hWnd;
	ofn.lpstrFilter		= Filter;
	ofn.nFilterIndex	= 1;
	ofn.lpstrFile		= FileName;
	ofn.nMaxFile		= MAX_PATH;
	if(!*file_path)					//KlNULLłΌ݂̃fBNg[
		GetCurrentDirectory(MAX_PATH, file_path);
	ofn.lpstrInitialDir = file_path;
	ofn.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
	if(!GetOpenFileName(&ofn))	return FALSE;		//ǂݍ݌

	BOOL bSuccess = FALSE;
	HANDLE hFile;
	hFile = CreateFile(FileName, GENERIC_READ, FILE_SHARE_READ, NULL,
						OPEN_EXISTING, NULL, NULL);	//t@CǍ݂ŃI[v
	if(hFile != INVALID_HANDLE_VALUE) {				//I[vł
		DWORD dwFileSize = GetFileSize(hFile, NULL);
		if(dwFileSize != 0xFFFFFFFF) {				//-1(0xFFFFFFFF)G[
			delete [] m_str;						//̕p
			m_str = new char[dwFileSize + 1];		//ǂݍ񂾃f[^NULLI[悤ɂ
			DWORD dwRead;
			if(ReadFile(hFile, m_str, dwFileSize, &dwRead, NULL)) {
				m_str[dwFileSize] = 0; 				//Ô߁Aobt@̏I[NULLu
				bSuccess = TRUE;					//ǂݍݐ
			}
		}
		CloseHandle(hFile);							//t@C̃N[Y
	}
	return bSuccess;
}

//t@C̓Ǎ
bool CSTR::FromFile(char* FileName) {

	BOOL bSuccess = FALSE;
	HANDLE hFile;
	hFile = CreateFile(FileName, GENERIC_READ, FILE_SHARE_READ, NULL,
						OPEN_EXISTING, NULL, NULL);	//t@CǍ݂ŃI[v
	if(hFile != INVALID_HANDLE_VALUE) {				//I[vł
		DWORD dwFileSize = GetFileSize(hFile, NULL);
		if(dwFileSize != 0xFFFFFFFF) {				//-1(0xFFFFFFFF)G[
			delete [] m_str;						//̕p
			m_str = new char[dwFileSize + 1];		//ǂݍ񂾃f[^NULLI[悤ɂ
			DWORD dwRead;
			if(ReadFile(hFile, m_str, dwFileSize, &dwRead, NULL)) {
				m_str[dwFileSize] = 0; 				//Ô߁Aobt@̏I[NULLu
				bSuccess = TRUE;					//ǂݍݐ
			}
		}
		CloseHandle(hFile);							//t@C̃N[Y
	}
	return bSuccess;
}

//t@Cւ̏
bool CSTR::ToFile(char* Filter, char* Default, HWND hWnd = NULL) {

	char FileName[MAX_PATH];
	char file_path[MAX_PATH];
	OPENFILENAME ofn;				//I[vt@C_CAO\

	ZeroMemory(&ofn, sizeof(ofn));	//[
	FileName[0] = NULL;

	ofn.lStructSize		= sizeof(ofn);
	ofn.hwndOwner		= hWnd;
	ofn.lpstrFilter		= Filter;
	ofn.nFilterIndex	= 1;
	ofn.lpstrFile		= FileName;
	ofn.nMaxFile		= MAX_PATH;
	GetCurrentDirectory(MAX_PATH, file_path);
	ofn.lpstrInitialDir = file_path;
	ofn.lpstrDefExt		= Default;		//ftHg̊gq
	ofn.Flags = OFN_EXPLORER | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY |
				OFN_OVERWRITEPROMPT;

	if(!GetSaveFileName(&ofn))	return FALSE;;

	BOOL bSuccess = FALSE;
	HANDLE hFile;
	hFile = CreateFile(FileName, GENERIC_WRITE, NULL, NULL,	//t@C݂ŃI[v
						CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile != INVALID_HANDLE_VALUE) {				//I[vł
		DWORD dwTextLength = lstrlen(m_str) + 1;	//obt@當񒷎擾ANULLI[Z
		if(dwTextLength > 0) {						//eLXgΈȉs
			DWORD dwWritten;
			if(WriteFile(hFile, m_str, dwTextLength, &dwWritten, NULL))
				bSuccess = TRUE;					//ݐ
		}
		CloseHandle(hFile);							//t@C̃N[Y
	}
	return bSuccess;
}

//t@Cւ̏
bool CSTR::ToFile(char* FileName) {

	BOOL bSuccess = FALSE;
	HANDLE hFile;
	hFile = CreateFile(FileName, GENERIC_WRITE, NULL, NULL,	//t@C݂ŃI[v
						CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile != INVALID_HANDLE_VALUE) {				//I[vł
		DWORD dwTextLength = lstrlen(m_str) + 1;	//obt@當񒷎擾ANULLI[Z
		if(dwTextLength > 0) {						//eLXgΈȉs
			DWORD dwWritten;
			if(WriteFile(hFile, m_str, dwTextLength, &dwWritten, NULL))
				bSuccess = TRUE;					//ݐ
		}
		CloseHandle(hFile);							//t@C̃N[Y
	}
	return bSuccess;
}

//m_str̒P؂o
bool CSTR::Next(CSTR& destination) {

	CSTR str;
	delete [] str.m_str;
	str.m_str = new char[lstrlen(m_str) + 1];
	char* ptr = m_str;
	char* des = str.m_str;
	bool Terminate = TRUE;
	//Xy[X̓XLbv
	while(isspace(*ptr) || (*ptr == -0x7F && *(ptr + 1) == 0x40) || *ptr == ',') {
		if(isspace(*ptr) || *ptr == ',')
			ptr++;						//XLbvXy[X
		else {
			ptr++;	ptr++;				//Sp"@"XLbv
		}
	}
	//Xy[X𒲂ׂ
	while(!isspace(*ptr)) {				//Xy[XłȂ
		if(!*ptr) {						//NULLI[ȂFALSEԂ
			Terminate = FALSE;
			break;
		}
		else if(*ptr == -0x7F && *(ptr + 1) == 0x40) {
			break;						//Sp"@"ȂI
		}
		else if(*ptr == ',') {
			ptr++;						//','XLbvĎ̕܂Ői
			break;						//󔒕
		}
		else if(*ptr == '"') {
			ptr++;						//'"'XLbvĒgo
			while(*ptr != '"') {		//'"'Ȃ'"'܂Ői
				if(!*ptr) {				//NULLI[ȂFALSEԂ
					Terminate = FALSE;
					break;
				}
				*des = *ptr;
				ptr++;	des++;
			}
			ptr++;						//\[X|C^[͎̕֐i߂
			break;						//[v𔲂ăfXeBl[VNULL
		}
		else if(*ptr == '/' && *(ptr + 1) == '*') {
			ptr++;	ptr++;				//"/*`*/"Rg
			while(!(*ptr == '*' && *(ptr + 1) == '/')) {
				if(!*ptr) {				//NULLI[ȂFALSEԂ
					Terminate = FALSE;
					break;
				}
				ptr++;
			}
			ptr++;	ptr++;
			//ēxXy[XXLbv
			while(isspace(*ptr) || (*ptr == -0x7F && *(ptr + 1) == 0x40) || *ptr == ',') {
				if(!*ptr) {				//NULLI[ȂFALSEԂ
					Terminate = FALSE;
					break;
				}
				if(isspace(*ptr) || *ptr == ',')
					ptr++;				//XLbvXy[X
				else {
					ptr++;	ptr++;		//Sp"@"XLbv
				}
			}
			continue;
		}
		else if(*ptr == '/' && *(ptr + 1) == '/') {
			while(*ptr != '\n') {		//"//"Rg
				if(!*ptr) {				//NULLI[ȂFALSEԂ
					Terminate = FALSE;
					break;
				}
				ptr++;
			}
			while(isspace(*ptr) || (*ptr == -0x7F && *(ptr + 1) == 0x40) || *ptr == ',') {
				if(!*ptr) {				//NULLI[ȂFALSEԂ
					Terminate = FALSE;
					break;
				}
				if(isspace(*ptr) || *ptr == ',')
					ptr++;				//XLbvXy[X
				else {
					ptr++;	ptr++;		//Sp"@"XLbv
				}
			}
			continue;
		}
		else {
			*des = *ptr;
		}
		ptr++;	des++;
	}
	*des = NULL;

	destination = str;			//destinationɐ؂
	str = ptr;					//strm_striptrȍ~̕
	delete [] m_str;
	m_str = new char[lstrlen(str.m_str) + 1];
	strcpy(m_str, str.m_str);	//m_strɂ͐؂̕񂪓
	if(*str.m_str || *destination.m_str)
		Terminate = TRUE;		//cNULLł؂񂪂Α
	else
		Terminate = FALSE;		//NULLȂI
	return Terminate;			//stOԂ
}

//̍s܂Ői
bool CSTR::GetLine(CSTR& destination) {

	bool Terminate = TRUE;
	char* ptr = m_str;
	char* des = ptr;
	while(*des && *des != '\n')
		des++;
	if(!*des) {
		destination = "";
		Terminate = FALSE;	//̏ITC
	}
	else {
		*des = NULL; des++;				//NULLI[Ai߂
		delete destination.m_str;
		destination.m_str = new char[des - ptr + 1];
		strcpy(destination.m_str, ptr);
		destination.m_str[des - ptr - 1] = '\n';//NULLɂ'\n't
		destination.m_str[des - ptr] = NULL;	//NULLI[
	}
	if(Terminate) {					//܂񂪂Ύc
		CSTR str = des;
		delete [] m_str;
		m_str = new char[lstrlen(str.m_str) + 1];
		strcpy(m_str, str.m_str);	//m_strɂ͐؂̕񂪓
	}
	if(*destination.m_str)			//NULLɏoA
		Terminate = TRUE;			//؂񂪂Α
	else
		Terminate = FALSE;			//NULLȂI
	return Terminate;				//stOԂ
}

//̍s܂Ői
bool CSTR::NextLine() {

	char* ptr = m_str;
	while(*ptr != '\n') {		//sR[h܂Ői
		if(!*ptr) {				//rNULLI[ȂFALSEԂ
			return FALSE;
		}
		ptr++;
	}
	ptr++;
	CSTR str = ptr;
	delete [] m_str;
	m_str = new char[lstrlen(str.m_str) + 1];
	strcpy(m_str, str.m_str);	//m_strɂ͐؂̕񂪓
	return TRUE;				//stOԂ
}

//̌
char* CSTR::Find(char* ToFind, char* sp = 0) {

	if(!sp)
		sp = m_str;
	return strstr(sp, ToFind);
}

//̒u
char* CSTR::Replace(char* ToFind, char* ToReplace, char* sp = 0) {

	//CSTR̃f[^AAuvZ
	int OrgLen = lstrlen(m_str);
	int ToFindLen = lstrlen(ToFind);
	int ToReplaceLen = lstrlen(ToReplace);
	//sp̎w肪CSTRf[^̐擪猟
	if(!sp)
		sp = m_str;
	//|C^[̎擾
	char* Found_at = strstr(sp, ToFind);		//񂪖NULLԂ
	//
	if(Found_at) {
		DWORD dspl = Found_at - m_str;			//Found_atm_stȓΈʒu
		//u̕f[^obt@[iNULLI[tj̊m
		char* buff = new char[OrgLen - ToFindLen + ToReplaceLen + 1];
		*Found_at = NULL;						//NULLI[
		lstrcpy(buff, m_str);					//iToFindj܂łbuffɃRs[
		lstrcat(buff, ToReplace);				//iToFindj̑ɒuRs[
		lstrcat(buff, Found_at + ToFindLen);	//iToFindjȍ~̕Rs[
		buff[OrgLen - ToFindLen + ToReplaceLen] = NULL;	//NULLI[t
		delete [] m_str;						//CSTRf[^im_strj폜
		m_str = new char[OrgLen - ToFindLen + ToReplaceLen + 1];	//Vf[^̈m
		lstrcpy(m_str, buff);					//ũf[^Rs[
		Found_at = m_str + dspl;				//Found_atm_stȓΈʒu
		delete [] buff;							//f[^obt@[j
	}
	return Found_at;	//ułȂꍇNULLAłꍇu̐擪|C^[
}

//̑Su
void CSTR::ReplaceAll(char* ToFind, char* ToReplace, char* sp = 0) {

	char* Next = sp;
	while((Next = Replace(ToFind, ToReplace, Next)))
		Next += lstrlen(ToReplace);
}

#endif
