/////////////////////////////
// ECCSkelton
// CANVASNX`t@C
// Copyright (c) August, 2022
//        By Ysama
/////////////////////////////

class CANVAS
{
public:
	HWND		m_hWnd;			//ΏۂƂȂEBhE
	HDC			m_hDC;			//Rp`uDC
	HBITMAP		m_hCanvas;		//zEBhEłrbg}bv
	HBITMAP		m_hBitmap;		//LoXŎgrbg}bvnh
	HFONT		m_hFont;		//LoXŎgtHg
	int			m_BMPw;			//LoXŎgrbg}bv
	int			m_BMPh;			//LoXŎgrbg}bv
	int			m_Left;			//tXN[̍
	int			m_Top;			//tXN[̏
	int			m_Right;		//tXN[̉E
	int			m_Bottom;		//tXN[̉
	POINT		m_Start;		//`JnW
	POINT		m_End;			//`IW
	HPEN		m_Pen;			//ỹnh
	int			m_PStyle;		//yX^C
	int			m_PWidth;		//y
	HBRUSH		m_Brush;		//uṼnh
	COLORREF	m_Color;		//`F
	bool		m_Focus;		//DragRect֐̃tO

public:
	CANVAS();													//RXgN^[
	CANVAS(HWND);												//RXgN^[{
	~CANVAS();													//fXgN^[
	bool SetCanvas(HWND);										//CANVAS̏
	HWND hWnd() {return m_hWnd;}								//EBhEnhԂ
	HDC  hDC() {return m_hDC;}									//DCnhԂ
	void Clear();												//ʏ
	void Color(int);											//Fw
	void Dot(int, int);											//_`
	void Line(int, int, int, int);								//`
	void Box(int, int, int, int, int);							//``
	void Circle(int, int, int, int);							//~`
	void Ellipsed(int, int, int, int, int);						//ȉ~`
	void Arced(int, int, int, int, int, int, int, int);			//~()`
	void Chorded(int, int, int, int, int, int, int, int, int);	//~(L)`
	bool Paint(int, int, COLORREF);								//wFœhׂ
	HBITMAP GetBMP(int, int, int, int);							//rbg}bv摜捞
	bool PutBMP(int, int, int);									//rbg}bv摜t
	bool PutBMP(HBITMAP, int, int, int);						//Orbg}bv摜t
	bool FitBMP(int, int, int, int, int);						//rbg}bv摜TCYɍĒt
	HBRUSH BrSelection(int);									//uVI
	void OnPaint(HDC, int, int);								//WM_PAINT̏
	void ReDraw(int, int, int, int);							//InvalidateRect
	void DragRect(int, int, bool);								//`̈ɋ``
	void PrintText(int, int, LPCTSTR, int, UINT);				//`iDrawTextގj
	void PrintTextEx(LPCTSTR, LPRECT,
			COLORREF, LPCTSTR, int, UINT,
			int, int, int, DWORD, DWORD, DWORD, DWORD);			//`iFƃtHgwj
	void Font(HFONT);											//tHgI
};

//RXgN^[
CANVAS::CANVAS() {

	m_hWnd		= 0;			//ΏۂƂȂEBhE
	m_hDC		= 0;			//Rp`uDC
	m_hCanvas 	= 0;			//zEBhEłrbg}bv
	m_hBitmap	= 0;			//LoXŎgrbg}bvnh
	m_hFont		= 0;			//LoXŎgtHg
	m_Pen		= 0;			//ỹnh
	m_Brush		= 0;			//uṼnh
}

//RXgN^[{
CANVAS::CANVAS(HWND hWnd) {

	SetCanvas(hWnd);
}

//fXgN^[
CANVAS::~CANVAS() {

	DeleteObject(m_hCanvas);	//XN[rbg}bv
	DeleteObject(m_hBitmap);	//摜rbg}bv
	DeleteDC(m_hDC);			//Rp`cb폜
	if(m_hFont)
		DeleteObject(m_hFont);	//ݎgpĂtHg폜
}

//CANVAS̏
bool CANVAS::SetCanvas(HWND hWnd) {

	if(!hWnd) {
		MessageBoxW(NULL, L"EBhEnhw肳Ă܂",
					L"G[", MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	m_hWnd = hWnd;									//EBhEnhL^
	HDC hDC = GetDC(hWnd);							//ΏۃEBhEDC擾
	m_hDC = CreateCompatibleDC(hDC);				//Rp`cb쐬
	m_Left = m_Top = 0;								//tXN[Ɋg債
	m_Right = GetSystemMetrics(SM_CXFULLSCREEN);	//̃L@XTCY
	m_Bottom = GetSystemMetrics(SM_CYFULLSCREEN);	//L^Ă
	m_hCanvas = CreateCompatibleBitmap(hDC,			//m_hDCł͂Ȃ̂Œ
				m_Right,							//m_hDCɂƃmNƂȂ
				m_Bottom);
	SelectObject(m_hDC, m_hCanvas);					//L@X̎
	m_Pen = (HPEN)GetCurrentObject(hDC, OBJ_PEN);
	m_PStyle = PS_SOLID;							//\bhy
	m_PWidth = 0;									//1sNZ
	m_Brush = (HBRUSH)GetCurrentObject(hDC, OBJ_BRUSH);
	m_Color = RGB(0, 0, 0);							//
	PatBlt(m_hDC, m_Left, m_Top, m_Right, m_Bottom, PATCOPY);	//`
	ReleaseDC(hWnd, hDC);							//hDCJ
	m_Focus = FALSE;								//DragRecttȌ
	m_hFont = 0;									//m_hFont̏

	return TRUE;
}

//ʏ
void CANVAS::Clear() {

	PatBlt(m_hDC, m_Left, m_Top, m_Right, m_Bottom, PATCOPY);
	InvalidateRect(m_hWnd, NULL, TRUE);
}

//F̑Ii0 - 1516FwAȊO͐FIR_CAOオ
void CANVAS::Color(int Col) {	//oAAԁA}[_A΁AVAAFApx 2Px

	static	CHOOSECOLOR clr;
	static	COLORREF cref[16];
	static	COLORREF selected_color;
	switch(Col) {
		case 0:	//
			m_Color = RGB(0, 0, 0);
			break;
		case 1:	//
			m_Color = RGB(0, 0, 128);
			break;
		case 2:	//
			m_Color = RGB(128, 0, 0);
			break;
		case 3:	//}[_
			m_Color = RGB(128, 0, 128);
			break;
		case 4:	//
			m_Color = RGB(0, 128, 0);
			break;
		case 5:	//VA
			m_Color = RGB(0, 128, 128);
			break;
		case 6:	//F
			m_Color = RGB(128, 128, 0);
			break;
		case 7:	//邢DF
			m_Color = RGB(192, 192, 192);
			break;
		case 8:	//ÂDF
			m_Color = RGB(128, 128, 128);
			break;
		case 9:	//邢
			m_Color = RGB(0, 0, 255);
			break;
		case 10:	//邢
			m_Color = RGB(255, 0, 0);
			break;
		case 11:	//邢}[_
			m_Color = RGB(255, 0, 255);
			break;
		case 12:	//邢
			m_Color = RGB(0, 255, 0);
			break;
		case 13:	//邢VA
			m_Color = RGB(0, 255, 255);
			break;
		case 14:	//邢F
			m_Color = RGB(255, 255, 0);
			break;
		case 15:	//
			m_Color = RGB(255, 255, 255);
			break;
		default:	//FIR_CAO
			clr.lStructSize	= sizeof(CHOOSECOLOR);
			clr.hwndOwner		= m_hWnd;
			clr.hInstance		= 0;
			clr.rgbResult		= selected_color;
			clr.lpCustColors	= cref;
			clr.Flags			= CC_RGBINIT;
			clr.lCustData		= 0L;
			clr.lpfnHook		= NULL;
			clr.lpTemplateName	= NULL;
			if( ChooseColor(&clr) == TRUE )
	  			m_Color = clr.rgbResult;
			break;
	}
}

void CANVAS::Dot(int x, int y) {

	SetPixel(m_hDC, x, y, m_Color);
	RECT rec;
	rec.left = x;	rec.right = x + 1;
	rec.top = y;	rec.bottom = y + 1;
	InvalidateRect(m_hWnd, &rec, TRUE);
}

//
void CANVAS::Line(int sx, int sy, int ex, int ey) {

	HPEN pen = CreatePen(m_PStyle, m_PWidth, m_Color);
	m_Pen = (HPEN)SelectObject(m_hDC, pen);
	MoveToEx(m_hDC, sx, sy, NULL);
	LineTo(m_hDC, ex, ey);
	SelectObject(m_hDC, m_Pen);
	DeleteObject(pen);
	ReDraw(sx, sy, ex, ey);
}

//``
void CANVAS::Box(int sx, int sy, int ex, int ey, int type = 0) {

	HPEN pen = CreatePen(m_PStyle, m_PWidth, m_Color);
	m_Pen = (HPEN)SelectObject(m_hDC, pen);
	HBRUSH brush = BrSelection(type);
	Rectangle(m_hDC, sx, sy, ex, ey);
	SelectObject(m_hDC, m_Brush);
	SelectObject(m_hDC, m_Pen);
	DeleteObject(brush);			//NULL_BRUSH̏ꍇł͖
	DeleteObject(pen);
	ReDraw(sx, sy, ex, ey);
}

//~`
void CANVAS::Circle(int x, int y, int rd, int type = 0) {

	HPEN pen = CreatePen(m_PStyle, m_PWidth, m_Color);
	m_Pen = (HPEN)SelectObject(m_hDC, pen);
	HBRUSH brush = BrSelection(type);
	Ellipse(m_hDC, x - rd, y - rd, x + rd, y + rd);
	SelectObject(m_hDC, m_Brush);
	SelectObject(m_hDC, m_Pen);
	DeleteObject(brush);			//NULL_BRUSH̏ꍇł͖
	DeleteObject(pen);
	ReDraw(x - rd, y - rd, x + rd + 1, y + rd + 1);
}

//cς̑ȉ~`
void CANVAS::Ellipsed(int sx, int sy, int ex, int ey, int type = 0) {

	HPEN pen = CreatePen(m_PStyle, m_PWidth, m_Color);
	m_Pen = (HPEN)SelectObject(m_hDC, pen);
	HBRUSH brush = BrSelection(type);
	Ellipse(m_hDC, sx, sy, ex, ey);
	SelectObject(m_hDC, m_Brush);
	SelectObject(m_hDC, m_Pen);
	DeleteObject(brush);			//NULL_BRUSH̏ꍇł͖
	DeleteObject(pen);
	ReDraw(sx, sy, ex, ey);
}

//a~ʂ`
void CANVAS::Arced(int sx, int sy, int ex, int ey, int srx, int sry, int erx, int ery) {

	HPEN pen = CreatePen(m_PStyle, m_PWidth, m_Color);
	m_Pen = (HPEN)SelectObject(m_hDC, pen);
	Arc(m_hDC, sx, sy, ex, ey, srx, sry, erx, ery);
	SelectObject(m_hDC, m_Pen);
	DeleteObject(pen);
	ReDraw(sx, sy, ex, ey);
}

//at~ʂ`
void CANVAS::Chorded(int sx, int sy, int ex, int ey, int srx, int sry, int erx, int ery, int type = 0) {

	HPEN pen = CreatePen(m_PStyle, m_PWidth, m_Color);
	m_Pen = (HPEN)SelectObject(m_hDC, pen);
	HBRUSH brush = BrSelection(type);
	Chord(m_hDC, sx, sy, ex, ey, srx, sry, erx, ery);
	SelectObject(m_hDC, m_Brush);
	SelectObject(m_hDC, m_Pen);
	DeleteObject(brush);			//NULL_BRUSH̏ꍇł͖
	DeleteObject(pen);
	ReDraw(sx, sy, ex, ey);
}

//wFœhׂ
bool CANVAS::Paint(int x, int y, COLORREF col) {		

	bool result;
	COLORREF sfCol;
	HBRUSH hBrush = CreateSolidBrush(col);
	HGDIOBJ hOldBrush = SelectObject(m_hDC, hBrush);
	sfCol = GetPixel(m_hDC, x, y);
	result = ExtFloodFill(m_hDC, x, y, sfCol, FLOODFILLSURFACE);
	SelectObject(m_hDC, hOldBrush);
	DeleteObject(hBrush);
	InvalidateRect(m_hWnd, NULL, TRUE);
	return result;
}

//rbg}bv摜捞
HBITMAP CANVAS::GetBMP(int x, int y, int w, int h) {

	if(m_hBitmap)					//ɓǂ݂܂ꂽrbg}bv
		DeleteObject(m_hBitmap);	//폜

	HDC hDC = GetDC(m_hWnd);						//EBhEDC擾
	HDC memDC = CreateCompatibleDC(hDC);			//Rp`cb쐬
	m_hBitmap = CreateCompatibleBitmap(hDC, w, h);	//Rp`rbg}bv쐬
	SelectObject(memDC, m_hBitmap);					//rbg}bvI
	StretchBlt(memDC, 0, 0, w, h, m_hDC, x, y, w, h, SRCCOPY);
	ReleaseDC(m_hWnd, hDC);							//EBhEDCJ
	DeleteObject(memDC);							//Rp`cb폜
	m_BMPw = w;										//rbg}bvL^
	m_BMPh = h;										//rbg}bvL^
	return m_hBitmap;
}

//rbg}bv摜\tiPj
bool CANVAS::PutBMP(int x, int y, int ro) {

	if(!m_hBitmap)				//ɓǂ݂܂ꂽrbg}bv
		return FALSE;			//UԂ

	DWORD dwRop;
	switch(ro) {
		case 1:		dwRop = SRCAND;		break;	//And
		case 2:		dwRop = SRCPAINT;	break;	//Or
		case 3:		dwRop = SRCINVERT;	break;	//Xor
		default:	dwRop = SRCCOPY;	break;	//Pset
	}

	HDC hDC = GetDC(m_hWnd);						//EBhEDC擾
	HDC memDC = CreateCompatibleDC(hDC);			//Rp`cb쐬
	SelectObject(memDC, m_hBitmap);					//rbg}bvI
	bool success = BitBlt(m_hDC, x, y, m_BMPw, m_BMPh, memDC, 0, 0, dwRop);
	ReDraw(x, y, x + m_BMPw, y + m_BMPh);			//`
	ReleaseDC(m_hWnd, hDC);							//EBhEDCJ
	DeleteObject(memDC);							//Rp`cb폜
	return success;
}

//rbg}bv摜\tiQj
bool CANVAS::PutBMP(HBITMAP bmp, int x, int y, int ro) {

	if(!bmp)					//Lȃrbg}bv
		return FALSE;			//UԂ

	DWORD dwRop;
	switch(ro) {
		case 1:		dwRop = SRCAND;		break;	//And
		case 2:		dwRop = SRCPAINT;	break;	//Or
		case 3:		dwRop = SRCINVERT;	break;	//Xor
		default:	dwRop = SRCCOPY;	break;	//Pset
	}

	HDC hDC = GetDC(m_hWnd);						//EBhEDC擾
	HDC memDC = CreateCompatibleDC(hDC);			//Rp`cb쐬
	SelectObject(memDC, bmp);						//rbg}bvI
	BITMAP bm;										//BITMAP\
	GetObject(bmp, sizeof(BITMAP), &bm);			//TCYszɎo
	bool success = BitBlt(m_hDC, x, y, bm.bmWidth, bm.bmHeight, memDC, 0, 0, dwRop);
	ReDraw(x, y, x + bm.bmWidth, y + bm.bmHeight);	//`
	ReleaseDC(m_hWnd, hDC);							//EBhEDCJ
	DeleteObject(memDC);							//Rp`cb폜
	return success;
}

//rbg}bv摜\tiRj
bool CANVAS::FitBMP(int x, int y, int w, int h, int ro) {

	if(!m_hBitmap)				//ɓǂ݂܂ꂽrbg}bv
		return FALSE;			//UԂ

	DWORD dwRop;
	switch(ro) {
		case 1:		dwRop = SRCAND;		break;	//And
		case 2:		dwRop = SRCPAINT;	break;	//Or
		case 3:		dwRop = SRCINVERT;	break;	//Xor
		default:	dwRop = SRCCOPY;	break;	//Pset
	}

	HDC hDC = GetDC(m_hWnd);						//EBhEDC擾
	HDC memDC = CreateCompatibleDC(hDC);			//Rp`cb쐬
	SelectObject(memDC, m_hBitmap);					//rbg}bvI
	bool success = StretchBlt(m_hDC, x, y, w, h,
							memDC, 0, 0, m_BMPw, m_BMPh, dwRop);
	ReDraw(x, y, x + w, y + h);						//`
	ReleaseDC(m_hWnd, hDC);							//EBhEDCJ
	DeleteObject(memDC);							//Rp`cb폜
	return success;
}

//uVIi0-A1-\bhA2`6-قȂnb`uVj
HBRUSH CANVAS::BrSelection(int type) {

	HBRUSH brush;
	switch(type) {
		case 1:	//Solid Brush
			brush = CreateSolidBrush(m_Color);
			break;
		case 2:	//A 45-degree upward, left-to-right hatch
			brush = CreateHatchBrush(HS_BDIAGONAL, m_Color);
			break;
		case 3:	//Horizontal and vertical cross-hatch
			brush = CreateHatchBrush(HS_CROSS, m_Color);
			break;
		case 4:	//45-degree crosshatch
			brush = CreateHatchBrush(HS_DIAGCROSS, m_Color);
			break;
		case 5:	//A 45-degree downward, left-to-right hatch
			brush = CreateHatchBrush(HS_FDIAGONAL, m_Color);
			break;
		case 6:	//Horizontal hatch
			brush = CreateHatchBrush(HS_HORIZONTAL, m_Color);
			break;
		case 7:	//Vertical hatch
			brush = CreateHatchBrush(HS_VERTICAL, m_Color);
			break;
		case 0:	//0͏LȊO̒l̏ꍇ͓iNULLjuV
		default:
			brush = (HBRUSH)GetStockObject(NULL_BRUSH);
			break;
	}
	m_Brush = (HBRUSH)SelectObject(m_hDC, brush);
	return brush;
}

//m_hWnd̃nhWM_PAINTbZ[W̏ɂ̊֐u
void CANVAS::OnPaint(HDC hDC, int x = 0, int y = 0) {

	//EBhEzEBhEiBitmapjŕ`
	BitBlt(hDC, m_Left, m_Top, m_Right, m_Bottom, m_hDC, x, y, SRCCOPY);
}

//zEBhEɕ`悵`i(sx, sy)-(ex, ey)jĕ`悳
void CANVAS::ReDraw(int sx, int sy, int ex, int ey) {

	RECT rec;
	rec.left = sx > ex ? ex : sx;
	rec.right = sx > ex ? sx + 1 : ex + 1;
	rec.top = sy > ey ? ey : sy;
	rec.bottom = sy > ey ? sy + 1 : ey + 1;
	InvalidateRect(m_hWnd, &rec, TRUE);
}


//`̈ɋ``
void CANVAS::DragRect(int x, int y, bool flag) {

	static RECT rect;
	HDC hDC = GetDC(m_hWnd);
	if(flag) {		//`
		if(m_Focus) {
			DrawFocusRect(hDC, &rect);
			rect.left = m_Start.x <= x ? m_Start.x : x;
			rect.right = m_Start.x > x ? m_Start.x : x;
			rect.top = m_Start.y <= y ? m_Start.y : y;
			rect.bottom = m_Start.y > y ? m_Start.y : y;
			DrawFocusRect(hDC, &rect);
		}
		else {
			m_Start.x = rect.left = rect.right = x;
			m_Start.y = rect.top = rect.bottom = y;
			DrawFocusRect(hDC, &rect);
			m_Focus = TRUE;
		}
	}
	else {
		DrawFocusRect(hDC, &rect);
		m_Focus = FALSE;
	}
	ReleaseDC(m_hWnd, hDC);
}

void CANVAS::PrintText(int x, int y, LPCTSTR str, int w = 0,
					UINT fmt = DT_LEFT | DT_NOCLIP) {

	RECT rec;
	GetClientRect(m_hWnd, &rec);
	rec.left = x;
	rec.top = y;
	if(w)	rec.right = x + w;
	rec.bottom = y + DrawText(m_hDC, str, -1, &rec, DT_CALCRECT);
	DrawText(m_hDC, str, -1, &rec, fmt);
	InvalidateRect(m_hWnd, &rec, TRUE);
}

void CANVAS::PrintTextEx(LPCTSTR str, LPRECT lprec, COLORREF rgb, LPCTSTR FontName, int FontSize,
				UINT fmt = DT_LEFT | DT_NOCLIP,
				int nEscapement = 0, int nOrientation = 0, int nWeight = FW_NORMAL,
				DWORD fdwItalic = FALSE, DWORD fdwUnderline = FALSE,
				DWORD fdwStrikeOut = FALSE, DWORD fdwCharSet = DEFAULT_CHARSET) {
	if(m_hFont)
		DeleteObject(m_hFont);
	m_hFont = CreateFont(FontSize, 0,
			nEscapement, nOrientation, nWeight,
			fdwItalic, fdwUnderline, fdwStrikeOut,
			fdwCharSet,
			OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
			DEFAULT_QUALITY,
			DEFAULT_PITCH,
			FontName);
	SelectObject(m_hDC, m_hFont);
	SetTextColor(m_hDC, rgb);
	DrawText(m_hDC, str, -1, lprec, fmt);
	InvalidateRect(m_hWnd, lprec, TRUE);
}

void CANVAS::Font(HFONT newfont) {

	if(m_hFont)
		DeleteObject(m_hFont);	//ݎgpĂtHg폜
	SelectObject(m_hDC, (m_hFont = newfont));
}
