////////////////////////////////
// ECCSkelton
// CCLIPBOARDNX`t@C
// Copyright (c) August, 2022
//        By Ysama
////////////////////////////////

class CCLIPBOARD {
private:
	//ϐ
	HWND m_hWnd;		//Nbv{[hgpEBhEnh
	WCHAR* m_Text;		//eLXgp
	HBITMAP m_hBitmap;	//rbg}bvp
public:
	//֐
	CCLIPBOARD();		//RXgN^[
	CCLIPBOARD(HWND);	//RXgN^[
	~CCLIPBOARD();		//fXgN^[
	void SetWnd(HWND);
	WCHAR* GetText();
	bool SetText(WCHAR*);
	HBITMAP GetBitmap();
	bool SetBitmap(HBITMAP);
};

CCLIPBOARD::CCLIPBOARD() {
	m_hWnd = NULL;
	m_Text = NULL;
	m_hBitmap = NULL;
}

CCLIPBOARD::CCLIPBOARD(HWND hWnd) {
	m_hWnd = hWnd;
	m_Text = NULL;
	m_hBitmap = NULL;
}

CCLIPBOARD::~CCLIPBOARD() {
	if(!m_Text)
		delete [] m_Text;
}

void CCLIPBOARD::SetWnd(HWND hWnd){
	m_hWnd = hWnd;
}

WCHAR* CCLIPBOARD::GetText() {

	//Nbv{[hɃeLXgf[^邩ۂ
	if(!IsClipboardFormatAvailable(CF_TEXT))
		return NULL;
	//Nbv{[hJ
	if(!OpenClipboard(m_hWnd))
		return NULL;
	//Nbv{[hf[^|C^[擾
	HGLOBAL hGlobal = (HGLOBAL)GetClipboardData(CF_TEXT);
	if(!hGlobal) {
		CloseClipboard();
		return NULL;
	}
	//[bN
	WCHAR *str = (WCHAR*)GlobalLock(hGlobal);
	//m_TextɕKvȒ̃[iɎgĂΉĂjm
	if(m_Text)
		delete [] m_Text;
    m_Text = new WCHAR[lstrlenW(str) + 1];
	lstrcpyW(m_Text, str);
    GlobalUnlock(hGlobal);
    CloseClipboard();
	return m_Text;
}

bool CCLIPBOARD::SetText(WCHAR* str) {

	//eLXg̒+1̃O[o[m
	HGLOBAL hGlobal = GlobalAlloc(GHND, (lstrlenW(str) + 1) * sizeof(WCHAR));
	//eLXgf[^̃O[o[փRs[
	WCHAR* pt = (WCHAR*)GlobalLock(hGlobal);
	lstrcpyW(pt, str);
	GlobalUnlock(hGlobal);
	//O[o[Nv{[hɓn
	OpenClipboard(m_hWnd);
	EmptyClipboard();
	SetClipboardData(CF_TEXT, hGlobal);
	return CloseClipboard();
}

HBITMAP CCLIPBOARD::GetBitmap() {

	//Nbv{[hɃeLXgf[^邩ۂ
	if(!IsClipboardFormatAvailable(CF_BITMAP))
		return NULL;
	//Nbv{[hJ
	if(!OpenClipboard(m_hWnd))
		return NULL;
	//Nbv{[hf[^|C^[擾
	m_hBitmap = (HBITMAP)GetClipboardData(CF_BITMAP);
	CloseClipboard();
	return m_hBitmap;
}

bool CCLIPBOARD::SetBitmap(HBITMAP hBitmap) {

	//rbg}bvnhNv{[hɓn
	OpenClipboard(m_hWnd);
	EmptyClipboard();
	SetClipboardData(CF_BITMAP, hBitmap);
	return CloseClipboard();
}
