////////////////////////////////////////
// ECCSkelton
// _CAO{NXCDLG`t@C
// Copyright (c) August, 2022
//        By Ysama
////////////////////////////////////////

class CDLG
{
protected:
	HANDLE	m_hMutex = 0;
	WCHAR	m_UniqName[MAX_PATH] = {L"\0"};
	bool	m_Mode = TRUE;						//TRUE - Modal dialog, FALSE - Modeless dialog
public:		//o[ϐ
	HWND		m_hWnd = 0;						//EBhEnh
	HWND		m_hParent = 0;					//eEBhEnh
	HINSTANCE	m_hInstance = 0;				//CX^Xϐ
	MSG			m_Msg;							//EBhEbZ[W
	HACCEL		m_Accel = 0;					//Accelerator̗L

public:	//o[֐
	CDLG();										//ftH[gRXgN^[
	CDLG(WCHAR*);								//UniqueNametRXgN^[
	~CDLG();									//fXgN^[
	HWND GetHandle() {return m_hWnd;}			//_CAOnhԂ
	void SetHandle(HWND h) {m_hWnd = h;}		//_CAÕnhݒ
	HINSTANCE GetInstance()
					{return m_hInstance;}		//_CAÕCX^XԂ
	void SetInstance(HINSTANCE hInst)
					{m_hInstance = hInst;}		//_CAÕCX^Xݒ
	int DoModal(HWND, LPCWSTR, HINSTANCE);		//[__CAOJ
	bool EndModal(int);							//[__CAO߂
	bool Create(HWND, HINSTANCE, LPCWSTR);		//[hX_CAOJ
	bool Destroy();								//[hX_CAO߂
	static BOOL CALLBACK DummyProc(HWND, UINT, WPARAM, LPARAM);	//_~[̃R[obN֐
	virtual BOOL CALLBACK DlgProc(HWND, UINT, WPARAM, LPARAM);	//{̃R[obN֐
	virtual	bool OnInit(WPARAM, LPARAM);			//WM_INITDIALOG
	virtual bool OnActivate(WPARAM, LPARAM);		//WM_ACTIVATE
	virtual bool OnEnable(WPARAM, LPARAM);			//WM_ENABLE
	virtual bool OnTimer(WPARAM, LPARAM);			//WM_TIMER
	virtual bool OnSetFocus(WPARAM, LPARAM);		//WM_SETFOCUS
	virtual	bool OnNotify(WPARAM, LPARAM);			//WM_NOTIFY
	virtual	bool OnCommand(WPARAM, LPARAM);			//WM_COMMAND
	virtual bool OnKeyDown(WPARAM, LPARAM);			//WM_KEYDOWN
	virtual bool OnKeyUp(WPARAM, LPARAM);			//WM_KEYUP
	virtual bool OnChar(WPARAM, LPARAM);			//WM_CHAR
	virtual bool OnLButtonDblclk(WPARAM, LPARAM);	//WM_LBUTTONDBLCLK
	virtual bool OnLButtonDown(WPARAM, LPARAM);		//WM_LBUTTONDOWN
	virtual bool OnLButtonUp(WPARAM, LPARAM);		//WM_LBUTTONUP
	virtual bool OnMButtonDblclk(WPARAM, LPARAM);	//WM_MBUTTONDBLCLK
	virtual bool OnMButtonDown(WPARAM, LPARAM);		//WM_MBUTTONDOWN
	virtual bool OnMButtonUp(WPARAM, LPARAM);		//WM_MBUTTONUP
	virtual bool OnMouseMove(WPARAM, LPARAM);		//WM_MOUSEMOVE
	virtual bool OnRButtonDblclk(WPARAM, LPARAM);	//WM_RBUTTONDBLCLK
	virtual bool OnRButtonDown(WPARAM, LPARAM);		//WM_RBUTTONDOWN
	virtual bool OnRButtonUp(WPARAM, LPARAM);		//WM_RBUTTONUP
	virtual bool OnPaint(WPARAM, LPARAM);			//WM_PAINT
	virtual bool OnEraseBkgnd(WPARAM, LPARAM);		//WM_ERASEBKGND
	virtual bool OnMove(WPARAM, LPARAM);			//WM_MOVE
	virtual bool OnSize(WPARAM, LPARAM);			//WM_SIZE
	virtual bool OnHScroll(WPARAM, LPARAM);			//WM_HSCROLL
	virtual bool OnVScroll(WPARAM, LPARAM);			//WM_VSCROLL
	virtual bool OnDropFiles(WPARAM, LPARAM);		//WM_DROPFILES
	virtual bool OnGetMaxInfo(WPARAM, LPARAM);		//WM_GETMAXINFO
	virtual	bool OnClose(WPARAM, LPARAM);			//WM_CLOSE
	virtual	bool OnDestroy(WPARAM, LPARAM);			//WM_DESTROY
	bool InclAccel(LPWSTR);						//Modeless DialogpANZ[^[[h֐
	UINT Loop();								//Modeless DialogpbZ[W[v
	bool IsOnlyOne();							//QdNh~֐
	LRESULT SendMsg(UINT, WPARAM, LPARAM);		//EBhEւ̃bZ[W
	LRESULT SendItemMsg(int, UINT,
						WPARAM, LPARAM);		//EBhERg[ւ̃bZ[W
};

//ftH[gRXgN^[
CDLG::CDLG() {
}

//UniqueNametRXgN^[
CDLG::CDLG(WCHAR* UName) {

	wsprintfW(m_UniqName, L"%d", UName);
}

//fXgN^[
CDLG::~CDLG() {

	if(m_hMutex)
		CloseHandle(m_hMutex);
}

//[__CAOJ
int CDLG::DoModal(HWND hParent, LPCWSTR DlgName, HINSTANCE hInstance) {

	if(m_hWnd)		//gp̏ꍇÂ܂ܖ߂
		return FALSE;
	//eEBhẼnhL^
	m_hParent = hParent;
	//eEBhẼCX^X擾ċL^
	m_hInstance = hInstance;
	//_CAOJ
	int ret = DialogBoxParamW(m_hInstance, DlgName, hParent, DummyProc, (LPARAM)this);
	if(ret == -1)
		return FALSE;
	m_Mode = TRUE;	//Modal dialog ƂĊJ
	return ret;
}

//[__CAO߂
bool CDLG::EndModal(int i) {

	EndDialog(m_hWnd, i);
	m_hWnd = 0;		//gpԂɂ
	return TRUE;
}

//[hX_CAOJ
bool CDLG::Create(HWND hParent, HINSTANCE hInstance, LPCWSTR DlgName) {

	if(m_hWnd)		//gp̏ꍇÂ܂ܖ߂
		return FALSE;
	//eEBhẼnhL^
	m_hParent = hParent;
	//CX^X擾ċL^
	m_hInstance = hInstance;
	//_CAOJ
	m_hWnd = CreateDialogParamW(m_hInstance, DlgName, m_hParent, DummyProc, (LPARAM)this);
	if(!m_hWnd) {	//_CAO쐬s
		MessageBoxW(0, L"_CAO܂łB", L"G[",
				MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	//_CAO̕\ƍĕ`
	ShowWindow(m_hWnd, SW_SHOWNORMAL);
	UpdateWindow(m_hWnd);
	m_Mode = FALSE;	//Modeless dialog ƂĊJ
	return TRUE;
}

//[hX_CAO߂
bool CDLG::Destroy() {

	DestroyWindow(m_hWnd);
	m_hWnd = 0;		//gpԂɂ
	m_Mode = TRUE;	//Modal dialog
	return TRUE;
}

//_~[R[obN֐
BOOL CALLBACK CDLG::DummyProc(HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam) {

	if(Message == WM_INITDIALOG) {
		//EBhEnh擾A
		((CDLG*)lParam)->m_hWnd = hWnd;
		//EBhEvpeBCDLGNXCX^Xւ̃|C^[ށidvj
		SetPropW(hWnd, L"CPP_CLASS", (HANDLE)lParam);
	}
	//Inito[֐񂾂̃NX̃CX^Xւ̃|C^[ǂ
	CDLG* pWnd = (CDLG*)GetPropW(hWnd, L"CPP_CLASS");
	//ꂪǂݍ߂
	if(pWnd) {
		//{̃R[obN֐iWndProcjĂ
		BOOL lResult = pWnd->DlgProc(hWnd, Message, wParam, lParam);
		//EBhEj󎞂ɃEBhEvpeBp
		if(Message == WM_DESTROY)
			RemovePropW(hWnd, L"CPP_CLASS");
		return lResult;
	}
	else
		//EBhEY̏ɔC
		FALSE;
}

//{̃R[obN֐iz֐j
BOOL CALLBACK CDLG::DlgProc(HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam) {

	bool Done = FALSE;
	switch(Message) {
		case WM_INITDIALOG:
			//ŏDummyProcĂ΂鎞m_hWndL^
			m_hWnd = hWnd;
			Done = OnInit(wParam, lParam);
			break;
		case WM_NOTIFY:
			Done = OnNotify(wParam, lParam);
			break;
		case WM_COMMAND:
			Done = OnCommand(wParam, lParam);
			break;
		case WM_ACTIVATE:
			Done = OnActivate(wParam, lParam);
			break;
		case WM_ENABLE:
			Done = OnEnable(wParam, lParam);
			break;
		case WM_TIMER:
			Done = OnTimer(wParam, lParam);
			break;
		case WM_SETFOCUS:
			Done = OnSetFocus(wParam, lParam);
			break;
		case WM_KEYDOWN:
			Done = OnKeyDown(wParam, lParam);
			break;
		case WM_KEYUP:
			Done = OnKeyUp(wParam, lParam);
			break;
		case WM_CHAR:
			Done = OnChar(wParam, lParam);
			break;
		case WM_LBUTTONDBLCLK:
			Done = OnLButtonDblclk(wParam, lParam);
			break;
		case WM_LBUTTONDOWN:
			Done = OnLButtonDown(wParam, lParam);
			break;
		case WM_LBUTTONUP:
			Done = OnLButtonUp(wParam, lParam);
			break;
		case WM_MBUTTONDBLCLK:
			Done = OnMButtonDblclk(wParam, lParam);
			break;
		case WM_MBUTTONDOWN:
			Done = OnMButtonDown(wParam, lParam);
			break;
		case WM_MBUTTONUP:
			Done = OnMButtonUp(wParam, lParam);
			break;
		case WM_MOUSEMOVE:
			Done = OnMouseMove(wParam, lParam);
			break;
		case WM_RBUTTONDBLCLK:
			Done = OnRButtonDblclk(wParam, lParam);
			break;
		case WM_RBUTTONDOWN:
			Done = OnRButtonDown(wParam, lParam);
			break;
		case WM_RBUTTONUP:
			Done = OnRButtonUp(wParam, lParam);
			break;
		case WM_PAINT:
			Done = OnPaint(wParam, lParam);
			break;
		case WM_ERASEBKGND:
			Done = OnEraseBkgnd(wParam, lParam);
			break;
		case WM_MOVE:
			Done = OnMove(wParam, lParam);
			break;
		case WM_SIZE:
			Done = OnSize(wParam, lParam);
			break;
		case WM_HSCROLL:
			Done = OnHScroll(wParam, lParam);
			break;
		case WM_VSCROLL:
			Done = OnVScroll(wParam, lParam);
			break;
		case WM_DROPFILES:
			Done = OnDropFiles(wParam, lParam);
			break;
		case WM_GETMINMAXINFO:
			Done = OnGetMaxInfo(wParam, lParam);
			break;
		case WM_CLOSE:
			Done = OnClose(wParam, lParam);
			if(Done) {		//IȂ
				if(m_Mode)	//Modal _CAO
					EndModal(Done);
				else		//Modeless _CAO
					Destroy();
			}
			break;
		case WM_DESTROY:
			Done = OnDestroy(wParam, lParam);
			break;
	}
	return Done;
}

//WM_INITDIALOGiz֐j
bool CDLG::OnInit(WPARAM wParam, LPARAM lParam) {
	return FALSE;
}

//WM_ACTIVATEiz֐j
bool CDLG::OnActivate(WPARAM wParam, LPARAM lParam) {
	return FALSE;
}

//WM_ENABLEiz֐j
bool CDLG::OnEnable(WPARAM wParam, LPARAM lParam) {
	return FALSE;
}

//WM_TIMERiz֐j
bool CDLG::OnTimer(WPARAM wParam, LPARAM lParam) {
	return FALSE;
}

//WM_SETFOCUSiz֐j
bool CDLG::OnSetFocus(WPARAM wParam, LPARAM lParam) {
	return FALSE;
}

//WM_NOTIFYiz֐j
bool CDLG::OnNotify(WPARAM wParam, LPARAM lParam) {
	return FALSE;
}

//WM_COMMANDiz֐j
bool CDLG::OnCommand(WPARAM wParam, LPARAM lParam) {
	return FALSE;
}

//WM_KEYDOWNiz֐j
bool CDLG::OnKeyDown(WPARAM wParam, LPARAM lParam) {
	return FALSE;
}

//WM_KEYUPiz֐j
bool CDLG::OnKeyUp(WPARAM wParam, LPARAM lParam) {
	return FALSE;
}

//WM_CHARiz֐j
bool CDLG::OnChar(WPARAM wParam, LPARAM lParam) {
	return FALSE;
}

//WM_LBUTTONDBLCLKiz֐j
bool CDLG::OnLButtonDblclk(WPARAM wParam, LPARAM lParam) {
	return FALSE;
}

//WM_LBUTTONDOWNiz֐j
bool CDLG::OnLButtonDown(WPARAM wParam, LPARAM lParam) {
	return FALSE;
}

//WM_LButtonUpiz֐j
bool CDLG::OnLButtonUp(WPARAM wParam, LPARAM lParam) {
	return FALSE;
}

//WM_MBUTTONDBLCLKiz֐j
bool CDLG::OnMButtonDblclk(WPARAM wParam, LPARAM lParam) {
	return FALSE;
}

//WM_MBUTTONDOWNiz֐j
bool CDLG::OnMButtonDown(WPARAM wParam, LPARAM lParam) {
	return FALSE;
}

//WM_MButtonUpiz֐j
bool CDLG::OnMButtonUp(WPARAM wParam, LPARAM lParam) {
	return FALSE;
}

//WM_MOUSEMOVEiz֐j
bool CDLG::OnMouseMove(WPARAM wParam, LPARAM lParam) {
	return FALSE;
}

//WM_RBUTTONDBLCLKiz֐j
bool CDLG::OnRButtonDblclk(WPARAM wParam, LPARAM lParam) {
	return FALSE;
}

//WM_RBUTTONDOWNiz֐j
bool CDLG::OnRButtonDown(WPARAM wParam, LPARAM lParam) {
	return FALSE;
}

//WM_RButtonUpiz֐j
bool CDLG::OnRButtonUp(WPARAM wParam, LPARAM lParam) {
	return FALSE;
}

//WM_PAINTiz֐j
bool CDLG::OnPaint(WPARAM wParam, LPARAM lParam) {
	return FALSE;
}

//WM_ERASEBKGNDiz֐j
bool CDLG::OnEraseBkgnd(WPARAM wParam, LPARAM lParam) {
	return FALSE;
}

//WM_MOVEiz֐j
bool CDLG::OnMove(WPARAM wParam, LPARAM lParam) {
	return FALSE;
}

//WM_SIZEiz֐j
bool CDLG::OnSize(WPARAM wParam, LPARAM lParam) {
	return FALSE;
}

//WM_HSCROLLiz֐j
bool CDLG::OnHScroll(WPARAM wParam, LPARAM lParam) {
	return FALSE;
}

//WM_VSCROLLiz֐j
bool CDLG::OnVScroll(WPARAM wParam, LPARAM lParam) {
	return FALSE;
}

//WM_DROPFILESiz֐j
bool CDLG::OnDropFiles(WPARAM wParam, LPARAM lParam) {
	return FALSE;
}

//WM_GETMINMAXINFOiz֐j
bool CDLG::OnGetMaxInfo(WPARAM wParam, LPARAM lParam) {
	return FALSE;
}

//WM_CLOSE(z֐j
bool CDLG::OnClose(WPARAM wParam, LPARAM lParam) {

	return FALSE;
}

//WM_DESTROY(z֐j
bool CDLG::OnDestroy(WPARAM wParam, LPARAM lParam) {

	return FALSE;
}

//ANZ[^[
bool CDLG::InclAccel(LPWSTR Name) {

	if(!(m_Accel = LoadAcceleratorsW(m_hInstance, Name))) {
		MessageBoxW(NULL, L"ANZ[^[̓ǍɎs܂",
					L"G[", MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	return TRUE;
}

//bZ[W[v
UINT CDLG::Loop() {

	while(GetMessageW(&m_Msg, NULL, 0, 0)) {
		//ANZ[^[
		if(!TranslateAcceleratorW(m_hWnd, m_Accel, &m_Msg) &&
		//{[hX_CAO
		!IsDialogMessageW(m_hWnd, &m_Msg)) {
			TranslateMessage(&m_Msg);
			DispatchMessageW(&m_Msg);
		}
	}
	return m_Msg.wParam;
}

bool CDLG::IsOnlyOne() {

	m_hMutex = CreateMutexW(NULL, TRUE, m_UniqName);
	if (!m_hMutex)
		return FALSE;
	// GetLastError()AERROR_ALREADY_EXISTSȂA
	// łɃAvP[VNĂ
	if (GetLastError() == ERROR_ALREADY_EXISTS) {
    //dN̏
    	return FALSE;
	}
	return TRUE;
}

//Rg[ւ̂ւ̃bZ[W
LRESULT CDLG::SendMsg(UINT Msg, WPARAM wParam, LPARAM lParam) {

	return SendMessageW(m_hWnd, Msg, wParam, lParam);
}

//EBhERg[ւ̂ւ̃bZ[W
LRESULT CDLG::SendItemMsg(int ID, UINT Msg, WPARAM wParam, LPARAM lParam) {

	return SendDlgItemMessageW(m_hWnd, ID, Msg, wParam, lParam);
}
