/////////////////////////////
// ECCSkelton
// CREDITNX`t@C
// Copyright (c) August, 2022
//        By Ysama
/////////////////////////////
#include <richedit.h>
#define	MAXBUFF	1024 * 1024
#define	CMASK	CFM_BOLD | CFM_CHARSET | CFM_COLOR | CFM_FACE | CFM_ITALIC | CFM_SIZE | CFM_STRIKEOUT | CFM_UNDERLINE
#define	NOMORE	-1
#define	PMARGIN	1440	//1C`twip
#define	INDENT	567		//1Z`twip

class CREDIT : public CCTRL
{
public:		//o[ϐ
	HINSTANCE m_hRtLib;				//b`GfBbgRg[̃CX^X
	HDC m_Dhdc;						//fBXv[̃foCXReLXg
	int m_FontSize;					//b`GfBbgRg[Ŝ̃tHgTCY
	WCHAR m_FontName[32];			//b`GfBbgRg[Ŝ̃tHg
	CHARFORMATW m_cfm;				//LN^[tH[}bg\
	PARAFORMAT m_pf;				//pOttH[}bg\
	HWND m_hFRDlg;					//u_CAÕnh
	UINT m_frMsg;					//u_CAÕbZ[W
	WCHAR m_FindWhat[MAX_PATH];		//obt@[
	WCHAR m_ReplaceWith[MAX_PATH];	//uobt@[
	HDC m_Phdc;						//v^[̃foCXReLXg
	int m_nPrnW;					//͈͂̕I
	int m_nLog;						//͈̘͂_IsNZ
	int m_RichWidth;				//b`GfBbgRg[̕(twip)

public:		//o[֐
	CREDIT();						//RXgN^[
	~CREDIT();						//fXgN^[
	bool Create(LPWSTR, DWORD,
			DWORD, HWND, int, 
			int, int, int, int);	//b`GfBbg̍쐬
	long GetMax();					//b`GfBbg̍ő啶擾
	void SetMax(long);				//b`GfBbg̍ő啶ݒ
	void FilterMsg(DWORD);			//b`GfBbgWM_NOTIFYbZ[Wݒ
	static DWORD CALLBACK SaveRichEditProc(DWORD, LPBYTE, LONG, LONG*);
	bool SaveFile(LPWSTR);			//t@CZ[u֐
	static DWORD CALLBACK ReadRichEditProc(DWORD, LPBYTE, LONG, LONG*);
	bool LoadFile(LPWSTR);			//t@C[h֐
	long GetSize();					//t@CTCY߂
	long GetLines();				//b`GfBbg̍sԂ
	LPPOINT GetLinePos(int);		//ws̍ŏAŌ̌̈ʒuԂ
	LPPOINT GetPos();				//݂̍sÄʒuԂ
	LPLOGFONT GetFont();			//݂̃tHg擾
	bool SelFont();					//tHg_CAOɂtHgI
	void SetFont();					//tHgݒ(tHg_CAOwj
	void SetFont(int, WCHAR*);		//tHgݒ(ڎwj
	void InitCol(int, int);			//F̏(j
	COLORREF GetCol(int, int);		//F擾
	void SetCol(COLORREF, bool);	//Fݒ
	void SetTokenColor(WCHAR*,		//Token̐Ft
			COLORREF, int, int, UINT);
	void Jump(int, bool);			//wsֈړ
	void Align(WCHAR);				//񂹐ݒ
	void Indent(int);				//Cfgݒ
	void Tab(int);					//^u̐ݒ
	bool SetPrinter();				//v^[̐ݒ
	int AddPageNo(int);				//y[Wt^֐
	bool Print(WCHAR*);				//֐
	void SetWYSWYG(bool);			//ʂƈ킹
	FINDREPLACEW* SetFRDlg(WCHAR);	//Eu_CAȌ
	bool WasFound(FINDTEXTW*, UINT);//Eu֐
	void FindReplace(LPARAM);		//Eu_CAO
};

//RXgN^[
CREDIT::CREDIT() {

	//b`GfBbgRg[̃nh̏
	m_hWnd = 0;
	//RRg[̏
	InitCommonControls();
	//b`GfBbgRg[DLL̓Ǎ
	m_hRtLib = LoadLibraryW(L"RICHED20.DLL");
	//Eu[bZ[W̓o^
	m_frMsg = RegisterWindowMessageW(FINDMSGSTRINGW);
	//tHgTCY̏
	m_FontSize = 10;
	//tHg̏
	lstrcpyW(m_FontName, L"lr ");
	//v^[֌Wϐ̏
	m_Phdc = 0;
	m_nPrnW = m_nLog = m_RichWidth = 0;
}

//fXgN^[
CREDIT::~CREDIT() {

	ReleaseDC(m_hWnd, m_Dhdc);		//̃foCXReLXg̉
	if(!m_Phdc) DeleteDC(m_Phdc);	//̃v^[foCXReLXg΍폜
	if(!FreeLibrary(m_hRtLib))
		MessageBoxW(NULL, L"b`GfBbgRg[̊JɎs܂",
					L"G[", MB_OK | MB_ICONERROR);
}

//------------------------------------
// b`GfBbgRg[̍쐬
//------------------------------------
bool CREDIT::Create(LPWSTR WindowTitle, DWORD Style, DWORD ExStyle,
						HWND hParent, int ID,
						int x = CW_USEDEFAULT, int y = CW_USEDEFAULT,
						int w = CW_USEDEFAULT, int h = CW_USEDEFAULT) {

	m_hInstance = (HINSTANCE)GetWindowLong(hParent, GWL_HINSTANCE);
	m_hWnd =	CreateWindowExW(ExStyle, L"RICHEDIT20W", WindowTitle,
					Style, x, y, w, h, m_hParent = hParent, (HMENU)ID,
					m_hInstance, NULL);
	if(m_hWnd == NULL) return FALSE;
	ShowWindow(m_hWnd, SW_SHOWNORMAL);
	UpdateWindow(m_hWnd);
	m_Dhdc = GetDC(m_hWnd);		//̃foCXReLXgۑ

	//GfBbgRg[̍ő啶
	SetMax(MAXBUFF);
	//tHg̏
	SetFont(m_FontSize, m_FontName);
	//񂹂̏
	Align('L');

	return TRUE; 
}

//------------------------------------
// b`GfBbg̍ő啶擾
//------------------------------------
long CREDIT::GetMax() {

	return SendMessageW(m_hWnd, EM_GETLIMITTEXT, 0, 0);
}
//------------------------------------
// b`GfBbg̍ő啶ݒ
//------------------------------------
void CREDIT::SetMax(long max) {

	SendMessageW(m_hWnd, EM_SETLIMITTEXT, max, 0);
}

//-------------------------------------------
// b`GfBbgWM_NOTIFYbZ[Wݒ
//-------------------------------------------
void CREDIT::FilterMsg(DWORD msg) {

	DWORD dwEvent = SendMessageW(m_hWnd, EM_GETEVENTMASK, 0, 0);
	dwEvent |= msg;
	SendMessageW(m_hWnd, EM_SETEVENTMASK, 0, (LPARAM)dwEvent);
}

//---------------------------------------------------
// b`GfBbgRg[pR[obN֐
//---------------------------------------------------
DWORD CALLBACK CREDIT::SaveRichEditProc(DWORD dwCookie, LPBYTE pbbuf, LONG cb, LONG* pcb) {

	if (WriteFile((HANDLE)dwCookie, pbbuf, cb, (LPDWORD)pcb, NULL))
		return FALSE;
	else
		return TRUE;
}

//--------------------------------------------------------------------------
// b`GfBbgRg[peLXgAb`GfBbgt@C֐
// t@C pszFileName ̃t@C RichEdit Control֏܂
//--------------------------------------------------------------------------
bool CREDIT::SaveFile(LPWSTR pszFileName) {

	EDITSTREAM eds;		//EDITSTREAM\
	bool nFileType;		//rtftxt̔ʃtO
	if(StrStrW(pszFileName, L".rtf"))		nFileType = TRUE;	//rtft@CƂ
	else if(StrStrW(pszFileName, L".RTF"))	nFileType = TRUE;	//rtft@CƂ
	else									nFileType = FALSE;	//textt@CƂ
	HANDLE hFile = CreateFile(pszFileName, GENERIC_WRITE, 0,
						NULL, CREATE_ALWAYS,
						FILE_ATTRIBUTE_NORMAL | FILE_FLAG_WRITE_THROUGH, NULL);
	if (hFile == INVALID_HANDLE_VALUE) {
		MessageBoxW(m_hWnd, L"t@CJ܂ł", L"G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	eds.dwCookie = (DWORD)hFile;
	eds.dwError = 0;
	eds.pfnCallback = SaveRichEditProc;
	if(nFileType) {
		int ret = MessageBoxW(m_hWnd, L"UFT-8 RTFŕۑ܂\niuvANSI RTFj", L"݊mF", MB_YESNO | MB_ICONQUESTION);
		if(ret == IDYES)
			SendMessageW(m_hWnd, EM_STREAMOUT, (WPARAM)(CP_UTF8 << 16) | SF_USECODEPAGE | SF_RTF, (LPARAM)&eds);
		else
			SendMessageW(m_hWnd, EM_STREAMOUT, (WPARAM)SF_RTF, (LPARAM)&eds);
	}
	else {
		int ret = MessageBoxW(m_hWnd, L"BOMtUFT-16ŕۑ܂\nBOMUFT-8ŕۑ܂iuvj\niuLZvANSIj", L"݊mF", MB_YESNOCANCEL | MB_ICONQUESTION);
		if(ret == IDYES) {
			//BOM̏ - WindowsIntelnUTF-16 FF FEigGfBAj
			BYTE BOM[2] = {0xFF, 0xFE};
			DWORD dwWritten;
			WriteFile(hFile, BOM, 2, &dwWritten, NULL);
			SendMessageW(m_hWnd, EM_STREAMOUT, (WPARAM)SF_TEXT | SF_UNICODE, (LPARAM)&eds);
		}
		else if(ret == IDNO)
			SendMessageW(m_hWnd, EM_STREAMOUT, (WPARAM)(CP_UTF8 << 16) | SF_USECODEPAGE | SF_TEXT, (LPARAM)&eds);
		else
			SendMessageW(m_hWnd, EM_STREAMOUT, (WPARAM)SF_TEXT, (LPARAM)&eds);
	}
	CloseHandle(hFile);
	SendMessageW(m_hWnd, EM_SETMODIFY, (WPARAM)FALSE, 0);
	SetFocus(m_hWnd);
	return TRUE;
}

//---------------------------------------------------
// b`GfBbgRg[pǍR[obN֐
//---------------------------------------------------
DWORD CALLBACK CREDIT::ReadRichEditProc(DWORD dwCookie, LPBYTE pbBuf, LONG cb, LONG* pcb) {

	ReadFile((HANDLE)dwCookie, pbBuf, cb, (LPDWORD)pcb, NULL);
	return FALSE;
}

//--------------------------------------------------------------------------
// b`GfBbgRg[peLXgAb`GfBbgt@CǍ֐
// t@C pszFileName ̃t@C RichEdit Control֓ǂ݂܂
//--------------------------------------------------------------------------
bool CREDIT::LoadFile(LPWSTR pszFileName) {

	EDITSTREAM eds;		//EDITSTREAM\
	bool nFileType;		//rtftxt̔ʃtO
	if(StrStrW(pszFileName, L".rtf"))		nFileType = TRUE;	//rtft@CƂ
	else if(StrStrW(pszFileName, L".RTF"))	nFileType = TRUE;	//rtft@CƂ
	else									nFileType = FALSE;	//textt@CƂ
	HANDLE hFile = CreateFile(pszFileName, GENERIC_READ, 0, NULL, OPEN_EXISTING,
						FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE) {
		MessageBoxW(m_hWnd, L"t@CJ܂ł", L"G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	eds.dwCookie = (DWORD)hFile;
	eds.dwError = 0;
	eds.pfnCallback = ReadRichEditProc;
	if(nFileType) {
		int ret = MessageBoxW(m_hWnd, L"UFT-8 RTFœǂݍ݂܂\niuvANSI RTFj", L"ǂݍ݊mF", MB_YESNO | MB_ICONQUESTION);
		if(ret == IDYES)
			SendMessageW(m_hWnd, EM_STREAMIN, (WPARAM)(CP_UTF8 << 16) | SF_USECODEPAGE | SF_RTF, (LPARAM)&eds);
		else
			SendMessageW(m_hWnd, EM_STREAMIN, (WPARAM)SF_RTF, (LPARAM)&eds);
	}
	else {
		int ret = MessageBoxW(m_hWnd, L"BOMtUFT-16œǂݍ݂܂\nBOMUFT-8ɂ܂iuvj\niuLZvANSIj", L"ǂݍ݊mF", MB_YESNOCANCEL | MB_ICONQUESTION);
		if(ret == IDYES) {
			//BOM̓ǂݍ - WindowsIntelnUTF-16 FF FEigGfBAj
			BYTE BOM[2];
			DWORD dwRead;
			ReadFile(hFile, BOM, 2, &dwRead, NULL);
			if(BOM[0] != 0xFF || BOM[1] != 0xFE) {
				MessageBoxW(m_hWnd, L"BOMtUFT-16t@Bł͂܂", L"G[", MB_OK | MB_ICONERROR);
				CloseHandle(hFile);
				return FALSE;
			}
			SendMessageW(m_hWnd, EM_STREAMIN, (WPARAM)SF_TEXT | SF_UNICODE, (LPARAM)&eds);
		}
		else if(ret == IDNO)
			SendMessageW(m_hWnd, EM_STREAMIN, (WPARAM)(CP_UTF8 << 16) | SF_USECODEPAGE | SF_TEXT, (LPARAM)&eds);
		else
			SendMessageW(m_hWnd, EM_STREAMIN, (WPARAM)SF_TEXT, (LPARAM)&eds);
	}
	CloseHandle(hFile);
	SendMessageW(m_hWnd, EM_SETMODIFY, (WPARAM)FALSE, 0);
	SetFocus(m_hWnd);
	return TRUE;
}

//------------------------
// t@CTCY߂
//------------------------
long CREDIT::GetSize() {

	long ln = SendMessageW(m_hWnd, EM_GETLINECOUNT, 0, 0);
	long li = SendMessageW(m_hWnd, EM_LINEINDEX, ln - 1, 0);
	long ll = SendMessageW(m_hWnd, EM_LINELENGTH, li, 0);
	return (li + ll);
}

//----------------------------
//b`GfBbg̍sԂ
//----------------------------
long CREDIT::GetLines() {

	return SendMessageW(m_hWnd, EM_GETLINECOUNT, 0, 0);
}

//----------------------------------
//ws̍ŏAŌ̌̈ʒuԂ
//----------------------------------
LPPOINT CREDIT::GetLinePos(int ln) {

	static POINT pt;
	pt.x = SendMessageW(m_hWnd, EM_LINEINDEX, ln, 0);
	pt.y = pt.x + SendMessageW(m_hWnd, EM_LINELENGTH, pt.x, 0);
	return &pt;
}

//--------------------------
// ݂̍sÄʒuԂ
// 0A0sn܂
//--------------------------
LPPOINT CREDIT::GetPos() {

	static POINT pt;
	CHARRANGE cr;
	SendMessageW(m_hWnd, EM_EXGETSEL, 0, (LPARAM)&cr);
	long ln = SendMessageW(m_hWnd, EM_EXLINEFROMCHAR, 0, cr.cpMin);
	long li = SendMessageW(m_hWnd, EM_LINEINDEX, ln, 0);
	pt.x = cr.cpMin - li;
	pt.y = ln;
	return &pt;
}

//------------------------
// ݂̃tHg擾
//------------------------
LPLOGFONT CREDIT::GetFont() {

	return m_hFont.GetInfo();
}

//----------------------------------------------
// ݑIĂ镶̃tHgtHg
// _CAOgĕύX
//----------------------------------------------
bool CREDIT::SelFont() {

	CHOOSEFONT cf;		//ChooseFont\
	ZeroMemory(&cf, sizeof(CHOOSEFONT));
	LOGFONTW lf;		//Font\
    ZeroMemory(&lf, sizeof(LOGFONTW));

	//݂̃tHƏ\CHOOSEFONTɓǂݍ
	m_cfm.cbSize = sizeof(CHARFORMAT);
	SendMessageW(m_hWnd, EM_GETCHARFORMAT, TRUE, (LPARAM)&m_cfm);
	lf.lfHeight = MulDiv(m_cfm.yHeight,
		GetDeviceCaps(m_Dhdc, LOGPIXELSY), -1440);
	m_cfm.dwMask = CMASK;
	if(m_cfm.dwEffects & CFE_BOLD)
		lf.lfWeight = FW_BOLD;
	else
		lf.lfWeight = FW_NORMAL;
	if(m_cfm.dwEffects & CFE_ITALIC)
		lf.lfItalic = TRUE;
	if(m_cfm.dwEffects & CFE_UNDERLINE)
		lf.lfUnderline = TRUE;
	if(m_cfm.dwEffects & CFE_STRIKEOUT)
		lf.lfStrikeOut = TRUE;
	lf.lfCharSet = m_cfm.bCharSet;
	lf.lfQuality = DEFAULT_QUALITY;
	lf.lfPitchAndFamily = m_cfm.bPitchAndFamily;
	lstrcpyW(lf.lfFaceName, m_cfm.szFaceName);
	cf.rgbColors = m_cfm.crTextColor;
	cf.lStructSize = sizeof(CHOOSEFONT);
	cf.hwndOwner = m_hWnd;
	cf.lpLogFont = &lf;
	cf.Flags = CF_SCREENFONTS | CF_EFFECTS | CF_INITTOLOGFONTSTRUCT;
	//tHgChooseFont_CAO\̂瓾
	if(ChooseFont(&cf)) {	//
		m_cfm.cbSize = sizeof(CHARFORMAT);
		m_cfm.dwMask = CMASK;
		m_cfm.yHeight = 2 * cf.iPointSize;
		m_cfm.dwEffects = 0;
		if(lf.lfWeight >= FW_BOLD)
			m_cfm.dwEffects |= CFE_BOLD;
		if(lf.lfItalic)
			m_cfm.dwEffects |= CFE_ITALIC;
		if(lf.lfUnderline)
			m_cfm.dwEffects |= CFE_UNDERLINE;
		if(lf.lfStrikeOut)
			m_cfm.dwEffects |= CFE_STRIKEOUT;
		m_cfm.crTextColor = (COLORREF)cf.rgbColors;
		m_cfm.bPitchAndFamily = lf.lfPitchAndFamily;
		m_cfm.bCharSet = lf.lfCharSet;
		lstrcpyW(m_cfm.szFaceName, lf.lfFaceName);
		if(!SendMessageW(m_hWnd, EM_SETCHARFORMAT,
			SCF_SELECTION, (LPARAM)&m_cfm)) {
			MessageBoxW(m_hWnd, L"tHg̐ݒ肪ł܂ł", L"G[", MB_OK | MB_ICONERROR);
			return FALSE;
		}
	}
	SetFocus(m_hWnd);
	return TRUE;
}

//--------------------------------------
// tHgݒ(tHg_CAOwj
//--------------------------------------
void CREDIT::SetFont() {

	CHOOSEFONT cf;		//ChooseFont\
	ZeroMemory(&cf, sizeof(CHOOSEFONT));
	LOGFONTW lf;		//Font\
    ZeroMemory(&lf, sizeof(LOGFONTW));
	lf = *GetFont();
	cf.rgbColors = m_cfm.crTextColor;
	cf.lStructSize = sizeof(CHOOSEFONT);
	cf.hwndOwner = m_hWnd;
	cf.lpLogFont = &lf;
	cf.Flags = CF_SCREENFONTS | CF_EFFECTS | CF_INITTOLOGFONTSTRUCT;
	//tHgChooseFont_CAO\̂瓾
	if(ChooseFont(&cf)) {	//
		m_FontSize = cf.iPointSize / 10;
		lstrcpyW(m_FontName, lf.lfFaceName);
		m_hFont.SetFont(m_hWnd, m_FontSize, m_FontName);
	}
}

//------------------------
// tHgݒ(ڎwj
//------------------------
void CREDIT::SetFont(int size, WCHAR* FontName) {

	m_FontSize = size;
	lstrcpyW(m_FontName, FontName);
	m_hFont.SetFont(m_hWnd, size, FontName);
}

//--------------------------------------------------------------------------
// F̏(jflag = 0iSIjA1i1sIjȂi1Ij
//--------------------------------------------------------------------------
void CREDIT::InitCol(int min = 0, int max = -1) {

	CHARRANGE cr;
	SendMessageW(m_hWnd, EM_EXGETSEL, 0, (LPARAM)&cr);
	SendMessageW(m_hWnd, EM_SETSEL, min, max);
	m_cfm.cbSize = sizeof(CHARFORMAT);
	m_cfm.dwMask = CFM_COLOR;			//CMASK;
	m_cfm.dwEffects = CFE_AUTOCOLOR;	//|= CFE_AUTOCOLOR;
	SendMessageW(m_hWnd, EM_SETCHARFORMAT, SCF_SELECTION, (LPARAM)&m_cfm);
	SendMessageW(m_hWnd, EM_EXSETSEL, 0, (LPARAM)&cr);
	SetFocus(m_hWnd);
}

//------------------------------------------------
// b`GfBbgRg[̕F擾
//------------------------------------------------
COLORREF CREDIT::GetCol(int min, int max) {

	SendMessageW(m_hWnd, EM_SETSEL, min, max);
	m_cfm.cbSize = sizeof(CHARFORMAT);
	m_cfm.dwMask = CFM_COLOR;	//CMASK;
	SendMessageW(m_hWnd, EM_GETCHARFORMAT, SCF_SELECTION, (LPARAM)&m_cfm);
	return m_cfm.crTextColor;
}

//------------------------------------------------
// b`GfBbgRg[̕Fݒ肷
//------------------------------------------------
void CREDIT::SetCol(COLORREF col, bool sign = TRUE) {

	if(sign) {
		m_cfm.cbSize = sizeof(CHARFORMAT);
		m_cfm.dwMask = CFM_COLOR;	//CMASK;
		m_cfm.crTextColor = col;
		m_cfm.dwEffects = 0;		//^= CFE_AUTOCOLOR;
		SendMessageW(m_hWnd, EM_SETCHARFORMAT, SCF_SELECTION, (LPARAM)&m_cfm);
	}
	else
		SendMessageW(m_hWnd, EM_SETBKGNDCOLOR, 0, (LPARAM)col);
	SetFocus(m_hWnd);
}

//-----------------
// Token̐Ft
//-----------------
void CREDIT::SetTokenColor(WCHAR* target, COLORREF col, int min = 0, int max = -1, UINT flag = FR_MATCHCASE | FR_WHOLEWORD) {

	//FINDTEXT\
	FINDTEXTW ft;
	//͈͂̐ݒ
	ft.chrg.cpMin = min;
	ft.chrg.cpMax = max;
	//̒
	long wl = lstrlenW(target);
	//ւ̃|C^[ݒ
	ft.lpstrText = target;
	while(WasFound(&ft, flag)) {
		SendMessageW(m_hWnd, EM_SETSEL, ft.chrg.cpMin, ft.chrg.cpMin + wl);
		SetCol(col);
		ft.chrg.cpMin += wl;
	}
}

//--------------
// wsֈړ
//--------------
void CREDIT::Jump(int line, bool cover = TRUE) {

	CHARRANGE cr;
	cr.cpMin = cr.cpMax = SendMessageW(m_hWnd, EM_LINEINDEX, line, 0);
	if(cover)	cr.cpMax += SendMessageW(m_hWnd, EM_LINELENGTH, cr.cpMin, 0);
	SendMessageW(m_hWnd, EM_EXSETSEL, 0, (LPARAM)&cr);
	SendMessageW(m_hWnd, EM_SCROLLCARET, 0, 0);
	SetFocus(m_hWnd);
}

//------------------------------------------
// b`GfBbgRg[̕
// flag = R(ight), C(enter) or L(eft)
//------------------------------------------
void CREDIT::Align(WCHAR flag) {

	ZeroMemory(&m_pf, sizeof(PARAFORMAT));
	m_pf.cbSize = sizeof(PARAFORMAT);
	m_pf.dwMask = PFM_ALIGNMENT;
	switch(flag) {		//tbOɂpf.wAlignmentɏ݁A}[N
		case L'R':
			m_pf.wAlignment = PFA_RIGHT;
			break;
		case L'C':
			m_pf.wAlignment = PFA_CENTER;
			break;
		case L'L':
			m_pf.wAlignment = PFA_LEFT;
			break;
		default:
			m_pf.wAlignment = PFA_LEFT;
			break;
	}
	SendMessageW(m_hWnd, EM_SETPARAFORMAT, 0, (LPARAM)&m_pf);
	SetFocus(m_hWnd);
}

//--------------------------------------------
// b`GfBbgRg[̃Cfg
// flag = 1-^3-E̐ݒA2-^4-Ẻ
//--------------------------------------------
void CREDIT::Indent(int flag) {

	ZeroMemory(&m_pf, sizeof(PARAFORMAT));
	m_pf.cbSize = sizeof(PARAFORMAT);
	m_pf.dwMask = PFM_STARTINDENT | PFM_RIGHTINDENT;
	SendMessage(m_hWnd, EM_GETPARAFORMAT, 0, (LPARAM)&m_pf);
	switch(flag) {		//tbOɂpf.dxStart/RightOffsetɏ
		case 1:
			m_pf.dxStartIndent += INDENT;
			break;
		case 2:
			m_pf.dxStartIndent -= INDENT;
			if(m_pf.dxStartIndent < 0)
				m_pf.dxStartIndent = 0;
			break;
		case 3:
			m_pf.dxRightIndent += INDENT;
			break;
		case 4:
			m_pf.dxRightIndent -= INDENT;
			if(m_pf.dxRightIndent < 0)
				m_pf.dxRightIndent = 0;
			break;
	}
	SendMessageW(m_hWnd, EM_SETPARAFORMAT, 0, (LPARAM)&m_pf);
	SetFocus(m_hWnd);
}

//------------
// ^u̐ݒ
//------------
void CREDIT::Tab(int unit) {

	//twips P(20 twips = 1 points)
	//RichEdit̏l͍200twips(10 points x 20)A108twipsǂ̂B
	SIZE size;		//o[cxAcy
	WCHAR temp[95];
	for(int i = 0; i < 95; i++)	temp[i] = i + 32;
	GetTextExtentPoint32(m_Dhdc, temp, 95, &size);
	unit *= (size.cx / 95) * m_FontSize * 144 / GetDeviceCaps(m_Dhdc, LOGPIXELSX);
	//݂̈ʒuL^
	CHARRANGE cur;
	SendMessageW(m_hWnd, EM_EXGETSEL, 0, (LPARAM)&cur);
	//^uݒ
	ZeroMemory(&m_pf, sizeof(PARAFORMAT));
	m_pf.cbSize = sizeof(PARAFORMAT);
	SendMessageW(m_hWnd, EM_GETPARAFORMAT, 0, (LPARAM)&m_pf);
	m_pf.dwMask |= PFM_TABSTOPS;
	m_pf.cTabCount = MAX_TAB_STOPS;			//^uXgbv̓_̐
	for (int i = 0; i < MAX_TAB_STOPS; i++)
		m_pf.rgxTabs[i] = unit * (i + 1);	//e^uXgbv̓_L^
	//ŜJo[
	CHARRANGE set;
	set.cpMin = 0;	set.cpMax = -1;
	SendMessageW(m_hWnd, EM_EXSETSEL, 0, (LPARAM)&set);
	SendMessageW(m_hWnd, EM_SETPARAFORMAT, 0, (LPARAM)&m_pf);
	//ɖ߂
	SendMessageW(m_hWnd, EM_EXSETSEL, 0, (LPARAM)&cur);
	SetFocus(m_hWnd);
}

//--------------------
// v^[ݒ֐
//--------------------
bool CREDIT::SetPrinter() {

	if(!m_Phdc)		//̃v^[foCXReLXgΐ悸폜
		DeleteDC(m_Phdc);
	//_CAOv^[ݒŊJ
	PRINTDLG pd;
	ZeroMemory(&pd, sizeof(PRINTDLG));
	pd.lStructSize = sizeof(PRINTDLG);
	pd.hwndOwner = m_hWnd;
	pd.Flags = PD_PRINTSETUP | PD_RETURNDC;
	//v^[̃foCXReLXg擾
	if(PrintDlg(&pd))
		m_Phdc = pd.hDC;
	else {
		MessageBoxW(NULL, L"v^[̃foCXReLXg擾ł܂", L"G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	//v^[p̕I
	m_nPrnW = GetDeviceCaps(m_Phdc, PHYSICALWIDTH);
	//̘_IsNZ
	m_nLog = GetDeviceCaps(m_Phdc, LOGPIXELSX);
	//E1C`(1440 twip)̃}[Wݒ
	m_RichWidth = MulDiv(m_nPrnW, 1440, m_nLog) - PMARGIN * 2;
	return TRUE;
}

//--------------------
// y[Wԍt֐
//--------------------
int CREDIT::AddPageNo(int nPage) {

	int wx, wy, x, y;
	WCHAR szPage[64];
	const WCHAR *szPage_Org = L"- %d -";
	int nTextW;		//
	TEXTMETRIC tm;
	wx = GetDeviceCaps(m_Phdc, PHYSICALWIDTH);
	wy = GetDeviceCaps(m_Phdc, PHYSICALHEIGHT);
	wsprintfW(szPage, szPage_Org, nPage);
	GetTextMetrics(m_Phdc, &tm);
	nTextW = (int)tm.tmAveCharWidth * lstrlen(szPage);
	x = (wx - nTextW) / 2;	//ʒu
	y = wy - PMARGIN / 4;	//ʒu
	TextOutW(m_Phdc, x, y, szPage, lstrlenW(szPage));
	return nPage;
}

//--------------
// ֐
//--------------
bool CREDIT::Print(WCHAR* szFileName) {

	static FORMATRANGE fr;
	DOCINFOW di;
	DWORD lTextLen;
	DWORD lNextMin = 0;
	int nPage = 1; //y[Wԍ
	ZeroMemory(&fr, sizeof(FORMATRANGE));
	ZeroMemory(&di, sizeof(DOCINFOW));
	//^Cg szFileName
	di.cbSize = sizeof(DOCINFO);
	di.lpszDocName = szFileName;
	if(!m_Phdc) {
		MessageBoxW(m_hWnd, L"v^[܂", L"G[",
			MB_OK | MB_ICONERROR);
		return FALSE;
	}
	fr.hdc = m_Phdc;
	fr.hdcTarget = m_Phdc;
	fr.rcPage.left = 0;
	fr.rcPage.top = 0;
	fr.rcPage.right = MulDiv(GetDeviceCaps(m_Phdc, PHYSICALWIDTH),
		1440, GetDeviceCaps(m_Phdc, LOGPIXELSX));
	fr.rcPage.bottom = MulDiv(GetDeviceCaps(m_Phdc, PHYSICALHEIGHT),
		1440, GetDeviceCaps(m_Phdc, LOGPIXELSY));
	//㉺E1C`(1440twip)̃}[Wݒ
	fr.rc.top = PMARGIN;
	fr.rc.left = PMARGIN;
	fr.rc.right = fr.rcPage.right - PMARGIN;
	fr.rc.bottom = fr.rcPage.bottom - PMARGIN;
//	lTextLen = SendMessage(m_hWnd, WM_GETTEXTLENGTH, 0, 0);	//[ṽR[h
	GETTEXTLENGTHEX gtl;	//GETTEXTLENEX\
	lTextLen = PtrToInt(SendMessageW(m_hWnd, EM_GETTEXTLENGTHEX, (WPARAM)&gtl, 0));
	fr.chrg.cpMin = 0;
	fr.chrg.cpMax = lTextLen;
	StartDoc(m_Phdc, &di);
/*  Oct 2, 2020 - Tv"Visual Studio 2019 Image Library EULA.rtf"t@C
	ƁAlTextLen11,661ł̂ɑ΂Afr.chrg.cpMin11,649̂11,647
	ȂA[vƂȂ邽߂ɁAwhileɎ̂悤ȏǉB
	if(lNextMin <= fr.chrg.cpMin)	break;	//[vR[h
	AɃb`GfBbg̃f[^WM_GETTEXTLENGTHłƂ邱Ƃł͂ȂA
	ƍlAׂʁAEM_GETTEXTLENGTHEX̗pBiAۂsځj
	//؃R[h1
	char Buff[128];
	wsprintf(Buff, "fr.chrg.cpMax = %d\nfr.chrg.cpMin = %d", fr.chrg.cpMax, fr.chrg.cpMin);
	MessageBox(m_hWnd, Buff, "", MB_OK | MB_ICONINFORMATION);
	//؃R[h2
	char Buff[128];
	wsprintf(Buff, "WM_GETTEXTLENGTH= %d, EM_GETTEXTLENGTHEX, = %d", lTextLen, nLength);
	MessageBox(m_hWnd, Buff, "Test", MB_OK | MB_ICONINFORMATION);
*/
	while (fr.chrg.cpMin < lTextLen) {
		lNextMin = SendMessageW(m_hWnd, EM_FORMATRANGE, TRUE, (LPARAM)&fr);
		StartPage(m_Phdc);
		SendMessageW(m_hWnd, EM_DISPLAYBAND, 0, (LPARAM)&fr.rc);
		AddPageNo(nPage);
		EndPage(m_Phdc);
		fr.chrg.cpMin = lNextMin;
		nPage++;
	}
	SendMessageW(m_hWnd, EM_FORMATRANGE, TRUE, NULL);
	return (EndDoc(m_Phdc) > 0);
}

//--------------------------------------------------------
// b`GfBbgRg[̕v^[ɍ킹
//--------------------------------------------------------
void CREDIT::SetWYSWYG(bool sign = TRUE) {

	if(sign) {
		if(!(SendMessageW(m_hWnd, EM_SETTARGETDEVICE, (WPARAM)m_Phdc, (LPARAM)m_RichWidth)))
			MessageBoxW(m_hWnd, L"b`GfBbgRg[ݒł܂ł",
						L"G[", MB_OK | MB_ICONERROR);
	}
	else {
		SendMessageW(m_hWnd, EM_SETTARGETDEVICE, (WPARAM)m_Dhdc,
			(LPARAM)MulDiv(GetDeviceCaps(m_Dhdc, PHYSICALWIDTH), 1440,
			GetDeviceCaps(m_Dhdc, LOGPIXELSX)));
	}
}

//--------------------------------------
// upFINDREPLACE\̂̏
//--------------------------------------
FINDREPLACEW* CREDIT::SetFRDlg(WCHAR sign) {

	DWORD flag;
	switch(sign) {
	case L'F':
	case L'f':
		flag = FR_DOWN | FR_FINDNEXT;
		break;
	case L'R':
	case L'r':
		flag = FR_DOWN | FR_REPLACE;
		break;
	default :
		return 0;
	}

	static FINDREPLACEW fr;
	ZeroMemory(&fr, sizeof(FINDREPLACEW));
	fr.lStructSize = sizeof(FINDREPLACEW);
	fr.hwndOwner = m_hParent;
	fr.hInstance = NULL;
	fr.Flags = flag;
	fr.lpstrFindWhat = m_FindWhat;
	fr.lpstrReplaceWith = m_ReplaceWith;
	fr.wFindWhatLen = MAX_PATH;
	fr.wReplaceWithLen = MAX_PATH;
	fr.lCustData = NULL;
	fr.lpfnHook = NULL;
	fr.lpTemplateName = NULL;
	return &fr;
}

//----------------
// Eu֐
//----------------
bool CREDIT::WasFound(FINDTEXTW* ft, UINT flag) {

	return ((ft->chrg.cpMin = SendMessageW(m_hWnd, EM_FINDTEXTW,
								flag, (LPARAM)ft)) != NOMORE);
}

//------------------------------
// Eu_CAO֐
//------------------------------
void CREDIT::FindReplace(LPARAM lParam) {

	static int fcount = 0;	//񐔂̃JE^[
	static int rcount = 0;	//u񐔂̃JE^[
	static int fc, rc;		//\p̃JE^[iL0ɏ̂Łj
	static FINDTEXTW ft;	//FINDTEXTW\́|o[chrglpstrText
	WCHAR FRMsg[MAX_PATH];	//o̓bZ[Wpz
	LPFINDREPLACEW fr = (LPFINDREPLACEW)lParam;	//\FINDREPLACEWւ̃|C^[
	//͈͂̐ݒ
	if(!fcount) {								//񂾂s
		SendMessageW(m_hWnd, EM_EXGETSEL, 0,
					(LPARAM)&ft.chrg);			//I͈͂擾
		if(fr->Flags & FR_DOWN) {				//Ȃ
			ft.chrg.cpMin = ft.chrg.cpMax;		//I͈̖͂ift.chrg.cpMaxj
			ft.chrg.cpMax = -1;					//܂ł
		}
		else									//ȂI͈͂̐擪ift.chrg.cpMinj
			ft.chrg.cpMax = 0;					//icpMax < MinłȂ΂ȂȂj
	}
	//̐ݒ
	ft.lpstrText = m_FindWhat;
	//u
	if(fr->Flags & FR_DIALOGTERM) {		//Eu_CAOIꍇ
		fc = fcount;	rc = rcount;	//\pɋL^
		m_hFRDlg = 0;					//nh
		fcount = 0;						//JE^[
		rcount = 0;						//uJE^[
		SetFocus(m_hWnd);				//b`GfBbgRg[ɃtH[JX𓖂Ă
	}
	else if(fr->Flags & FR_FINDNEXT) {	//uv̏ꍇ
		if(WasFound(&ft, (fr->Flags & FR_DOWN) | (fr->Flags & FR_MATCHCASE) | 
					(fr->Flags & FR_WHOLEWORD))) {				//ꍇ
			fcount++;											//񐔂L^
			SendMessageW(m_hWnd, EM_SETSEL, ft.chrg.cpMin,
						ft.chrg.cpMin + lstrlenW(m_FindWhat));	//I
			SendMessageW(m_hWnd, EM_SCROLLCARET, 0, 0);			//Lbg̈ʒu\
			SetFocus(m_hWnd);			//b`GfBbgRg[ɃtH[JX𓖂Ă
			if(fr->Flags & FR_DOWN)		//̏ꍇ
				ft.chrg.cpMin += lstrlenW(m_FindWhat);			//̌Jnʒuɐi߂
		}
		else {													//Ȃꍇ
			SendMessageW(m_hFRDlg, WM_CLOSE, 0, 0);				//Eu_CAO
			wsprintfW(FRMsg, L" %d񌩂܂", fc);
			MessageBoxW(m_hParent, FRMsg, L"bZ[W", MB_OK | MB_ICONINFORMATION);
		}
	}
	else if(fr->Flags & FR_REPLACE) {	//uuĎɁv̏ꍇ
		if(WasFound(&ft, (fr->Flags & FR_DOWN) | (fr->Flags & FR_MATCHCASE) | 
					(fr->Flags & FR_WHOLEWORD))) {				//ꍇ
			SendMessageW(m_hWnd, EM_SETSEL, ft.chrg.cpMin, ft.chrg.cpMin + lstrlenW(m_FindWhat));
			SendMessageW(m_hWnd, EM_SCROLLCARET, 0, 0);			//Lbgʒu\
			//bZ[W{bNXŊmFČuɒu
			if(MessageBoxW(m_hParent, L"u܂H", L"m  F",
							MB_YESNO | MB_ICONQUESTION) == IDYES) {
				SendMessageW(m_hWnd, EM_REPLACESEL, TRUE, (LPARAM)m_ReplaceWith);
				rcount++;										//u񐔂L^
			}
			fcount++;											//񐔂L^
			SendMessageW(m_hWnd, EM_SETSEL, ft.chrg.cpMin, ft.chrg.cpMin + lstrlenW(m_ReplaceWith));
			SendMessageW(m_hWnd, EM_SCROLLCARET, 0, 0);			//Lbgʒu\
			SetFocus(m_hWnd);			//b`GfBbgRg[ɃtH[JX𓖂Ă
			if(fr->Flags & FR_DOWN)		//̏ꍇ
				ft.chrg.cpMin += lstrlenW(m_ReplaceWith);		//̌Jnʒuɐi߂
		}
		else {													//Ȃꍇ
			SendMessageW(m_hFRDlg, WM_CLOSE, 0, 0);				//Eu_CAO
			wsprintfW(FRMsg, L" %dA%du܂", fc, rc);
			MessageBoxW(m_hParent, FRMsg, L"bZ[W", MB_OK | MB_ICONINFORMATION);
		}
	}
	else if(fr->Flags & FR_REPLACEALL) {//uׂĒuv̏ꍇ
		ft.chrg.cpMin = 0;		//Jnʒu𕶓ƂA
		ft.chrg.cpMax = -1;		//Iʒu𕶖Ƃ
		while(WasFound(&ft, (fr->Flags & FR_DOWN) | (fr->Flags & FR_MATCHCASE) |
					(fr->Flags & FR_WHOLEWORD))) {
			fcount++;											//񐔂L^
			SendMessageW(m_hWnd, EM_SETSEL, ft.chrg.cpMin, ft.chrg.cpMin + lstrlen(m_FindWhat));
			SendMessageW(m_hWnd, EM_SCROLLCARET, 0, 0);			//Lbgʒu\
			SendMessageW(m_hWnd, EM_REPLACESEL, TRUE, (LPARAM)m_ReplaceWith);
			rcount++;											//u񐔂L^
			if(fr->Flags & FR_DOWN)		//̏ꍇ
				ft.chrg.cpMin += lstrlenW(m_ReplaceWith);		//̌Jnʒuɐi߂
		}
		SendMessageW(m_hFRDlg, WM_CLOSE, 0, 0);					//Eu_CAO
		wsprintfW(FRMsg, L" %du܂", rc);
		MessageBoxW(m_hParent, FRMsg, L"bZ[W", MB_OK | MB_ICONINFORMATION);
	}
	SetFocus(m_hWnd);		//b`GfBbgRg[ɃtH[JX𓖂Ă
}
