/////////////////////////////
// ECCSkelton
// Shell Service Utility
// CSHELLNX`t@C
// Copyright (c) August, 2022
//        By Ysama
/////////////////////////////
///////////////////////////////
// Shell (COM) Service Utility
///////////////////////////////

#define		WM_SHELLCHANGE	WM_APP
#include <shlobj.h>
#include <shlwapi.h>
//ICu[t@C̎w
#pragma comment (lib, "shell32.lib")
#pragma comment (lib, "shlwapi.lib")

class CSHELL
{
private:
	IShellFolder		*m_pDesktopFolder;	//fXNgbvizjtH[_[C^[tF[X
	PIDLIST_ABSOLUTE	m_pidlDesktop;		//fXNgbv̐΃AhX
	PIDLIST_ABSOLUTE	m_pidlCurFolder;	//݂̃tH[_[̐΃AhX
	HWND				m_tvhWnd;			//TreeViewij̃EBhEnh
	HWND				m_lvhWnd;			//ListViewiEj̃EBhEnh
	ULONG				m_uRegisterId;		//Shellʒm̓o^ID
public:
	CSHELL(HWND);
	~CSHELL();
	void SetHandles(HWND, HWND);			//TreeViewijListViewiEj̃nhݒ
	IShellFolder* GetShellFolder() {return m_pDesktopFolder;}	//fXNgbvVFtH[_[̎擾
	PIDLIST_ABSOLUTE GetDesktop() {return m_pidlDesktop;}		//fXNgbvPIDL̎擾
	void SetCurFolder(PIDLIST_ABSOLUTE);						//m_pidlCurFolder̐ݒ
	PIDLIST_ABSOLUTE GetCurFolder();							//m_pidlCurFolder̎擾
	bool InsertTreeItem(PIDLIST_ABSOLUTE, HTREEITEM, LPWSTR, SFGAOF);
	bool ViewEnumItem(PIDLIST_ABSOLUTE, HWND, BOOL, HTREEITEM, int CALLBACK (*)(LPARAM, LPARAM, LPARAM));
	bool ResetListViewColumn(IShellFolder*);
	bool InsertListItem(PIDLIST_ABSOLUTE, IShellFolder*, PITEMID_CHILD, SFGAOF, int);
	ULONG SetSHChangeNoticeRegister(HWND);								//t@CAtH[_[̕ύXʒmݒ
	void NotifyShellChange(PIDLIST_ABSOLUTE, PIDLIST_ABSOLUTE, LONG);	//VFʒm;
	bool FileOperation(HWND, WCHAR, WCHAR*, WCHAR*, FILEOP_FLAGS);			//t@C
};

CSHELL::CSHELL(HWND hWnd) {

	//PXbhiSTAjCOM library
	CoInitialize(NULL);
	//tH[_[̎擾
	if(SHGetDesktopFolder(&m_pDesktopFolder) != S_OK)
		MessageBoxW(NULL, L"Unable to use CSHELL class", L"Error", MB_OK | MB_ICONERROR);
	if(SHGetSpecialFolderLocation(hWnd, CSIDL_DESKTOP, &m_pidlDesktop) != S_OK)	//CSIDL = "Constant Special item ID List" CSIDL_DESKTOP = The "Windows Desktop" virtual folder 
		MessageBoxW(NULL, L"Unable to use CSHELL class", L"Error", MB_OK | MB_ICONERROR);
	m_pidlCurFolder = NULL;
}

CSHELL::~CSHELL() {

	SHChangeNotifyDeregister(m_uRegisterId);	//VFʒmI
	if(m_pDesktopFolder)
		m_pDesktopFolder->Release();			//COM[̊J
	CoUninitialize();							//yK{zCOM̏I
}

//TreeViewijListViewiEj̃nhݒ
void CSHELL::SetHandles(HWND tvhWnd, HWND lvhWnd) {

	m_tvhWnd = tvhWnd;	//TreeViewij̃EBhEnh
	m_lvhWnd = lvhWnd;	//ListViewiEj̃EBhEnh
}

//m_pidlCurFolder̐ݒ
void CSHELL::SetCurFolder(PIDLIST_ABSOLUTE pidl) {

	m_pidlCurFolder = pidl;
}

//m_pidlCurFolder̎擾
PIDLIST_ABSOLUTE CSHELL::GetCurFolder() {

	return m_pidlCurFolder;
}

bool CSHELL::InsertTreeItem(PIDLIST_ABSOLUTE pidlAbsolute, HTREEITEM hitemParent, LPWSTR lpszName, SFGAOF attributes) {

	SHFILEINFOW		FileInfo;		//t@CIuWFNgɊւ`\
	TVINSERTSTRUCTW	tvIs;			//c[r\p}\
	//tvIsitemݒ
	SHGetFileInfo((LPWSTR)pidlAbsolute, 0, &FileInfo, sizeof(SHFILEINFO), SHGFI_SYSICONINDEX | SHGFI_PIDL);
	tvIs.item.iImage = FileInfo.iIcon;			//iIcon|VXeC[WXg̃CfbNX
	SHGetFileInfo((LPWSTR)pidlAbsolute, 0, &FileInfo, sizeof(SHFILEINFO), SHGFI_SYSICONINDEX | SHGFI_PIDL | SHGFI_OPENICON);
	tvIs.item.iSelectedImage = FileInfo.iIcon;	//iIcon|VXeC[WXǵuIvCfbNX
 	tvIs.hParent		= hitemParent;			//c[r[ẽCfbNX
	tvIs.item.mask		= TVIF_TEXT | TVIF_PARAM | TVIF_IMAGE | TVIF_SELECTEDIMAGE;	//gp郁o[
	tvIs.item.pszText	= lpszName;				//ڂ̃t@C܂̓tH[_[
	tvIs.item.lParam	= (LPARAM)pidlAbsolute;	//ڂ̐PIDLlParamɋL^
	//SFGAOF attributes̃`FbN
	if (attributes & SFGAO_GHOSTED) {		//u؂vitemiconO[ɂ
		tvIs.item.mask	|= LVIF_STATE;
		tvIs.item.state	 = LVIS_CUT;
		tvIs.item.stateMask = LVIS_CUT;
	}
	if (attributes & SFGAO_SHARE) {			//itemLĂꍇAuLvԂiconɂ
		tvIs.item.mask	|= LVIF_STATE;
		tvIs.item.state	 = INDEXTOOVERLAYMASK(1);
		tvIs.item.stateMask = LVIS_OVERLAYMASK;
	}
	if (attributes & SFGAO_LINK) {			//itemV[gJbg̏ꍇAuV[gJbgvԂiconɂ
		tvIs.item.mask	|= LVIF_STATE;
		tvIs.item.state	 = INDEXTOOVERLAYMASK(2);
		tvIs.item.stateMask = LVIS_OVERLAYMASK;
	}
	if (attributes & SFGAO_HASSUBFOLDER) {	//itemsubfolderꍇAuWJ\v́u+vt
		tvIs.item.mask	|= TVIF_CHILDREN;
		tvIs.item.cChildren = 1;
	}
	return TreeView_InsertItem(m_tvhWnd, &tvIs);
}

bool CSHELL::ViewEnumItem(PIDLIST_ABSOLUTE pidlAbsolute, HWND hWnd, BOOL bInsertList, HTREEITEM hitem, int CALLBACK (*CompareFunc)(LPARAM, LPARAM, LPARAM)) {

	bool				success;
	int					i = 0;
	BOOL				bBind;
	WCHAR				szDisplayName[MAX_PATH];
	SFGAOF				attributes = 0;
	SHCONTF				flag;
	STRRET				strret;
	PIDLIST_ABSOLUTE	pidlNew;
	PITEMID_CHILD		pidlChild;
	IShellFolder		*pShellFolder;
	IEnumIDList			*pEnumIdList;
	//pidlAbsolutefXNgbv̏ꍇAG[̂ňvmFAvꍇm_pDesktopFolderw
	if(!m_pDesktopFolder->CompareIDs(0, pidlAbsolute, m_pidlDesktop)) {
		pShellFolder = m_pDesktopFolder;
		bBind = FALSE;
	}
	else {
		m_pDesktopFolder->BindToObject(pidlAbsolute, NULL, IID_PPV_ARGS(&pShellFolder));
		bBind = TRUE;
	}
	if(bInsertList) {	//TRUȄꍇAXgr[iڍ폜Ɨ񖼁j
		ListView_DeleteAllItems(m_lvhWnd);
		ResetListViewColumn(pShellFolder);
	}
	flag = bInsertList ? SHCONTF_FOLDERS | SHCONTF_NONFOLDERS : SHCONTF_FOLDERS;	//Xgr[͑SāAc[r\̓tH[_[̂
	if(pShellFolder->EnumObjects(hWnd, flag | SHCONTF_INCLUDEHIDDEN, &pEnumIdList) != S_OK) {	//IDXg擾s̏ꍇ
		if(bBind)
			pShellFolder->Release();
		return FALSE;
	}
	while(pEnumIdList->Next(1, &pidlChild, NULL) == S_OK) {	//qIDXg
		pidlNew = ILCombine(pidlAbsolute, pidlChild);
		if(bInsertList) {	//Xgr[֒ǉ
			attributes = SFGAO_GHOSTED | SFGAO_SHARE | SFGAO_LINK;
			pShellFolder->GetAttributesOf(1, (LPCITEMIDLIST *)&pidlChild, &attributes);
			success = (bool)InsertListItem(pidlNew, pShellFolder, pidlChild, attributes, i);
		}
		else {				//c[r[֒ǉ
			attributes = SFGAO_HASSUBFOLDER | SFGAO_GHOSTED | SFGAO_SHARE | SFGAO_LINK;
			pShellFolder->GetAttributesOf(1, (LPCITEMIDLIST *)&pidlChild, &attributes);
			pShellFolder->GetDisplayNameOf(pidlChild, SHGDN_NORMAL, &strret);
			StrRetToBuf(&strret, pidlChild, szDisplayName, sizeof(szDisplayName) / sizeof(WCHAR));
			success = (bool)InsertTreeItem(pidlNew, hitem, szDisplayName, attributes);
		}
		i++;
		CoTaskMemFree(pidlChild);	//pEnumIdList->Next()Ŏ擾q͉
	}
	if(bInsertList)	//Xgr[ACẽ\[g
		ListView_SortItems(m_lvhWnd, CompareFunc, (LPARAM)pShellFolder);
	pEnumIdList->Release();
	if(bBind)		//ꂪTRUȄꍇA[KviReleasevۂ̃tOj
		pShellFolder->Release();
	return success;
}

//Xgr[̃Zbg
bool CSHELL::ResetListViewColumn(IShellFolder *pShellFolder) {

	bool			success;
	int				i, nCol;
	WCHAR			szBuf[MAX_PATH];
	LVCOLUMN		lvColumn;
	SHELLDETAILS	shDetails;
	IShellFolder2	*pShellFolder2;
	//݂̗񐔂߂Ăׂč폜
	nCol = Header_GetItemCount(ListView_GetHeader(m_lvhWnd));
	for(i = 0; i < nCol; i++)
		ListView_DeleteColumn(m_lvhWnd, 0);
	//ShellFolder2̎擾Ɏs
	if(pShellFolder->QueryInterface(IID_PPV_ARGS(&pShellFolder2)) != S_OK)
		return FALSE;
	
	for(i = 0; i < 4; i++) {
		if(pShellFolder2->GetDetailsOf(NULL, i, &shDetails) != S_OK)
			break;	//ڍ׏̎擾Ɏs甲o
		//ڍ׏istrretjstriWCHARj
		StrRetToBuf(&shDetails.str, NULL, szBuf, sizeof(szBuf) / sizeof(WCHAR));
		//lvColumnɃZbg
		lvColumn.mask		= LVCF_WIDTH | LVCF_TEXT;
		lvColumn.cx			= 150;	//x
		lvColumn.pszText	= szBuf;
		success = (bool)ListView_InsertColumn(m_lvhWnd, i, &lvColumn);
	}
	pShellFolder2->Release();
	return success;
}

bool CSHELL::InsertListItem(PIDLIST_ABSOLUTE pidlAbsolute, IShellFolder *pShellFolder, PITEMID_CHILD pidlChild, SFGAOF attributes, int i) {

	bool			success;
	int				j;
	WCHAR			szBuf[MAX_PATH];
	LVITEMW			lvItem;
	SHFILEINFOW		shFileInfo;
	SHELLDETAILS	shDetails;
	IShellFolder2	*pShellFolder2;
	//ShellFolder2̎擾Ɏs
	if (pShellFolder->QueryInterface(IID_PPV_ARGS(&pShellFolder2)) != S_OK)
		return FALSE;
	//1si4j̍ڂǉĂ䂭
	for(j = 0; j < 4; j++) {
		pShellFolder2->GetDetailsOf(pidlChild, j, &shDetails);
		StrRetToBuf(&shDetails.str, pidlChild, szBuf, sizeof(szBuf) / sizeof(WCHAR));
		//LVITEM̐ݒ
		lvItem.mask	 = LVIF_TEXT;
		lvItem.iItem	= i;
		lvItem.iSubItem = j;
		lvItem.pszText  = szBuf;
		if(!j) {	//1̏ꍇiLVITEM̒ǉݒj
			SHGetFileInfo((LPTSTR)pidlAbsolute, 0, &shFileInfo, sizeof(SHFILEINFOW), SHGFI_SYSICONINDEX | SHGFI_PIDL);
			lvItem.mask  |= LVIF_IMAGE | LVIF_PARAM;
			lvItem.iImage = shFileInfo.iIcon;
			lvItem.lParam = (LPARAM)pidlAbsolute;
			if(attributes & SFGAO_GHOSTED) {
				lvItem.mask	 |= LVIF_STATE;
				lvItem.state	 = LVIS_CUT;
				lvItem.stateMask = LVIS_CUT;
			}
			if(attributes & SFGAO_SHARE) {
				lvItem.mask	 	|= LVIF_STATE;
				lvItem.state	 = INDEXTOOVERLAYMASK(1);
				lvItem.stateMask = LVIS_OVERLAYMASK;
			}
			if(attributes & SFGAO_LINK) {
				lvItem.mask	 	|= LVIF_STATE;
				lvItem.state	 = INDEXTOOVERLAYMASK(2);
				lvItem.stateMask = LVIS_OVERLAYMASK;
			}
			success = (bool)ListView_InsertItem(m_lvhWnd, &lvItem);
			if(!success) break;
		}
		else {		//1ȊȌꍇ
			success = (bool)ListView_SetItem(m_lvhWnd, &lvItem);
			if(!success) break;
		}
	}
	pShellFolder2->Release();
	return success;
}

//VFit@CAtH[_[̍쐬A폜A̕ύXjύXʒmݒiʒmI̓fXgN^[Ŏ{j
ULONG CSHELL::SetSHChangeNoticeRegister(HWND hWnd) {

	//Shellʒmp\entry̐ݒiĎΏۃfXNgbvȉjƓo^j		
	SHChangeNotifyEntry entry;	//ύXʒmݒp\
	entry.pidl = m_pidlDesktop;	//PIDLiyт̉ʁj̕ύXʒm󂯎
	entry.fRecursive = TRUE;	//TRUEɐݒ肷邱ƂPIDL̉ʃtH[_[̕ύXʒm
	m_uRegisterId = SHChangeNotifyRegister(hWnd, SHCNRF_ShellLevel | SHCNRF_NewDelivery,
					SHCNE_CREATE | SHCNE_DELETE | SHCNE_RENAMEITEM | SHCNE_MKDIR |
					SHCNE_RMDIR | SHCNE_RENAMEFOLDER, WM_SHELLCHANGE, 1, &entry);
	return m_uRegisterId;
}

//VFʒmiXgr[j
void CSHELL::NotifyShellChange(PIDLIST_ABSOLUTE pidlAbsolute1, PIDLIST_ABSOLUTE pidlAbsolute2, LONG lEvent) {

	int i, nCount;
	LVITEMW item;
	if(lEvent == SHCNE_CREATE) {			//t@C쐬ꂽꍇ
		SFGAOF				attributes;
		PITEMID_CHILD		pidlChild;
		PIDLIST_ABSOLUTE	pidlNew;
		IShellFolder		*pShellFolder;
 		//쐬ꂽt@C̃tH[_[IuWFNg̎擾
		SHBindToParent(pidlAbsolute1, IID_PPV_ARGS(&pShellFolder), NULL);
		//ŐV̎qPIDL擾
		pidlNew = ILClone(pidlAbsolute1);	//pidlAbsolute1̕쐬
		pidlChild = ILFindLastID(pidlNew);	//qPIDL擾
		//쐬ꂽt@C̑擾ăXgr[ɒǉ
		attributes = SFGAO_FILESYSTEM | SFGAO_GHOSTED | SFGAO_SHARE | SFGAO_LINK;
		pShellFolder->GetAttributesOf(1, (LPCITEMIDLIST *)&pidlChild, &attributes);
		InsertListItem(pidlNew, pShellFolder, pidlChild, attributes, -1);
 		//tH[_[IuWFNg̉
		pShellFolder->Release();
		ILFree(pidlNew);					//쐬̊J
	}
	else if(lEvent == SHCNE_DELETE) {		//t@C폜ꂽꍇ
		nCount = ListView_GetItemCount(m_lvhWnd);	//ACe擾
		for(i = 0; i < nCount; i++) {
			item.mask		= LVIF_PARAM;
			item.iItem		= i;
			item.iSubItem	= 0;
			ListView_GetItem(m_lvhWnd, &item);
			//ACepidl擾Aׂč폜t@C̃ACe폜
			if(ILIsEqual((PIDLIST_ABSOLUTE)item.lParam, pidlAbsolute1)) {
				ListView_DeleteItem(m_lvhWnd, i);
				break;
			}
		}
	}
	else if (lEvent == SHCNE_RENAMEITEM) {	//t@CύXꂽꍇ
		nCount = ListView_GetItemCount(m_lvhWnd);	//ACe擾
		for(i = 0; i < nCount; i++) {
			item.mask		= LVIF_PARAM;
			item.iItem		= i;
			item.iSubItem	= 0;
			ListView_GetItem(m_lvhWnd, &item);
			//ACepidl擾AׂĊYt@C𖼏̕ύX
			if (ILIsEqual((PIDLIST_ABSOLUTE)item.lParam, pidlAbsolute1)) {
				TCHAR  szPath[256];
				LPTSTR lpszName;
				SHGetPathFromIDList(pidlAbsolute2, szPath);
				lpszName = PathFindFileName(szPath);
				item.mask		= LVIF_TEXT | LVIF_PARAM;
				item.iItem		= i;
				item.iSubItem	= 0;
				item.pszText	= lpszName;
				item.cchTextMax	= lstrlen(lpszName);
				item.lParam		= (LPARAM)ILClone(pidlAbsolute2);
				ListView_SetItem(m_lvhWnd, &item);
				break;
			}
		}
	}
}

//t@C
bool CSHELL::FileOperation(HWND hWnd, WCHAR flag, WCHAR* From, WCHAR* To = NULL, FILEOP_FLAGS foflag = FOF_NOCONFIRMATION) {

	WCHAR fn[MAX_PATH] = {0};
	lstrcpyW(fn, From);
	SHFILEOPSTRUCTW Shfo;
	ZeroMemory(&Shfo, sizeof(Shfo));
	Shfo.hwnd	= hWnd;
	Shfo.pFrom	= fn;
	Shfo.pTo	= To;
	Shfo.fFlags	= foflag;
	switch(flag) {
	case L'M':
	case L'm':
		Shfo.wFunc = FO_MOVE;
		break;
	case L'C':
	case L'c':
		Shfo.wFunc = FO_COPY;
		break;
	case L'D':
	case L'd':
		Shfo.wFunc = FO_DELETE;
		break;
	case L'R':
	case L'r':
		Shfo.wFunc = FO_RENAME;
		break;
	default:
		break;
	}
	return SHFileOperation(&Shfo);
/*
int SHFileOperationA(
	LPSHFILEOPSTRUCT pFileOp   // SHFILEOPSTRUCT\
);
t@CVXeIuWFNg̃Rs[EړEO̕ύXE폜sȂ܂B
typedef struct _SHFILEOPSTRUCT {
	HWND  hwnd;						//EBhEnh
	UINT  wFunc;					//s鑀iFO_MOVE, FO_COPY, FO_DELETE, FO_RENAMEj
	LPCTSTR  pFrom;					//1ȏ̃t@Cobt@AhXitpXwA"*"ChJ[hwB0؂ōŌ2Kv)
	LPCTSTR  pTo;					//ړIt@CiRs[EړfBNg܂͕ύX̃t@CBgpȂꍇNULLj
	FILEOP_FLAGS fFlags;			//tOiFOF_MULTIDESTFILE, FOF_SILENT, FOF_NOCONFIRMATION, FOF_SIMPLEPROGRESSj
	BOOL fAnyOperationsAborted;		// ʁi[U[ɂ钆~ TRUEAȊOFALSEj
	LPVOID  hNameMappings;			// t@C}bsOIuWFNgiFOF_WANTMAPPINGHANDLE tOw肳ꂽꍇɂ̂ݎgpj
	LPCTSTR lpszProgressTitle;		// _CAÕ^CgiFlags o FOF_SIMPLEPROGRESS w肳Ăꍇɂ̂ݗLj
} SHFILEOPSTRUCT, FAR *LPSHFILEOPSTRUCT;
SHFileOperation ֐sȂt@CɊւĂ̏񂪊i[܂B
*/}
