/////////////////////////////
// ECCSkelton
// CSTRNX`t@C
// Copyright (c) August, 2022
//        By Ysama
/////////////////////////////
#ifndef	_CSTR_
#define _CSTR_

class CSTR {

	WCHAR*	m_str;

public:
	CSTR();									//RXgN^[ij
	CSTR(const WCHAR*);						//RXgN^[ij
	CSTR(const CSTR&);						//RXgN^[iCSTRj
	CSTR(const long);						//RXgN^[ij
	~CSTR();								//fXgN^[
	CSTR& operator = (const WCHAR*);		//operator = (B) ---> = B;
	CSTR& operator = (const CSTR&);			//operator = (B) ---> = B;
	CSTR& operator = (const long);			//operator = (B) ---> = B;
	WCHAR* ToChar() {return m_str;}			//|C^[ƂĕԂ
	void Print();							//m_str󎚂
	friend CSTR operator + (const CSTR&, const CSTR&);		//A operator + (B)  --->= A + B;
	friend bool operator == (const CSTR&, const CSTR&);		//A operator == (B) --->= A == B;
	friend bool operator == (const CSTR&, const WCHAR*);	//A operator == (B) --->= A == B;
	friend bool operator != (const CSTR&, const CSTR&);		//A operator == (B) --->= A != B;
	friend bool operator != (const CSTR&, const WCHAR*);	//A operator == (B) --->= A != B;
	bool FromFile(WCHAR*, WCHAR*, HWND);	//t@C̓Ǎ
	bool FromFile(WCHAR*);					//t@C̓Ǎ
	bool ToFile(WCHAR*, WCHAR*, HWND);		//_CAOgUTF-16t@Cւ̏
	bool ToFile(WCHAR*);					//UTF-16t@Cւ̏
	bool ToUTF8File(WCHAR*, bool);			//UTF-8t@Cւ̏݁iboolBOML̃tOj
	bool ToSJISFile(WCHAR*);				//SJISt@Cւ̏
	bool Next(CSTR&);						//m_str̒P؂o
	bool GetLine(CSTR&);					//̍s܂Ői
	bool NextLine();						//̍s܂Ői
	WCHAR* Find(WCHAR*, WCHAR*);			//̌
	WCHAR* Replace(WCHAR*, WCHAR*, WCHAR*);		//̒u
	void ReplaceAll(WCHAR*, WCHAR*, WCHAR*);	//̑Su
};

//RXgN^[ij
CSTR::CSTR() {

	//Chgp̂߃P[̏i{j
	setlocale(LC_CTYPE, "JPN");
	m_str = new WCHAR[1];
	*m_str = L'\0';
}

//RXgN^[ij
CSTR::CSTR(const WCHAR* string) {

	//Chgp̂߃P[̏i{j
	setlocale(LC_CTYPE, "JPN");
	m_str = new WCHAR[lstrlenW(string) + 1];
	lstrcpyW(m_str, string);
}

//RXgN^[iCSTRj
CSTR::CSTR(const CSTR& cst) {

	//Chgp̂߃P[̏i{j
	setlocale(LC_CTYPE, "JPN");
	m_str = new WCHAR[lstrlenW(cst.m_str) + 1];
	lstrcpyW(m_str, cst.m_str);
}

//RXgN^[ij
CSTR::CSTR(const long i) {

	//Chgp̂߃P[̏i{j
	setlocale(LC_CTYPE, "JPN");
	WCHAR sbuff[MAX_PATH / 8];
	wsprintfW(sbuff, L"%d", i);
	m_str = new WCHAR[lstrlenW(sbuff) + 1];
	lstrcpyW(m_str, sbuff);
}

//fXgN^[
CSTR::~CSTR() {

	delete [] m_str;
}

//WCHAȒ
CSTR& CSTR::operator = (const WCHAR* str) {

	delete [] m_str;
	m_str = new WCHAR[lstrlenW(str) + 1];
	lstrcpyW(m_str, str);
	return *this;
}

//CSTȒ
CSTR& CSTR::operator = (const CSTR& cst) {

	if(&cst != this) {	//You can't copy yourself
		delete [] m_str;
		m_str = new WCHAR[lstrlenW(cst.m_str) + 1];
		lstrcpyW(m_str, cst.m_str);
	}
	return *this;
}

//̑
CSTR& CSTR::operator = (const long i) {

	WCHAR sbuff[MAX_PATH / 8];
	wsprintfW(sbuff, L"%d", i);
	delete [] m_str;
	m_str = new WCHAR[lstrlenW(sbuff) + 1];
	lstrcpyW(m_str, sbuff);
	return *this;
}

//m_str󎚂
void CSTR::Print() {

	MessageBoxW(NULL, m_str, L"CSTR Message", MB_OK);
}

//ǉZq̒`
CSTR operator + (const CSTR& cst1, const CSTR& cst2) {

	CSTR strw;
	delete [] strw.m_str;
	strw.m_str = new WCHAR[lstrlenW(cst1.m_str) + lstrlenW(cst2.m_str) + 1];
	lstrcpyW(strw.m_str, cst1.m_str);
	lstrcatW(strw.m_str, cst2.m_str);
	return strw;
}

//rZq̒`iPj
bool operator == (const CSTR& cst1, const CSTR& cst2) {

	return !lstrcmpW(cst1.m_str, cst2.m_str);
}

//rZq̒`iQj
bool operator == (const CSTR& cst, const WCHAR* str) {

	return !lstrcmpW(cst.m_str, str);
}

//rZq̒`iRj
bool operator != (const CSTR& cst1, const CSTR& cst2) {

	return lstrcmpW(cst1.m_str, cst2.m_str);
}

//rZq̒`iSj
bool operator != (const CSTR& cst, const WCHAR* str) {

	return lstrcmpW(cst.m_str, str);
}

//t@C̓Ǎ
bool CSTR::FromFile(WCHAR* Filter, WCHAR* FilePath, HWND hWnd = NULL) {

	WCHAR FileName[MAX_PATH];
	WCHAR file_path[MAX_PATH];
	lstrcpyW(file_path, FilePath);	//Default Path
	OPENFILENAMEW ofn;				//I[vt@C_CAO\
	//I[vt@C_CAOŃt@C擾
	FileName[0] = NULL;
	ZeroMemory(&ofn, sizeof(ofn));	//[
	ofn.lStructSize		= sizeof(ofn);
	ofn.hwndOwner		= hWnd;
	ofn.lpstrFilter		= Filter;
	ofn.nFilterIndex	= 1;
	ofn.lpstrFile		= FileName;
	ofn.nMaxFile		= MAX_PATH;
	if(!*FilePath)					//KlNULLłΌ݂̃fBNg[
		GetCurrentDirectoryW(MAX_PATH, file_path);
	else
		lstrcpyW(file_path, FilePath);
	ofn.lpstrInitialDir = file_path;
	ofn.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
	if(!GetOpenFileNameW(&ofn))	return FALSE;		//ǂݍ݌
	return FromFile(FileName);
}

//t@C̓Ǎ
bool CSTR::FromFile(WCHAR* FileName) {

	//t@Cǂݍ
	BOOL bSuccess = FALSE;
	HANDLE hFile = CreateFileW(FileName, GENERIC_READ, FILE_SHARE_READ, NULL,
						OPEN_EXISTING, NULL, NULL);		//t@CǍ݂ŃI[v
	if(hFile != INVALID_HANDLE_VALUE) {					//I[vł
		DWORD dwFileSize = GetFileSize(hFile, NULL);
		if(dwFileSize != 0xFFFFFFFF) {					//-1(0xFFFFFFFF)G[
			LPBYTE Buff = new BYTE[dwFileSize + 2]();	//ǂݍ݃obt@iNULLI[ǉjp|C^[
			//"new z[]()"Ń[AWCHARt@CɂΉł悤Ō2oCgNULLɂĂ
			DWORD dwRead;
			if(ReadFile(hFile, Buff, dwFileSize, &dwRead, NULL)) {
				bSuccess = TRUE; 						//ǂݍݐ
				//BOMtUTF-16AUTF-32̏ꍇ
				if(Buff[0] == 0xFF && Buff[1] == 0xFE) {
					if(Buff[2] | Buff[3]) {				//NULLł͂ȂUTF-16BOM
						delete [] m_str;				//̕p
						//BOMȍ~̃f[^m_strɎ[
						m_str = new WCHAR[dwFileSize / sizeof(WCHAR)];
						//mɂ"new WCHAR[(dwFileSize + 2 <NULL> - 2 <BOM>) / sizeof(WCHAR)]
						CopyMemory(m_str, Buff + 2, dwFileSize - 2);	//BOMO
					}
					else {								//Buff[2]Buff[3])NULLiUTF-32܂UTF-16NULL̂݁j
						bSuccess = FALSE;				//BOMtUTF-32̏ꍇAǂݍݎs
					}
				}
				//BOMtUTF-8̏ꍇ
				else if(Buff[0] == 0xEF && Buff[1] == 0xBB && Buff[2] == 0xBF) {
					dwRead = MultiByteToWideChar(CP_UTF8, MB_ERR_INVALID_CHARS, (LPCCH)(Buff + 3), -1, NULL, NULL);
					if(dwRead) {	//UTF-8̏ꍇ
						//m_strp[̏
						delete [] m_str;
						m_str = new WCHAR[dwRead];
						//UTF8WCHAR֕ϊ
						MultiByteToWideChar(CP_UTF8, MB_ERR_INVALID_CHARS, (LPCCH)(Buff + 3), -1, m_str, dwRead);
					}
					else {			//BOMtUTF-8ŕϊs\̏ꍇ
						bSuccess = FALSE;	//ǂݍݎs
					}
				}
				//UTF-16A32A8ABOMȂꍇ
				else {
					//悸BOMUTF-8ۂ`FbN
					if(dwRead = MultiByteToWideChar(CP_UTF8, MB_ERR_INVALID_CHARS, (LPCCH)Buff, -1, NULL, NULL)) {
						//m_strp[̏
						delete [] m_str;
						m_str = new WCHAR[dwRead];
						//UTF8WCHAR֕ϊ
						MultiByteToWideChar(CP_UTF8, MB_ERR_INVALID_CHARS, (LPCCH)Buff, -1, m_str, dwRead);
					}
					//Sift JISiR[hy[WCP_ACPjۂ`FbN
					else if(dwRead = MultiByteToWideChar(CP_ACP, MB_ERR_INVALID_CHARS, (LPCCH)Buff, -1, NULL, NULL)) {
						//m_strp[̏
						delete [] m_str;
						m_str = new WCHAR[dwRead];
						//SJISWCHAR֕ϊ
						MultiByteToWideChar(CP_ACP, MB_ERR_INVALID_CHARS, (LPCCH)Buff, -1, m_str, dwRead);
					}
					//BOMAUTF-8܂SJISł͂ȂꍇAǂݍݎs
					else {
						bSuccess = FALSE;
					}
				}
			}
			delete [] Buff;							//ǂݍ݃obt@
		}
		CloseHandle(hFile);							//t@C̃N[Y
	}
	return bSuccess;
}

//t@Cւ̏݁iKlUTF-16 gGfBAj
bool CSTR::ToFile(WCHAR* Filter, WCHAR* DefExt, HWND hWnd = NULL) {

	WCHAR FileName[MAX_PATH];
	OPENFILENAMEW ofn;				//I[vt@C_CAO\
	//I[vt@C_CAOŃt@C擾
	ZeroMemory(&ofn, sizeof(ofn));	//[
	FileName[0] = NULL;
	ofn.lStructSize		= sizeof(ofn);
	ofn.hwndOwner		= hWnd;
	ofn.lpstrFilter		= Filter;
	ofn.nFilterIndex	= 1;
	ofn.lpstrFile		= FileName;
	ofn.nMaxFile		= MAX_PATH;
	ofn.lpstrInitialDir = L".";
	ofn.lpstrDefExt		= DefExt;	//ftHg̊gq
	ofn.Flags = OFN_EXPLORER | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY |
				OFN_OVERWRITEPROMPT;
	if(!GetSaveFileNameW(&ofn))	return FALSE;;
	//t@C
	return ToFile(FileName);
}

//t@Cւ̏݁iKlUTF-16 gGfBAj
bool CSTR::ToFile(WCHAR* FileName) {

	BOOL bSuccess = FALSE;
	HANDLE hFile;
	hFile = CreateFileW(FileName, GENERIC_WRITE, NULL, NULL,	//t@C݂ŃI[v
						CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile != INVALID_HANDLE_VALUE) {							//I[vł
		//obt@當񒷎擾ANULLI[Z
		DWORD dwTextLength = (lstrlenW(m_str) + 1) * sizeof(WCHAR);
		DWORD dwWritten;
		//BOM̏ - WindowsIntelnUTF-16 FF FEigGfBAj
		BYTE BOM[2] = {0xFF, 0xFE};
		if(WriteFile(hFile, BOM, 2, &dwWritten, NULL)) {
			WriteFile(hFile, m_str, dwTextLength, &dwWritten, NULL);
			bSuccess = (dwTextLength == dwWritten);				//ݐ
		}
		CloseHandle(hFile);			//t@C̃N[Y
	}
	return bSuccess;
}

//UTF-8t@Cւ̏݁iboolBOML̃tOj
bool CSTR::ToUTF8File(WCHAR* FileName, bool bom = TRUE) {

	BOOL bSuccess = FALSE;
	HANDLE hFile;
	hFile = CreateFileW(FileName, GENERIC_WRITE, NULL, NULL,	//t@C݂ŃI[v
						CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile != INVALID_HANDLE_VALUE) {		//I[vł
		//WCHARUTF8֕ϊۂ̕񒷁ioCg|NULLI[܂ށj擾
		DWORD dwBuffSize = WideCharToMultiByte(CP_UTF8, WC_ERR_INVALID_CHARS, m_str, -1, NULL, NULL, NULL, NULL);
		if(!dwBuffSize) {
			CloseHandle(hFile);				//t@C̃N[Y
			return FALSE;
		}
		//UTF-8p[̊m
		char* utf8 = new char[dwBuffSize]();
		//WCHARUTF8֕ϊ
		WideCharToMultiByte(CP_UTF8, WC_ERR_INVALID_CHARS, m_str, -1, utf8, dwBuffSize, NULL, NULL);
		//UTF-8̏
		DWORD dwWritten;
		if(bom) {	//BOML
			//BOM̏ - UTF-8 0xEF 0xBB 0xBF
			BYTE BOM[3] = {0xEF, 0xBB, 0xBF};
			if(WriteFile(hFile, BOM, 3, &dwWritten, NULL)) {
				WriteFile(hFile, utf8, dwBuffSize, &dwWritten, NULL);
				bSuccess = TRUE;	//ݐ
			}
		}
		else {		//BOM
			if(WriteFile(hFile, utf8, dwBuffSize, &dwWritten, NULL))
				bSuccess = TRUE;	//ݐ
		}
		delete [] utf8;				//UTF-8񃁃[̊J
		CloseHandle(hFile);			//t@C̃N[Y
	}
	return bSuccess;
}

//SJISt@Cւ̏
bool CSTR::ToSJISFile(WCHAR* FileName) {

	BOOL bSuccess = FALSE;
	HANDLE hFile;
	hFile = CreateFileW(FileName, GENERIC_WRITE, NULL, NULL,	//t@C݂ŃI[v
						CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile != INVALID_HANDLE_VALUE) {	//I[vł
		//WCHARSJIS֕ϊۂ̕񒷁ioCg|NULLI[܂ށj擾
		DWORD dwBuffSize = WideCharToMultiByte(CP_ACP, WC_NO_BEST_FIT_CHARS | WC_COMPOSITECHECK | WC_DEFAULTCHAR, m_str, -1, NULL, NULL, NULL, NULL);
//		DWORD dwBuffSize = WideCharToMultiByte(CP_ACP, WC_ERR_INVALID_CHARS, m_str, -1, NULL, NULL, NULL, NULL);	//2i
		if(!dwBuffSize) {
/*			DWORD dwError = GetLastError();		//C_ERR_INVALID_CHARSŃG[ɕtR[h
			switch(dwError) {
			case ERROR_INSUFFICIENT_BUFFER:
				MessageBoxW(0, L"Cause: ERROR_INSUFFICIENT_BUFFER", L"Error", MB_OK | MB_ICONERROR); break;
			case ERROR_INVALID_FLAGS:
				MessageBoxW(0, L"Cause: ERROR_INVALID_FLAGS", L"Error", MB_OK | MB_ICONERROR); break;
			case ERROR_INVALID_PARAMETER:
    	        MessageBoxW(0, L"Cause: ERROR_INVALID_PARAMETER", L"Error", MB_OK | MB_ICONERROR); break;
			default:
				MessageBoxW(0, L"Cause: unknown", L"Error", MB_OK | MB_ICONERROR); break;
			}
*/			CloseHandle(hFile);			//t@C̃N[Y
			return FALSE;
		}
		//SJISp[̊m
		char* sjis = new char[dwBuffSize]();
		//WCHARSJIS֕ϊ
		WideCharToMultiByte(CP_ACP, WC_NO_BEST_FIT_CHARS | WC_COMPOSITECHECK | WC_DEFAULTCHAR, m_str, -1, sjis, dwBuffSize, NULL, NULL);
		//SJIS̏
		DWORD dwWritten;
		if(WriteFile(hFile, sjis, dwBuffSize, &dwWritten, NULL))
			bSuccess = TRUE;			//ݐ
		delete [] sjis;					//UTF-8񃁃[̊J
		CloseHandle(hFile);				//t@C̃N[Y
	}
	return bSuccess;
}

//m_str̒P؂o
bool CSTR::Next(CSTR& destination) {

	CSTR str;
	delete [] str.m_str;
	str.m_str = new WCHAR[lstrlenW(m_str) + 1];
	WCHAR* ptr = m_str;
	WCHAR* des = str.m_str;
	bool Terminate = TRUE;
	//Xy[X̓XLbv
	while(iswspace(*ptr) || *ptr == L'@' || *ptr == L',') {
			ptr++;						//XLbvXy[X
	}
	//Xy[X𒲂ׂ
	while(!iswspace(*ptr)) {			//Xy[XłȂ
		if(!*ptr) {						//NULLI[ȂFALSEԂ
			Terminate = FALSE;
			break;
		}
		else if(*ptr == L'@') {
			break;						//Sp"@"ȂI
		}
		else if(*ptr == L',') {
			ptr++;						//','XLbvĎ̕܂Ői
			break;						//󔒕
		}
		else if(*ptr == L'"') {
			ptr++;						//'"'XLbvĒgo
			while(*ptr != L'"') {		//'"'Ȃ'"'܂Ői
				if(!*ptr) {				//NULLI[ȂFALSEԂ
					Terminate = FALSE;
					break;
				}
				*des = *ptr;
				ptr++;	des++;
			}
			ptr++;						//\[X|C^[͎̕֐i߂
			break;						//[v𔲂ăfXeBl[VNULL
		}
		else if(*ptr == L'/' && *(ptr + 1) == L'*') {
			ptr++;	ptr++;				//"/*`*/"Rg
			while(!(*ptr == L'*' && *(ptr + 1) == L'/')) {
				if(!*ptr) {				//NULLI[ȂFALSEԂ
					Terminate = FALSE;
					break;
				}
				ptr++;
			}
			ptr++;	ptr++;
			//ēxXy[XXLbv
			while(iswspace(*ptr) || *ptr == L'@' || *ptr == L',') {
				if(!*ptr) {				//NULLI[ȂFALSEԂ
					Terminate = FALSE;
					break;
				}
				ptr++;				//XLbvXy[X
			}
			continue;
		}
		else if(*ptr == L'/' && *(ptr + 1) == L'/') {
			while(*ptr != L'\n') {		//"//"Rg
				if(!*ptr) {				//NULLI[ȂFALSEԂ
					Terminate = FALSE;
					break;
				}
				ptr++;
			}
			while(iswspace(*ptr) || *ptr == L'@' || *ptr == L',') {
				if(!*ptr) {				//NULLI[ȂFALSEԂ
					Terminate = FALSE;
					break;
				}
				ptr++;				//XLbvXy[X
			}
			continue;
		}
		else {
			*des = *ptr;
		}
		ptr++;	des++;
	}
	*des = L'\0';

	destination = str;			//destinationɐ؂
	str = ptr;					//strm_striptrȍ~̕
	delete [] m_str;
	m_str = new WCHAR[lstrlenW(str.m_str) + 1];
	lstrcpyW(m_str, str.m_str);	//m_strɂ͐؂̕񂪓
	if(*str.m_str || *destination.m_str)
		Terminate = TRUE;		//cNULLł؂񂪂Α
	else
		Terminate = FALSE;		//NULLȂI
	return Terminate;			//stOԂ
}

//̍s܂Ői
bool CSTR::GetLine(CSTR& destination) {

	bool Terminate = TRUE;
	WCHAR* ptr = m_str;
	WCHAR* des = ptr;
	while(*des && *des != L'\n')
		des++;
	if(!*des) {
		destination = L"";
		Terminate = FALSE;	//̏ITC
	}
	else {
		*des = L'\0'; des++;				//NULLI[Ai߂
		delete [] destination.m_str;
		destination.m_str = new WCHAR[des - ptr + 1];
		lstrcpyW(destination.m_str, ptr);
		destination.m_str[des - ptr - 1] = L'\n';	//NULLɂ'\n't
		destination.m_str[des - ptr] = L'\0';		//NULLI[
	}
	if(Terminate) {					//܂񂪂Ύc
		CSTR str = des;
		delete [] m_str;
		m_str = new WCHAR[lstrlenW(str.m_str) + 1];
		lstrcpyW(m_str, str.m_str);	//m_strɂ͐؂̕񂪓
	}
	if(*destination.m_str)			//NULLɏoA
		Terminate = TRUE;			//؂񂪂Α
	else
		Terminate = FALSE;			//NULLȂI
	return Terminate;				//stOԂ
}

//̍s܂Ői
bool CSTR::NextLine() {

	WCHAR* ptr = m_str;
	while(*ptr != L'\n') {		//sR[h܂Ői
		if(!*ptr) {				//rNULLI[ȂFALSEԂ
			return FALSE;
		}
		ptr++;
	}
	ptr++;
	CSTR str = ptr;
	delete [] m_str;
	m_str = new WCHAR[lstrlenW(str.m_str) + 1];
	lstrcpyW(m_str, str.m_str);	//m_strɂ͐؂̕񂪓
	return TRUE;				//stOԂ
}

//̌
WCHAR* CSTR::Find(WCHAR* ToFind, WCHAR* sp = 0) {

	if(!sp)
		sp = m_str;
	return StrStrW(sp, ToFind);
}

//̒u
WCHAR* CSTR::Replace(WCHAR* ToFind, WCHAR* ToReplace, WCHAR* sp = 0) {

	//CSTR̃f[^AAuvZ
	int OrgLen = lstrlenW(m_str);
	int ToFindLen = lstrlenW(ToFind);
	int ToReplaceLen = lstrlenW(ToReplace);
	//sp̎w肪CSTRf[^̐擪猟
	if(!sp)
		sp = m_str;
	//|C^[̎擾
	WCHAR* Found_at = StrStrW(sp, ToFind);		//񂪖NULLԂ
	//
	if(Found_at) {
		DWORD dspl = Found_at - m_str;			//Found_atm_stȓΈʒu
		//u̕f[^obt@[iNULLI[tj̊m
		WCHAR* buff = new WCHAR[OrgLen - ToFindLen + ToReplaceLen + 1];
		*Found_at = L'\0';						//NULLI[
		lstrcpyW(buff, m_str);					//iToFindj܂łbuffɃRs[
		lstrcatW(buff, ToReplace);				//iToFindj̑ɒuRs[
		lstrcatW(buff, Found_at + ToFindLen);	//iToFindjȍ~̕Rs[
		buff[OrgLen - ToFindLen + ToReplaceLen] = L'\0';	//NULLI[t
		delete [] m_str;						//CSTRf[^im_strj폜
		m_str = new WCHAR[OrgLen - ToFindLen + ToReplaceLen + 1];	//Vf[^̈m
		lstrcpyW(m_str, buff);					//ũf[^Rs[
		Found_at = m_str + dspl;				//Found_atm_stȓΈʒu
		delete [] buff;							//f[^obt@[j
	}
	return Found_at;	//ułȂꍇNULLAłꍇu̐擪|C^[
}

//̑Su
void CSTR::ReplaceAll(WCHAR* ToFind, WCHAR* ToReplace, WCHAR* sp = 0) {

	WCHAR* Next = sp;
	while((Next = Replace(ToFind, ToReplace, Next)))
		Next += lstrlenW(ToReplace);
}

#endif
