///////////////////////////////////////
// ECCSkelton
// c[`bvNXCTTIP`t@C
// Copyright (c) August, 2022
//        By Ysama
///////////////////////////////////////

class CTTIP
{
public:
	HWND m_hTip;								//c[`bṽEBhEnh
	HWND m_hParent;								//ẽEBhEnh
	HWND m_hCtrl;								//Rg[̃EBhEnh
	HINSTANCE m_hInstance;						//ẽCX^X
	TOOLINFOW m_ToolInfo;						//TOOLINFO\
	CFONT m_hFont;								//c[`bṽtHg
public:		//o[֐
	bool SetToolTip(HWND, int, LPWSTR, bool);	//c[`bv̕t^
	void UpdateText(LPWSTR);					//c[`bv̍XV
	void SetWidth(int);							//c[`bvő啝ݒ
	void SetBackColor(UINT);					//c[`bvwiFݒ
	void SetTextColor(UINT);					//c[`bvwiFݒ
	void SetFont(int, LPWSTR);					//tHgݒ(ڎwj
};

//c[`bv̕t^
bool CTTIP::SetToolTip(HWND hWnd, int CtrlID, LPWSTR pszText, bool baloon = FALSE) {

	//ZbgRg[̐eAID܂͕NULL̏ꍇG[Ƃ
	if(!CtrlID || !(m_hParent = hWnd) || !*pszText)
		return FALSE;
	//o[^ɂ邩ۂ
	DWORD style;
	if(baloon)
		style = WS_POPUP | TTS_ALWAYSTIP | TTS_BALLOON;
	else
		style = WS_POPUP | TTS_ALWAYSTIP;
	//ΏۃRg[̃nh擾
	m_hCtrl = GetDlgItem(m_hParent, CtrlID);
	//񃊃\[X̂eEBhEi_CAOj̃CX^X
	m_hInstance = (HINSTANCE)GetWindowLong(m_hParent, GWL_HINSTANCE);
	//c[`bv̍쐬
	m_hTip = CreateWindowExW(NULL, TOOLTIPS_CLASS, NULL, style,
				CW_USEDEFAULT, CW_USEDEFAULT,
				CW_USEDEFAULT, CW_USEDEFAULT,
				m_hParent, NULL, m_hInstance, NULL);
	//c[`bv쐬sG[
	if(!m_hCtrl || !m_hTip)
		return FALSE;
	//c[`bvRg[Ɋ֘At
	ZeroMemory(&m_ToolInfo, sizeof(m_ToolInfo));	//[NA[
	m_ToolInfo.cbSize = sizeof(TOOLINFOW) - sizeof(void*);
//	m_ToolInfo.cbSize = sizeof(TOOLINFOW);		//Microsoft̃oOH
//ipjhttps://social.msdn.microsoft.com/Forums/en-US/5cc9a772-5174-4180-a1ca-173dc81886d9/adding-tooltip-controls-in-unicode-fails?forum=vclanguage
//i{jhttps://www.petitmonte.com/bbs/answers?question_id=12982
	m_ToolInfo.hwnd = m_hParent;
	m_ToolInfo.uFlags = TTF_IDISHWND | TTF_SUBCLASS;
	m_ToolInfo.uId = (UINT_PTR)m_hCtrl;
	m_ToolInfo.hinst = m_hInstance;
	m_ToolInfo.lpszText = pszText;
	SendMessage(m_hTip, TTM_ADDTOOL, 0, (LPARAM)&m_ToolInfo);
	SetWindowPos(m_hTip, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);
	return TRUE;
}

//c[`bv̍XV
void CTTIP::UpdateText(LPWSTR pszText) {

	//TOOLINFȌ
	ZeroMemory(&m_ToolInfo, sizeof(m_ToolInfo));	//[NA[
	m_ToolInfo.cbSize =  sizeof(TOOLINFOW) - sizeof(void*);
	m_ToolInfo.hwnd = m_hParent;
	m_ToolInfo.uFlags = TTF_IDISHWND | TTF_SUBCLASS;
	m_ToolInfo.uId = (UINT_PTR)m_hCtrl;
	m_ToolInfo.hinst = m_hInstance;
	m_ToolInfo.lpszText = pszText;
	SendMessage(m_hTip, TTM_UPDATETIPTEXT, 0, (LPARAM)&m_ToolInfo);
}

//c[`bvő啝ݒ
void CTTIP::SetWidth(int size) {	//Cӂ̕ꍇ size == -1

	SendMessageW(m_hTip, TTM_SETMAXTIPWIDTH, 0, (LPARAM)size);
}

//c[`bvwiFݒ
void CTTIP::SetBackColor(UINT col) {	//Cӂ̕ꍇ size == -1

	SendMessageW(m_hTip, TTM_SETTIPBKCOLOR, col, 0);
}

//c[`bvwiFݒ
void CTTIP::SetTextColor(UINT col) {	//Cӂ̕ꍇ size == -1

	SendMessageW(m_hTip, TTM_SETTIPTEXTCOLOR, col, 0);
}

// tHgݒ(ڎwj
void CTTIP::SetFont(int size, LPWSTR FontName) {

	m_hFont.SetFont(m_hTip, size, FontName);
}
