//////////////////////////////
// ECCSkelton
// CVOICENX`t@C
// Copyright (c) August, 2022
//        By Ysama
//////////////////////////////
#include <sapi.h>
#include <wchar.h>
#include <string>
#include <locale.h>
using namespace std;

#define	MAX_NUM	64							//g[N̍ő吔

class CVOICE {
private:
	//ϐ
	HRESULT m_hr;							//ʔpϐ
	ISpVoice* m_pVoice;						//IuWFNg|C^[
	DWORD m_Num_of_Token;					//g[Ni̎j̐
	ISpObjectToken* m_pToken[MAX_NUM];		//g[Nւ̃|C^[ilpj
	ISpObjectTokenCategory* m_pCategory;	//g[NJeS[ւ̃|C^[
	IEnumSpObjectTokens* m_pTokens;			//񋓗pg[NQւ̃|C^[
	WCHAR m_TokenID[MAX_NUM][MAX_PATH];		//g[NKey̕p
	WCHAR m_TokenName[MAX_NUM][32];			//g[NAttributeNamep
	WCHAR m_TokenGender[MAX_NUM][7];		//g[NAttributeGenderpiMale or Femalej
	WCHAR m_TokenLanguage[MAX_NUM][5];		//g[NAttributeLanguagepi411, 409 etc|4j
	wstring m_script;						//Ǐグ郏Chiidjւ̃|C^[
	//֐
	WCHAR* GetAttribute(LPWSTR, WCHAR*);		//̎wAttribute擾

public:
	//֐
	CVOICE();								//RXgN^[
	~CVOICE();								//fXgN^[
	bool GetVoices(HWND);					//p\ȉXg{bNXɓo^
	int GetCount()							//p\ȉԂ
		{return m_Num_of_Token;}
	WCHAR* GetGender(DWORD);					//p\ȓ̉̐ʂԂ
	WCHAR* GetLanguage(DWORD);				//p\ȓ̉̌Ԃ
	bool SetVoice(DWORD);					//p\ȓ̉I
	HRESULT Speak(WCHAR*);					//XNvgǂ
	HRESULT Speak(wstring);					//XNvgǂ
	void Pause();							//ǂݏグ̒f
	void Resume();							//ǂݏグ̍ĊJ
};

//RXgN^[
CVOICE::CVOICE() {

	//P[̐ݒ
	_wsetlocale(LC_CTYPE, L"JPN");			//Chgp̂߃P[̏iPCj
	m_hr = CoInitialize(NULL);				//񂾂ĂяoCOM̏
	if(FAILED(m_hr))
		MessageBoxW(0, L"Failed to initialize COM (Error 404)", L"COM Error", MB_OK | MB_ICONERROR);
	else {
		m_pVoice = NULL;					//IuWFNg|C^[
		for(int i =0; i < MAX_NUM; i++)		//IuWFNgg[Nւ̃|C^[
			m_pToken[i] = NULL;
		m_hr = CoCreateInstance(CLSID_SpVoice, NULL, CLSCTX_ALL, IID_ISpVoice, (void **)&m_pVoice);
		if(SUCCEEDED(m_hr))
			m_hr = m_pVoice->GetVoice(&m_pToken[0]);	//ftHg̉擾
		else
			MessageBoxW(0, L"Failed to create SAPI instance", L"SAPI Error", MB_OK | MB_ICONERROR);
	}
}

//fXgN^[
CVOICE::~CVOICE() {

	m_pVoice->Release();
	m_pVoice = NULL;
	CoUninitialize();
}

//̎wAttribute擾
WCHAR* CVOICE::GetAttribute(LPWSTR ptVoiceID, WCHAR* entry) {

	static BYTE Buff[128];	//擾entry(Age, Gender, Name)̕iREG_SZjf[^̎擾p
	WCHAR* VoiceID;			//ptVoiceIDRs[p|C^[
	WCHAR* cp;				//ptVoiceID͗p|C^[
	VoiceID = new WCHAR[lstrlenW(ptVoiceID) + 12];	//Ch{"\\Attributes"{I[k
	lstrcpyW(VoiceID, ptVoiceID);					//VoiceIDptVoiceIDRs[
	for(cp = VoiceID; *cp && *cp != L'\\'; cp++);	//cpgptVoiceID̍ŏ́u\v
	if(*cp)											//*cpL'\0'łȂL'\\'ł
		*cp++ = L'\0';								//ŏ́u\vNULLƂAcpi߂
	else
		return NULL;								//NULLI[܂ŗ̂ŃG[
	//VoiceID̓HKEY_LOCAL_MACHINEłȂNULLԂ
	if(lstrcmpW(VoiceID, L"HKEY_LOCAL_MACHINE"))
		return NULL;
	//VoiceID̃TuL[AttributesKeyɂhKey擾
	lstrcatW(cp, L"\\Attributes");
	HKEY hKey;
	DWORD dwResult = RegOpenKeyExW(HKEY_LOCAL_MACHINE, cp, 0, KEY_READ, &hKey);
	//VoiceIDKeyJȂNULLԂ
	if(dwResult != ERROR_SUCCESS)
		return NULL;
	//Attributesentry̕f[^擾
 	DWORD type;
	DWORD cbData = sizeof(Buff);
	dwResult = RegQueryValueExW(hKey, entry, NULL, &type, Buff, &cbData);
	//VoiceIDAttributesentryǂ߂ȂNULLԂ
	if(dwResult != ERROR_SUCCESS)
		return NULL;
	RegCloseKey(hKey);
	delete [] VoiceID;	
	return (WCHAR*)Buff;
}

bool CVOICE::GetVoices(HWND listbox) {	//p\ȉXg{bNXɓo^

	if(FAILED(m_hr)) {	//CX^X쐬ɌĂԂ߁ARXgN^[̌ʂ`FbN
		MessageBoxW(0, L"Failed to get Default Voice token", L"SAPI Error", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	//PDftHgJeS[̎擾
	bool RetSign1 = FALSE;
	m_hr = m_pToken[0]->GetCategory(&m_pCategory);
	if(SUCCEEDED(m_hr)) {
		m_hr = m_pCategory->EnumTokens(0, 0, &m_pTokens);	//p\g[NQ̎擾
		if(SUCCEEDED(m_hr)) {
			//g[N̗
			DWORD i;							//JE^[ϐ
			LPWSTR ptVoiceID;					//IDւ̃|C^[
			m_hr = m_pTokens->GetCount(&m_Num_of_Token);	//g[Nij̎擾
			if(SUCCEEDED(m_hr)) {
				WCHAR Buff[MAX_PATH];
				for (i = 0; i < m_Num_of_Token; i++) {
					m_hr = m_pTokens->Item(i, &m_pToken[i]);
					m_hr = m_pToken[i]->GetId(&ptVoiceID);
					//ptVoiceIDm_TokenID[i]֎[iMAX_PATHj
					wcsncpy(m_TokenID[i], ptVoiceID, MAX_PATH);
					//m_TokenName[i]"Name"[
					lstrcpyW(m_TokenName[i], GetAttribute(ptVoiceID, L"Name"));
					//m_TokenGender[i]"Gender"[
					lstrcpyW(m_TokenGender[i], GetAttribute(ptVoiceID, L"Gender"));
					//m_TokenLanguage[i]"Language"[
					lstrcpyW(m_TokenLanguage[i], GetAttribute(ptVoiceID, L"Language"));
					wsprintfW(Buff, L"%s (a %s with the native language of %s)", m_TokenName[i], m_TokenGender[i], m_TokenLanguage[i]);
					SendMessageW(listbox, LB_INSERTSTRING, i, (LPARAM)Buff);
					CoTaskMemFree(ptVoiceID);
					RetSign1 = TRUE;
				}
			}
		}
	}
	//QDSpeech_OneCorẻJeS[̎擾
	bool RetSign2 = FALSE;
	ISpObjectTokenCategory* pCategory;
	IEnumSpObjectTokens* pTokens;
	HRESULT hr = CoCreateInstance(CLSID_SpObjectTokenCategory, NULL, CLSCTX_ALL, IID_ISpObjectTokenCategory, (void **)&pCategory);
	if(SUCCEEDED(hr)) {
		hr = pCategory->SetId(L"HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\Speech_OneCore\\Voices", FALSE);
		if(FAILED(hr))
			MessageBoxW(0, L"Can't set category id", L"OneCore - SetId", MB_OK | MB_ICONERROR);
		hr = pCategory->EnumTokens(0, 0, &pTokens);	//p\g[NQ̎擾
		if(SUCCEEDED(hr)) {
			//g[N̗
			DWORD n, i;							//擾pƃJE^[ϐ
			LPWSTR ptVoiceID;					//idւ̃|C^[
			hr = pTokens->GetCount(&n);			//g[Nij̎擾
			if(SUCCEEDED(hr)) {
				WCHAR Buff[MAX_PATH];
				for (i = 0; i < n; i++) {
					hr = pTokens->Item(i, &m_pToken[m_Num_of_Token + i]);
					hr = m_pToken[m_Num_of_Token + i]->GetId(&ptVoiceID);
					//ptVoiceIDm_TokenID[i]֎[iMAX_PATHj
					wcsncpy(m_TokenID[m_Num_of_Token + i], ptVoiceID, MAX_PATH);
					//m_TokenName[i]"Name"[
					lstrcpyW(m_TokenName[m_Num_of_Token + i], GetAttribute(ptVoiceID, L"Name"));
					//m_TokenGender[i]"Gender"[
					lstrcpyW(m_TokenGender[m_Num_of_Token + i], GetAttribute(ptVoiceID, L"Gender"));
					//m_TokenLanguage[i]"Language"[
					lstrcpyW(m_TokenLanguage[m_Num_of_Token + i], GetAttribute(ptVoiceID, L"Language"));
					wsprintfW(Buff, L"(OneCore) %s (a %s with the native language of %s)", m_TokenName[m_Num_of_Token + i], m_TokenGender[m_Num_of_Token + i], m_TokenLanguage[m_Num_of_Token + i]);
					SendMessageW(listbox, LB_INSERTSTRING, m_Num_of_Token + i, (LPARAM)Buff);
					CoTaskMemFree(ptVoiceID);
					RetSign2 = TRUE;
				}
				m_Num_of_Token += n;
			}
		}
		pCategory->Release();
		pCategory = NULL;
	}
	return RetSign1 * RetSign2;
}

//p\ȓ̉̌Ԃ
WCHAR* CVOICE::GetLanguage(DWORD num) {

	if(num > m_Num_of_Token)	//ISpObjectToken|C^[𒴂
		return NULL;
	else
		return m_TokenLanguage[num];
}

//p\ȓ̉̐ʂԂ
WCHAR* CVOICE::GetGender(DWORD num) {

	if(num > m_Num_of_Token)	//ISpObjectToken|C^[𒴂
		return NULL;
	else
		return m_TokenGender[num];
}

//p\ȉI
bool CVOICE::SetVoice(DWORD num) {

	if(num > m_Num_of_Token)	//ISpObjectToken|C^[𒴂
		return FALSE;
	if(SUCCEEDED(m_pVoice->SetVoice(m_pToken[num])))
		return TRUE;
	else
		return FALSE;
}

//XNvgǂ
HRESULT CVOICE::Speak(WCHAR* str) {

	SPVOICESTATUS status;
	m_pVoice->GetStatus(&status, NULL);
	if(!status.dwRunningState || status.dwRunningState == SPRS_IS_SPEAKING) {
		int ync = MessageBoxW(0, L"ݓǂݏグA܂͖ǃXNvgcĂ܂Bf܂H", L"TTS Busy", MB_YESNOCANCEL | MB_ICONQUESTION);
		if(ync == IDYES) {
			m_pVoice->Speak(L"<lang langid=\"411\">f܂</lang><lang langid=\"409\">All pendeling scripts abandoned</lang>", SPF_PURGEBEFORESPEAK, NULL);
		}
		else if(ync == IDCANCEL)
			return -1;	//HRESULTFAILED̈Ӗi32bitڂ1j
	}
	m_script = str;
	return m_pVoice->Speak(m_script.c_str(), SVSFlagsAsync, NULL);	//񓯊
//	return m_pVoice->Speak(m_script.c_str(), SVSFDefault, NULL);	//
}

//XNvgǂ
HRESULT CVOICE::Speak(wstring script) {

	SPVOICESTATUS status;
	m_pVoice->GetStatus(&status, NULL);
	if(!status.dwRunningState || status.dwRunningState == SPRS_IS_SPEAKING) {
		int ync = MessageBoxW(0, L"ݓǂݏグA܂͖ǃXNvgcĂ܂Bf܂H", L"TTS Busy", MB_YESNOCANCEL | MB_ICONQUESTION);
		if(ync == IDYES) {
			m_pVoice->Speak(L"<lang langid=\"411\">f܂</lang><lang langid=\"409\">All pendeling scripts abandoned</lang>", SPF_PURGEBEFORESPEAK, NULL);
		}
		else if(ync == IDCANCEL)
			return -1;	//HRESULTFAILED̈Ӗi32bitڂ1j
	}
	m_script = script;
	return m_pVoice->Speak(m_script.c_str(), SVSFlagsAsync, NULL);	//񓯊
//	return m_pVoice->Speak(m_script.c_str(), SVSFDefault, NULL);	//
}

//ǂݏグ̒f
void CVOICE::Pause() {

	m_pVoice->Pause();
}

//ǂݏグ̍ĊJ
void CVOICE::Resume() {

	m_pVoice->Resume();
}
