//-------------------------
//         CSTRW.h
//   Copyright April 2022
//     By K. Yoshida
//      Version 1.0A
//Fgpɂwchar.hKv
//-------------------------
#ifndef	_CSTRW_
#define _CSTRW_

class CSTRW {

	WCHAR*	m_str;

public:
	CSTRW();									//RXgN^[ij
	CSTRW(const WCHAR*);						//RXgN^[ij
	CSTRW(const CSTRW&);						//RXgN^[iCSTRWj
	CSTRW(const long);							//RXgN^[ij
	~CSTRW();									//fXgN^[
	CSTRW& operator = (const CSTRW&);			//operator = (B) ---> = B;
	CSTRW& operator = (const long);				//operator = (B) ---> = B;
	WCHAR* ToChar() {return m_str;}				//|C^[ƂĕԂ
	void Print();								//m_str󎚂
	friend CSTRW operator + (const CSTRW&, const CSTRW&);	//A operator + (B)  --->= A + B;
	friend bool operator == (const CSTRW&, const CSTRW&);	//A operator == (B) --->= A == B;
	friend bool operator == (const CSTRW&, const WCHAR*);	//A operator == (B) --->= A == B;
	friend bool operator != (const CSTRW&, const CSTRW&);	//A operator == (B) --->= A != B;
	friend bool operator != (const CSTRW&, const WCHAR*);	//A operator == (B) --->= A != B;
	bool FromFile(WCHAR*, WCHAR*, HWND);		//t@C̓Ǎ
	bool FromFile(WCHAR*);						//t@C̓Ǎ
	bool ToFile(WCHAR*, WCHAR*, HWND);			//t@Cւ̏
	bool ToFile(WCHAR*);						//t@Cւ̏
	bool ToUTF8File(WCHAR*, bool);				//t@Cւ̏݁iboolBOML̃tOj
	bool Next(CSTRW&);							//m_str̒P؂o
	bool GetLine(CSTRW&);						//̍s܂Ői
	bool NextLine();							//̍s܂Ői
	WCHAR* Find(WCHAR*, WCHAR*);				//̌
};

//RXgN^[ij
CSTRW::CSTRW() {

	m_str = new WCHAR[1];
	*m_str = L'\0';
}

//RXgN^[ij
CSTRW::CSTRW(const WCHAR* string) {

	m_str = new WCHAR[lstrlenW(string) + 1];
	lstrcpyW(m_str, string);
}

//RXgN^[iCSTRWj
CSTRW::CSTRW(const CSTRW& cst) {

	m_str = new WCHAR[lstrlenW(cst.m_str) + 1];
	lstrcpyW(m_str, cst.m_str);
}

//RXgN^[ij
CSTRW::CSTRW(const long i) {

	WCHAR sbuff[MAX_PATH / 8];
	wsprintfW(sbuff, L"%d", i);
	m_str = new WCHAR[lstrlenW(sbuff) + 1];
	lstrcpyW(m_str, sbuff);
}

//fXgN^[
CSTRW::~CSTRW() {

	delete [] m_str;
}

//CSTRW̑
CSTRW& CSTRW::operator = (const CSTRW& cst) {

	if(&cst != this) {	//You can't copy yourself
		delete [] m_str;
		m_str = new WCHAR[lstrlenW(cst.m_str) + 1];
		lstrcpyW(m_str, cst.m_str);
	}
	return *this;
}

//̑
CSTRW& CSTRW::operator = (const long i) {

	WCHAR sbuff[MAX_PATH / 8];
	wsprintfW(sbuff, L"%d", i);
	m_str = new WCHAR[lstrlenW(sbuff) + 1];
	lstrcpyW(m_str, sbuff);
	return *this;
}

//m_str󎚂
void CSTRW::Print() {

	MessageBoxW(NULL, m_str, L"CSTRW Message", MB_OK);
}

//ǉZq̒`
CSTRW operator + (const CSTRW& cst1, const CSTRW& cst2) {

	CSTRW strw;
	delete [] strw.m_str;
	strw.m_str = new WCHAR[lstrlenW(cst1.m_str) + lstrlenW(cst2.m_str) + 1];
	lstrcpyW(strw.m_str, cst1.m_str);
	lstrcatW(strw.m_str, cst2.m_str);
	return strw;
}

//rZq̒`iPj
bool operator == (const CSTRW& cst1, const CSTRW& cst2) {

	return !lstrcmpW(cst1.m_str, cst2.m_str);
}

//rZq̒`iQj
bool operator == (const CSTRW& cst, const WCHAR* str) {

	return !lstrcmpW(cst.m_str, str);
}

//rZq̒`iRj
bool operator != (const CSTRW& cst1, const CSTRW& cst2) {

	return lstrcmpW(cst1.m_str, cst2.m_str);
}

//rZq̒`iSj
bool operator != (const CSTRW& cst, const WCHAR* str) {

	return lstrcmpW(cst.m_str, str);
}

//t@C̓Ǎ
bool CSTRW::FromFile(WCHAR* Filter, WCHAR* FilePath, HWND hWnd = NULL) {

	WCHAR FileName[MAX_PATH];
	WCHAR file_path[MAX_PATH];
	lstrcpyW(file_path, FilePath);	//Default Path
	OPENFILENAMEW ofn;				//I[vt@C_CAO\
	//I[vt@C_CAOŃt@C擾
	FileName[0] = NULL;
	ZeroMemory(&ofn, sizeof(ofn));	//[
	ofn.lStructSize		= sizeof(ofn);
	ofn.hwndOwner		= hWnd;
	ofn.lpstrFilter		= Filter;
	ofn.nFilterIndex	= 1;
	ofn.lpstrFile		= FileName;
	ofn.nMaxFile		= MAX_PATH;
	if(!*FilePath)					//KlNULLłΌ݂̃fBNg[
		GetCurrentDirectoryW(MAX_PATH, file_path);
	else
		lstrcpyW(file_path, FilePath);
	ofn.lpstrInitialDir = file_path;
	ofn.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
	if(!GetOpenFileNameW(&ofn))	return FALSE;		//ǂݍ݌
	//t@Cǂݍ
	BOOL bSuccess = FALSE;
	HANDLE hFile;
	hFile = CreateFileW(FileName, GENERIC_READ, FILE_SHARE_READ, NULL,
						OPEN_EXISTING, NULL, NULL);	//t@CǍ݂ŃI[v
	if(hFile != INVALID_HANDLE_VALUE) {				//I[vł
		DWORD dwFileSize = GetFileSize(hFile, NULL);
		if(dwFileSize != 0xFFFFFFFF) {				//-1(0xFFFFFFFF)G[
			LPBYTE Buff;							//ǂݍ݃obt@p|C^[
			Buff = new BYTE[dwFileSize];
			DWORD dwRead;
			if(ReadFile(hFile, Buff, dwFileSize, &dwRead, NULL)) {
				bSuccess = TRUE; //ǂݍݐ
			}
			if(Buff[0] == 0xFF && Buff[1] == 0xFE) {//UTF-16AUTF-32BOM`FbN
				if(Buff[2] | Buff[3]) {				//NULLł͂ȂUTF-16BOM
					delete [] m_str;				//̕p
					//BOMȍ~̓ǂݍ񂾃f[^悤ɂ
					m_str = new WCHAR[dwFileSize / sizeof(WCHAR)];
					CopyMemory(m_str, Buff + 2, dwFileSize - 2);
					//Ô߁Aobt@̏I[NULLu
					m_str[(dwFileSize - 2) / sizeof(WCHAR) - 1] = L'\0';
				}
				else {	//Buff[2]Buff[3])NULLUTF-32BOMi܂UTF-16NULL݂̂̃t@C̏ꍇj
					bSuccess = FALSE;	//UTF-32BOM̏ꍇAǂݍݎs
				}
			}
			else if(Buff[0] == 0xEF && Buff[1] == 0xBB && Buff[2] == 0xBF) {	//UTF-8BOM`FbN
				int iBuffSize = MultiByteToWideChar(CP_UTF8, MB_ERR_INVALID_CHARS, (LPCCH)(Buff + 3), -1, NULL, NULL);
				if(iBuffSize) {	//UTF-8̏ꍇ
					//m_strp[̊m
					if(m_str)
						delete [] m_str;
					m_str = new WCHAR[iBuffSize];
					//UTF8WCHAR֕ϊ
					MultiByteToWideChar(CP_UTF8, MB_ERR_INVALID_CHARS, (LPCCH)(Buff + 3), -1, m_str, iBuffSize);
				}
				else {					//BOMtUTF-8ŕϊs\ȏꍇ
					bSuccess = FALSE;	//ǂݍݎs
				}
			}
			else {						//UTF-16A32A8BOMȂꍇ
				//悸BOMUTF-8ۂ`FbN
				int iBuffSize = MultiByteToWideChar(CP_UTF8, MB_ERR_INVALID_CHARS, (LPCCH)(Buff), -1, NULL, NULL);
				if(iBuffSize) {			//BOMUTF-8̏ꍇ
					//m_strp[̊m
					if(m_str)
						delete [] m_str;
					m_str = new WCHAR[iBuffSize];
					//UTF8WCHAR֕ϊ
					MultiByteToWideChar(CP_UTF8, MB_ERR_INVALID_CHARS, (LPCCH)(Buff), -1, m_str, iBuffSize);
				}
				else {					//BOMAUTF-8ϊłȂꍇuۂ̂݁v
					m_str = new WCHAR[dwFileSize / sizeof(WCHAR) + 1];
					CopyMemory(m_str, Buff, dwFileSize);
					//Ô߁Aobt@̏I[NULLu
					m_str[dwFileSize / sizeof(WCHAR)] = L'\0';
				}
			}
			delete [] Buff;							//ǂݍ݃obt@
		}
		CloseHandle(hFile);							//t@C̃N[Y
	}
	return bSuccess;
}

//t@C̓Ǎ
bool CSTRW::FromFile(WCHAR* FileName) {

	BOOL bSuccess = FALSE;
	HANDLE hFile;
	hFile = CreateFileW(FileName, GENERIC_READ, FILE_SHARE_READ, NULL,
						OPEN_EXISTING, NULL, NULL);	//t@CǍ݂ŃI[v
	if(hFile != INVALID_HANDLE_VALUE) {				//I[vł
		DWORD dwFileSize = GetFileSize(hFile, NULL);
		if(dwFileSize != 0xFFFFFFFF) {				//-1(0xFFFFFFFF)G[
			LPBYTE Buff;							//ǂݍ݃obt@p|C^[
			Buff = new BYTE[dwFileSize];
			DWORD dwRead;
			if(ReadFile(hFile, Buff, dwFileSize, &dwRead, NULL)) {
				bSuccess = TRUE; //ǂݍݐ
			}
			if(Buff[0] == 0xFF && Buff[1] == 0xFE) {//UTF-16AUTF-32BOM`FbN
				if(Buff[2] | Buff[3]) {				//NULLł͂ȂUTF-16BOM
					delete [] m_str;				//̕p
					//BOMȍ~̓ǂݍ񂾃f[^悤ɂ
					m_str = new WCHAR[dwFileSize / sizeof(WCHAR)];
					CopyMemory(m_str, Buff + 2, dwFileSize - 2);
					//Ô߁Aobt@̏I[NULLu
					m_str[(dwFileSize - 2) / sizeof(WCHAR) - 1] = L'\0';
				}
				else {	//Buff[2]Buff[3])NULLUTF-32BOMi܂UTF-16NULL݂̂̃t@C̏ꍇj
					bSuccess = FALSE;	//UTF-32BOM̏ꍇAǂݍݎs
				}
			}
			else if(Buff[0] == 0xEF && Buff[1] == 0xBB && Buff[2] == 0xBF) {	//UTF-8BOM`FbN
				int iBuffSize = MultiByteToWideChar(CP_UTF8, MB_ERR_INVALID_CHARS, (LPCCH)(Buff + 3), -1, NULL, NULL);
				if(iBuffSize) {	//UTF-8̏ꍇ
					//m_strp[̊m
					if(m_str)
						delete [] m_str;
					m_str = new WCHAR[iBuffSize];
					//UTF8WCHAR֕ϊ
					MultiByteToWideChar(CP_UTF8, MB_ERR_INVALID_CHARS, (LPCCH)(Buff + 3), -1, m_str, iBuffSize);
				}
				else {					//BOMtUTF-8ŕϊs\ȏꍇ
					bSuccess = FALSE;	//ǂݍݎs
				}
			}
			else {						//UTF-16A32A8BOMȂꍇ
				//悸BOMUTF-8ۂ`FbN
				int iBuffSize = MultiByteToWideChar(CP_UTF8, MB_ERR_INVALID_CHARS, (LPCCH)(Buff), -1, NULL, NULL);
				if(iBuffSize) {			//BOMUTF-8̏ꍇ
					//m_strp[̊m
					if(m_str)
						delete [] m_str;
					m_str = new WCHAR[iBuffSize];
					//UTF8WCHAR֕ϊ
					MultiByteToWideChar(CP_UTF8, MB_ERR_INVALID_CHARS, (LPCCH)(Buff), -1, m_str, iBuffSize);
				}
				else {					//BOMAUTF-8ϊłȂꍇuۂ̂݁v
					m_str = new WCHAR[dwFileSize / sizeof(WCHAR) + 1];
					CopyMemory(m_str, Buff, dwFileSize);
					//Ô߁Aobt@̏I[NULLu
					m_str[dwFileSize / sizeof(WCHAR)] = L'\0';
				}
			}
			delete [] Buff;							//ǂݍ݃obt@
		}
		CloseHandle(hFile);							//t@C̃N[Y
	}
	return bSuccess;
}

//t@Cւ̏݁iKlUTF-16 gGfBAj
bool CSTRW::ToFile(WCHAR* Filter, WCHAR* DefExt, HWND hWnd = NULL) {

	WCHAR FileName[MAX_PATH];
	WCHAR file_path[MAX_PATH];
	OPENFILENAMEW ofn;				//I[vt@C_CAO\
	//I[vt@C_CAOŃt@C擾
	ZeroMemory(&ofn, sizeof(ofn));	//[
	FileName[0] = NULL;
	ofn.lStructSize		= sizeof(ofn);
	ofn.hwndOwner		= hWnd;
	ofn.lpstrFilter		= Filter;
	ofn.nFilterIndex	= 1;
	ofn.lpstrFile		= FileName;
	ofn.nMaxFile		= MAX_PATH;
	ofn.lpstrInitialDir = L".";
	ofn.lpstrDefExt		= DefExt;	//ftHg̊gq
	ofn.Flags = OFN_EXPLORER | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY |
				OFN_OVERWRITEPROMPT;
	if(!GetSaveFileNameW(&ofn))	return FALSE;;
	//t@C
	BOOL bSuccess = FALSE;
	HANDLE hFile;
	hFile = CreateFileW(FileName, GENERIC_WRITE, NULL, NULL,	//t@C݂ŃI[v
						CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile != INVALID_HANDLE_VALUE) {		//I[vł
		//obt@當񒷎擾ANULLI[Z
		DWORD dwTextLength = (lstrlenW(m_str) + 1) * sizeof(WCHAR);
		DWORD dwWritten;
		//BOM̏ - WindowsIntelnUTF-16 FF FEigGfBAj
		BYTE BOM[2] = {0xFF, 0xFE};
		if(WriteFile(hFile, BOM, 2, &dwWritten, NULL)) {
			WriteFile(hFile, m_str, dwTextLength, &dwWritten, NULL);
			bSuccess = TRUE;	//ݐ
		}
		CloseHandle(hFile);			//t@C̃N[Y
	}
	return bSuccess;
}

//t@Cւ̏݁iKlUTF-16 gGfBAj
bool CSTRW::ToFile(WCHAR* FileName) {

	BOOL bSuccess = FALSE;
	HANDLE hFile;
	hFile = CreateFileW(FileName, GENERIC_WRITE, NULL, NULL,	//t@C݂ŃI[v
						CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile != INVALID_HANDLE_VALUE) {		//I[vł
		//obt@當񒷎擾ANULLI[Z
		DWORD dwTextLength = (lstrlenW(m_str) + 1) * sizeof(WCHAR);
		DWORD dwWritten;
		//BOM̏ - WindowsIntelnUTF-16 FF FEigGfBAj
		BYTE BOM[2] = {0xFF, 0xFE};
		if(WriteFile(hFile, BOM, 2, &dwWritten, NULL)) {
			WriteFile(hFile, m_str, dwTextLength, &dwWritten, NULL);
			bSuccess = TRUE;	//ݐ
		}
		CloseHandle(hFile);			//t@C̃N[Y
	}
	return bSuccess;
}

//UTF-8t@Cւ̏݁iboolBOML̃tOj
bool CSTRW::ToUTF8File(WCHAR* FileName, bool bom = TRUE) {

	BOOL bSuccess = FALSE;
	HANDLE hFile;
	hFile = CreateFileW(FileName, GENERIC_WRITE, NULL, NULL,	//t@C݂ŃI[v
						CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile != INVALID_HANDLE_VALUE) {		//I[vł
		//WCHARUTF8֕ϊۂ̕񒷁ioCgj擾
		DWORD dwBuffSize = WideCharToMultiByte(CP_UTF8, WC_ERR_INVALID_CHARS, m_str, -1, NULL, NULL, NULL, NULL);
		if(!dwBuffSize) {
			CloseHandle(hFile);				//t@C̃N[Y
			return FALSE;
		}
		//UTF-8p[̊m
		char* utf8 = new char[dwBuffSize];
		//WCHARUTF8֕ϊ
		WideCharToMultiByte(CP_UTF8, WC_ERR_INVALID_CHARS, m_str, -1, utf8, dwBuffSize, NULL, NULL);
		//UTF-8̏
		DWORD dwWritten;
		if(bom) {	//BOML
			//BOM̏ - UTF-8 0xEF 0xBB 0xBF
			BYTE BOM[3] = {0xEF, 0xBB, 0xBF};
			if(WriteFile(hFile, BOM, 3, &dwWritten, NULL)) {
				WriteFile(hFile, utf8, dwBuffSize, &dwWritten, NULL);
				bSuccess = TRUE;	//ݐ
			}
		}
		else {		//BOM
			if(WriteFile(hFile, utf8, dwBuffSize, &dwWritten, NULL))
				bSuccess = TRUE;	//ݐ
		}
		delete [] utf8;				//UTF-8񃁃[̊J
		CloseHandle(hFile);			//t@C̃N[Y
	}
	return bSuccess;
}

//m_str̒P؂o
bool CSTRW::Next(CSTRW& destination) {

	CSTRW str;
	delete [] str.m_str;
	str.m_str = new WCHAR[lstrlenW(m_str) + 1];
	WCHAR* ptr = m_str;
	WCHAR* des = str.m_str;
	bool Terminate = TRUE;
	//Xy[X̓XLbv
	while(iswspace(*ptr) || *ptr == L'@' || *ptr == L',') {
			ptr++;						//XLbvXy[X
	}
	//Xy[X𒲂ׂ
	while(!iswspace(*ptr)) {			//Xy[XłȂ
		if(!*ptr) {						//NULLI[ȂFALSEԂ
			Terminate = FALSE;
			break;
		}
		else if(*ptr == L'@') {
			break;						//Sp"@"ȂI
		}
		else if(*ptr == L',') {
			ptr++;						//','XLbvĎ̕܂Ői
			break;						//󔒕
		}
		else if(*ptr == L'"') {
			ptr++;						//'"'XLbvĒgo
			while(*ptr != L'"') {		//'"'Ȃ'"'܂Ői
				if(!*ptr) {				//NULLI[ȂFALSEԂ
					Terminate = FALSE;
					break;
				}
				*des = *ptr;
				ptr++;	des++;
			}
			ptr++;						//\[X|C^[͎̕֐i߂
			break;						//[v𔲂ăfXeBl[VNULL
		}
		else if(*ptr == L'/' && *(ptr + 1) == L'*') {
			ptr++;	ptr++;				//"/*`*/"Rg
			while(!(*ptr == L'*' && *(ptr + 1) == L'/')) {
				if(!*ptr) {				//NULLI[ȂFALSEԂ
					Terminate = FALSE;
					break;
				}
				ptr++;
			}
			ptr++;	ptr++;
			//ēxXy[XXLbv
			while(iswspace(*ptr) || *ptr == L'@' || *ptr == L',') {
				if(!*ptr) {				//NULLI[ȂFALSEԂ
					Terminate = FALSE;
					break;
				}
				ptr++;				//XLbvXy[X
			}
			continue;
		}
		else if(*ptr == L'/' && *(ptr + 1) == L'/') {
			while(*ptr != L'\n') {		//"//"Rg
				if(!*ptr) {				//NULLI[ȂFALSEԂ
					Terminate = FALSE;
					break;
				}
				ptr++;
			}
			while(iswspace(*ptr) || *ptr == L'@' || *ptr == L',') {
				if(!*ptr) {				//NULLI[ȂFALSEԂ
					Terminate = FALSE;
					break;
				}
				ptr++;				//XLbvXy[X
			}
			continue;
		}
		else {
			*des = *ptr;
		}
		ptr++;	des++;
	}
	*des = L'\0';

	destination = str;			//destinationɐ؂
	str = ptr;					//strm_striptrȍ~̕
	delete [] m_str;
	m_str = new WCHAR[lstrlenW(str.m_str) + 1];
	lstrcpyW(m_str, str.m_str);	//m_strɂ͐؂̕񂪓
	if(*str.m_str || *destination.m_str)
		Terminate = TRUE;		//cNULLł؂񂪂Α
	else
		Terminate = FALSE;		//NULLȂI
	return Terminate;			//stOԂ
}

//̍s܂Ői
bool CSTRW::GetLine(CSTRW& destination) {

	bool Terminate = TRUE;
	WCHAR* ptr = m_str;
	WCHAR* des = ptr;
	while(*des && *des != L'\n')
		des++;
	if(!*des) {
		destination = L"";
		Terminate = FALSE;	//̏ITC
	}
	else {
		*des = L'\0'; des++;				//NULLI[Ai߂
		delete [] destination.m_str;
		destination.m_str = new WCHAR[des - ptr + 1];
		lstrcpyW(destination.m_str, ptr);
		destination.m_str[des - ptr - 1] = L'\n';	//NULLɂ'\n't
		destination.m_str[des - ptr] = L'\0';		//NULLI[
	}
	if(Terminate) {					//܂񂪂Ύc
		CSTRW str = des;
		delete [] m_str;
		m_str = new WCHAR[lstrlenW(str.m_str) + 1];
		lstrcpyW(m_str, str.m_str);	//m_strɂ͐؂̕񂪓
	}
	if(*destination.m_str)			//NULLɏoA
		Terminate = TRUE;			//؂񂪂Α
	else
		Terminate = FALSE;			//NULLȂI
	return Terminate;				//stOԂ
}

//̍s܂Ői
bool CSTRW::NextLine() {

	WCHAR* ptr = m_str;
	while(*ptr != L'\n') {		//sR[h܂Ői
		if(!*ptr) {				//rNULLI[ȂFALSEԂ
			return FALSE;
		}
		ptr++;
	}
	ptr++;
	CSTRW str = ptr;
	delete [] m_str;
	m_str = new WCHAR[lstrlenW(str.m_str) + 1];
	lstrcpyW(m_str, str.m_str);	//m_strɂ͐؂̕񂪓
	return TRUE;				//stOԂ
}

//̌
WCHAR* CSTRW::Find(WCHAR* ToFind, WCHAR* sp = 0) {

	if(!sp)
		sp = m_str;
	return StrStrW(sp, ToFind);
}

#endif
