//////////////////////////////////////////////////////////////////
// Class of MENACE (Machine Educable Noughts And Crosses Engine)
// for the use of Noughts and Crosses or "tic-tac-toe"
// Copyright (c) by Ysama, 2021
/////////////////////////////////////////////////////////////////

#include	<vector>
#include	<algorithm>
using namespace std;

//CBOARDNXwb_[
#include	"CBOARD.h"

////////////////////////
//CMENACENXwb_[
////////////////////////
class CMENACE : public CBOARD {
private:						//CMENACEpĂpłȂ
	vector <BOARD> m_BoardDB;
	vector <BOARD>::iterator m_Itr;
public:
	//֐
	bool AutoMove(char);		//Ŏł
	void Register();			//Ֆʂ̓o^
	void PushBack();			//Oɖ߂s҂m_Outcome֑
	int Search(BOARD);			//Ֆʂ̌i߂lF0|YȂA1|A2|j
	int BoardCmp(char*, char*);	//Ֆʔri߂lstrcmp(char*, char*)Ɠj
	void Rotate(char*);			//ՂE90x]
	void Mirror(char*);			//ՂE]
	int DBSize();				//DB̃f[^Ԃ
//	void DBSort();				//DB̃f[^m_PosL[ɏŃ\[g
//	void DBShow();				//DB̃f[^\
	bool BoardWrite(char*);		//DBf[^̏
	bool BoardRead(char*);		//DBf[^̓ǂݍ
};

//Ŏł
bool CMENACE::AutoMove(char you) {

	//ϐ
	BOARD work = m_Board;			//ΐՂ̕ʂƗpՂɂ
	int* vac = CheckBoard();		//݂̋󂫈ʒuz擾
	int pos[10];					//m_BoardDBɊYȂ󂫈ʒuz
	pos[9] = 0;						//pos[9]Ɏc󂫈ʒu
	//󂫈ʒuɎłꍇ̕]i1ǂށj
	for(int i  = 0, j = 0; i < vac[9]; i++) {
		work.m_Pos[vac[i]] = you;	//󂫈ʒuɎiyouj̎ł
		switch(Search(work)) {
		case 0:	//YȂ
			pos[j] = vac[i];		//󂫈ʒuposɓ
			j++;					//poszw
			pos[9]++;				//̐pos[9]ɋL^
			break;
		case 1:	//菟
			if(you == 1) {
				MakeMove(vac[i], you);	//youɗLȎł
				return true;
			}						//L̏ꍇvac[i]₩痎Ƃ
			break;
		case 2:	//菟
			if(you == 2) {
				MakeMove(vac[i], you);	//youɗLȎł
				return true;
			}						//L̏ꍇvac[i]₩痎Ƃ
			break;
		case -1:	//sk|肪ׂՕł₩Oi̔Օł͂Ȃj
		case -2:	//sk|肪ׂՕł₩Oi̔Օł͂Ȃj
			break;
		}
		work.m_Pos[vac[i]] = 0;		//ł󂫈ʒui0jɖ߂
	}
	//ȉłvacz񂩂瑊LȈʒu󂫈ʒuiposzjg
	if(!pos[9]) {					//vacz̑SĂ̌₪Lőłׂ󂫈ʒu
		m_Board.m_Outcome = -you;	//ȂדȂ̂m_OutcomeɃ}CiXl
		return false;				//̌㌻݂̔ՖʂDBo^i2ǂ݂ƂȂj
	}
	else {
		int i = pos[rand() % pos[9]];	//m_BoardDBɊYȂ󂫈ʒu𗐐őI
		MakeMove(i, you);			//ł
		RecMove(i);					//ŎL^
		return true;
	}
}

//Ֆʂ̓o^|m_Board.m_Outcome͏ҁi+jAsҁi-j
void CMENACE::Register() {

	//݂̔Ֆʁim_BoardjƓl̂̂Γo^
	if(!Search(m_Board))
		m_BoardDB.push_back(m_Board);
}

//Oɖ߂sҁi-jm_Outcome֑
void CMENACE::PushBack() {

	//ӁFIsOver()̌ʁAm_OutcomȅꍇKp
	//AutMove()́uvm_OutcomeƂȂ
	m_Board.m_Pos[m_LastMove] = 0;
	if(m_Board.m_Outcome == FIRST)
		m_Board.m_Outcome = -SECOND;
	else
		m_Board.m_Outcome = -FIRST;
}

//Ֆʂ̌i߂lF0|YȂA1|菟A2|菟A-1|skA-2|skj
//m_Board.m_Pos̔Ղ4E90x]A]4E90x]A
//XɐAւi]͋tƂȂjēľs
int CMENACE::Search(BOARD work) {

	int found = 0;						//l(YȂj
	//o^ꂽՖʂ
	for(m_Itr = m_BoardDB.begin(); m_Itr != m_BoardDB.end(); m_Itr++) {
		for(int j = 0; j < 4; j++) {	//4񂵂Čɖ߂
			if(!BoardCmp(work.m_Pos, m_Itr->m_Pos)) {
				found = m_Itr->m_Outcome;
				return found;
			}
			Rotate(work.m_Pos);
		}
		Mirror(work.m_Pos);				//Ֆʂ𔽓]
		for(int j = 0; j < 4; j++) {	//4񂵂Čɖ߂
			if(!BoardCmp(work.m_Pos, m_Itr->m_Pos)) {
				found = m_Itr->m_Outcome;
				return found;
			}
			Rotate(work.m_Pos);
		}
	}
	return found;
}

//Ֆʔri߂lstrcmp(char*, char*)Ɠj
int CMENACE::BoardCmp(char* bd1, char* bd2) {

	int i;
	for(i = 0; i < 9; i++) {
		if(bd1[i] != bd2[i])
			break;
	}
	return (bd1[i] - bd2[i]);
}

//ՖʂE90x]iړIj
//	-------		-------
//	|0|1|2|		|6|3|0|
//	-------		-------
//	|3|4|5|	|7|4|1|
//	-------		-------
//	|6|7|8|		|8|5|2|
//	-------		-------
void CMENACE::Rotate(char* bd) {

	char c = bd[0];
	bd[0] = bd[6];
	bd[6] = bd[8];
	bd[8] = bd[2];
	bd[2] = c;
	c = bd[3];
	bd[3] = bd[7];
	bd[7] = bd[5];
	bd[5] = bd[1];
	bd[1] = c;
}

//ՂE]
//	-------		-------
//	|0|1|2|		|2|1|0|
//	-------		-------
//	|3|4|5|	|5|4|3|
//	-------		-------
//	|6|7|8|		|8|7|6|
//	-------		-------
void CMENACE::Mirror(char* bd) {

	swap(bd[0], bd[2]);
	swap(bd[3], bd[5]);
	swap(bd[6], bd[8]);
}

//DB̃f[^Ԃ
int CMENACE::DBSize() {

	return m_BoardDB.size();
}

/*
//DB̃f[^m_PosL[ɏŃ\[g
//BDCmp͏pr֐ix < y)TRUEƂȂ
bool BDCmp(const BOARD& x, const BOARD& y) {
	int i;
	for(i = 0; i < 9; i++) {
		if(x.m_Pos[i] != y.m_Pos[i])
			break;
	}
	return ((x.m_Pos[i] - y.m_Pos[i]) < 0);
}
//BDCmpgsort֐g
void CMENACE::DBSort() {

	sort(m_BoardDB.begin(), m_BoardDB.end(), BDCmp);
}
*/
/*
//DB̃f[^\
void CMENACE::DBShow() {

	for(m_Itr = m_BoardDB.begin(); m_Itr != m_BoardDB.end(); m_Itr++) {
		cout << "-------" << endl;
		for(int i = 0; i < 9; i++) {
			char c;
			switch(m_Itr->m_Pos[i]) {
			case 0:
				c = ' ';
				break;
			case 1:
				c = 'O';
				break;
			case 2:
				c = 'X';
				break;
			}
			cout << "|" << c;
			if((i % 3) == 2)
				cout << "|" << endl << "-------" << endl;
		}
	}
}
*/

bool CMENACE::BoardWrite(char* fn) {

	BOARD board;
	int num = DBSize();
	HANDLE hFile = CreateFile(fn, GENERIC_WRITE,
				FILE_SHARE_WRITE, NULL,
				OPEN_ALWAYS, NULL, NULL);	//t@CŃI[v
	if(hFile != INVALID_HANDLE_VALUE) {		//I[vł
		DWORD dwWrite;
		//悸intŃf[^
		WriteFile(hFile, &num, sizeof(int), &dwWrite, NULL);
		m_Itr = m_BoardDB.begin();
		//BOARD̔z
		for(int i = 0; i < num; i++, m_Itr++) {
			board = *m_Itr;
			WriteFile(hFile, &board, sizeof(board), &dwWrite, NULL);
		}
		CloseHandle(hFile);				//t@C̃N[Y
		return TRUE;
	}
	else
		return FALSE;
}

bool CMENACE::BoardRead(char* fn) {

	BOARD board;
	int num;
	HANDLE hFile = CreateFile(fn, GENERIC_READ,
				FILE_SHARE_READ, NULL,
				OPEN_EXISTING, NULL, NULL);	//t@CǍŃI[v
	if(hFile != INVALID_HANDLE_VALUE) {		//I[vł
		m_BoardDB.clear();					//m_BoardDB̃f[^ɂ
		DWORD dwRead;
		//悸int numɃf[^ǂݍ
		ReadFile(hFile, &num, sizeof(int), &dwRead, NULL);
		m_Itr = m_BoardDB.begin();
		for(int i = 0; i < num; i++) {
			ReadFile(hFile, &board, sizeof(board), &dwRead, NULL);
			m_BoardDB.push_back(board);
		}
		CloseHandle(hFile);				//t@C̃N[Y
		return TRUE;
	}
	else
		return FALSE;
}
