///////////////////////////////////
// Maintenance Class for MENACE DB
///////////////////////////////////
#include	<vector>	//vectorgp̈
#include	<string>	//stringgp̈
#include	<windows.h>	//Win32(WriteFile, ReadFile)gp̈
#include	<algorithm>	//sortgp̈

using namespace std;

typedef struct _board {
	char m_Pos[9];
	//	-------		Ֆʂm_Pos[0]-[8]charzg
	//	|0|1|2|		ꂪMENACẼr[Yɑ
	//	-------
	//	|3|4|5|
	//	-------
	//	|6|7|8|
	//	-------
	int m_Outcome;	//DBo^p]f[^i菟(1, -1)A菟(2, -2)j
} BOARD, *PBOARD;

class CMENACEDB {
public:
	//iXf[^x[Xpϐ
	vector <BOARD> m_BoardDB;
	vector <BOARD>::iterator m_Itr1, m_Itr2;
	//iXeiXp֐
	int BoardCmp(char*, char*);	//Ֆʔri߂lstrcmp(char*, char*)Ɠj
	void Rotate(char*);			//ՂE90x]
	void Mirror(char*);			//ՂE]
	int DBSize();				//DB̃f[^Ԃ
	bool CheckDup();			//o^f[^̏d`FbN
	void Count(int&, int&, int&, int&);	//sʂ̏Wv
	void DBSort();				//DB̃f[^m_PosL[ɏŃ\[g
	void DBShow(int);			//DB̃f[^\
	void DBList();				//DB̃f[^Xg\
	bool BoardWrite(char*);		//BOARD̏
	bool BoardRead(char*);		//BOARD̓ǂݍ
};

//Ֆʔri߂lstrcmp(char*, char*)Ɠj
int CMENACEDB::BoardCmp(char* bd1, char* bd2) {

	int i;
	for(i = 0; i < 9; i++) {
		if(bd1[i] != bd2[i])
			break;
	}
	return (bd1[i] - bd2[i]);
}

void CMENACEDB::Rotate(char* bd) {

	char c = bd[0];
	bd[0] = bd[6];
	bd[6] = bd[8];
	bd[8] = bd[2];
	bd[2] = c;
	c = bd[3];
	bd[3] = bd[7];
	bd[7] = bd[5];
	bd[5] = bd[1];
	bd[1] = c;
}

//ՂE]
//	-------		-------
//	|0|1|2|		|2|1|0|
//	-------		-------
//	|3|4|5|	|5|4|3|
//	-------		-------
//	|6|7|8|		|8|7|6|
//	-------		-------
void CMENACEDB::Mirror(char* bd) {

	swap(bd[0], bd[2]);
	swap(bd[3], bd[5]);
	swap(bd[6], bd[8]);
}

//DB̃f[^Ԃ
int CMENACEDB::DBSize() {

	return m_BoardDB.size();
}

//o^f[^̏d`FbN
bool CMENACEDB::CheckDup() {
	
	int i, j;
	bool res = TRUE;
	m_Itr1 = m_BoardDB.begin();
	for(i = 0; m_Itr1 != m_BoardDB.end(); m_Itr1++, i++) {
		for(m_Itr2 = m_Itr1 + 1, j = 1; m_Itr2 != m_BoardDB.end(); m_Itr2++, j++) {
			for(int k = 0; k < 4; k++) {						//4񂵂Čɖ߂
				if(!BoardCmp(m_Itr1->m_Pos, m_Itr2->m_Pos)) {	//d
					cout << "DB" << i << "ԗvf̏df[^" << j << "Ԗڂ̃f[^̑" << k << "]Ɍ܂B" << endl;
					//Kvɉč폜
					res = FALSE;
				}
			}
			Rotate(m_Itr1->m_Pos);								//4]̂Ōɖ߂
		}
		Mirror(m_Itr1->m_Pos);									//Ֆʂ𔽓]
		for(m_Itr2 = m_Itr1 + 1, j = 1; m_Itr2 != m_BoardDB.end(); m_Itr2++, j++) {
			for(int k = 0; k < 4; k++) {//4񂵂Čɖ߂
				if(!BoardCmp(m_Itr1->m_Pos, m_Itr2->m_Pos)) {	//d
					cout << "]DB" << i << "ԗvf̏df[^" << j << "Ԗڂ̃f[^̑" << k << "]Ɍ܂B" << endl;
					//Kvɉč폜
					res = FALSE;
				}
			}
			Rotate(m_Itr1->m_Pos);								//4]̂Ōɖ߂
		}
		Mirror(m_Itr1->m_Pos);									//Ֆʂ𔽓]Čɖ߂
	}
	if(res)
		cout << "df[^͌܂łB" << endl;
	return res;
}

//sʂ̏Wv
void CMENACEDB::Count(int& fwin, int& swin, int& flose, int& slose) {

	for(m_Itr1 = m_BoardDB.begin(); m_Itr1 != m_BoardDB.end(); m_Itr1++) {
		switch(m_Itr1->m_Outcome) {
		case 1:
			fwin++;
			break;
		case 2:
			swin++;
			break;
		case -1:
			flose++;
			break;
		case -2:
			slose++;
			break;
		}
	}
}

//DB̃f[^m_PosL[ɏŃ\[g
//BDCmp͏pr֐ix < y)TRUEƂȂ
bool BDCmp(const BOARD& x, const BOARD& y) {

	int i;
	for(i = 0; i < 9; i++) {
		if(x.m_Pos[i] != y.m_Pos[i])
			break;
	}
	return ((x.m_Pos[i] - y.m_Pos[i]) < 0);
}
//BDCmpgsort֐g
void CMENACEDB::DBSort() {

	sort(m_BoardDB.begin(), m_BoardDB.end(), BDCmp);
}

//DB̃f[^\
void CMENACEDB::DBShow(int n) {

	m_Itr1 = m_BoardDB.begin() + n;
	cout << "-------" << endl;
	for(int i = 0; i < 9; i++) {
		char c;
		switch(m_Itr1->m_Pos[i]) {
		case 0:
			c = ' ';
			break;
		case 1:
			c = 'O';
			break;
		case 2:
			c = 'X';
			break;
		}
		cout << "|" << c;
		if((i % 3) == 2)
			cout << "|" << endl << "-------" << endl;
	}
}

//DB̃f[^Xg\i1s4j
void CMENACEDB::DBList() {

	string num, str[4];		//numR[hԍAstr[0]"------- "A3s̓f[^\p
	char nums[9];			//R[hԍ8{NULL
	int i;
	for(m_Itr1 = m_BoardDB.begin(), i = 0; m_Itr1 != m_BoardDB.end(); m_Itr1++, i++) {
		//Օ\sstrz̏
		if(!(i % 4)) {
			num = "";
			for(int j = 0; j < 4; j++)
				str[j] = "";
		}
		//R[hԍs
		sprintf(nums, "No.%4d ", i);
		num = num + nums;
		//
		str[0] = str[0] + "------- ";
		//f[^
		char c;
		for(int j = 0; j < 3; j++) {
			//0 - 2̍s
			switch(m_Itr1->m_Pos[j]) {
			case 0:
				c = ' ';
				break;
			case 1:
				c = 'O';
				break;
			case 2:
				c = 'X';
				break;
			}
			str[1] = str[1] + "|" + c;
			//3 - 5̍s
			switch(m_Itr1->m_Pos[j + 3]) {
			case 0:
				c = ' ';
				break;
			case 1:
				c = 'O';
				break;
			case 2:
				c = 'X';
				break;
			}
			str[2] = str[2] + "|" + c;
			//6 - 8̍s
			switch(m_Itr1->m_Pos[j + 6]) {
			case 0:
				c = ' ';
				break;
			case 1:
				c = 'O';
				break;
			case 2:
				c = 'X';
				break;
			}
			str[3] = str[3] + "|" + c;
		}
		str[1] = str[1] + "| ";
		str[2] = str[2] + "| ";
		str[3] = str[3] + "| ";
		if((i % 4) == 3) {
			cout << num << endl;
			cout << str[0] << endl;
			for(int j = 1; j < 4; j++) {
				cout << str[j] << endl;
				cout << str[0] << endl;
			}
		}
		if(i && !(i % 5)) {	//5sɈUXgbviŏ͎sȂj
			cout << "L[ĂDDDiSPC~j" << endl;
			//Pause
			if(getch() == ' ')
				return;;
		}
	}
	if(!(i % 4)) {	//L̕\ssȂꍇ̕⊮
		cout << num << endl;
		cout << str[0] << endl;
		for(int j = 1; j < 4; j++) {
			cout << str[j] << endl;
			cout << str[0] << endl;
		}
	}
}

//BOARD̏
bool CMENACEDB::BoardWrite(char* fn) {

	BOARD board;
	int num = m_BoardDB.size();
	HANDLE hFile = CreateFile(fn, GENERIC_WRITE,
				FILE_SHARE_WRITE, NULL,
				OPEN_ALWAYS, NULL, NULL);	//t@CŃI[v
	if(hFile != INVALID_HANDLE_VALUE) {		//I[vł
		DWORD dwWrite;
		//悸intŃf[^
		WriteFile(hFile, &num, sizeof(int), &dwWrite, NULL);
		m_Itr1 = m_BoardDB.begin();
		//BOARD̔z
		for(int i = 0; i < num; i++, m_Itr1++) {
			board = *m_Itr1;
			WriteFile(hFile, &board, sizeof(board), &dwWrite, NULL);
		}
		CloseHandle(hFile);				//t@C̃N[Y
		return TRUE;
	}
	else
		return FALSE;
}

//BOARD̓ǂݍ
bool CMENACEDB::BoardRead(char* fn) {

	BOARD board;
	int num;
	HANDLE hFile = CreateFile(fn, GENERIC_READ,
				FILE_SHARE_READ, NULL,
				OPEN_EXISTING, NULL, NULL);	//t@CǍŃI[v
	if(hFile != INVALID_HANDLE_VALUE) {		//I[vł
		m_BoardDB.clear();					//m_BoardDB̃f[^ɂ
		DWORD dwRead;
		//悸int numɃf[^ǂݍ
		ReadFile(hFile, &num, sizeof(int), &dwRead, NULL);
		for(int i = 0; i < num; i++) {
			ReadFile(hFile, &board, sizeof(board), &dwRead, NULL);
			m_BoardDB.push_back(board);
		}
		CloseHandle(hFile);				//t@C̃N[Y
		return TRUE;
	}
	else
		return FALSE;
}
