////////////////////
//C# Easel_Test.cs
////////////////////
using System;
using System.Windows.Forms;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Reflection;					//Assemblyg
using Atelier;								//Atelier.dllg

namespace WindowsFormsApp
{
	public partial class AppForm : Form
	{
		Panel panel;						//sN`[i{bNXj̘gƂȂPanel
		PictureBox picBox;					//sN`[{bNXRg[
		Button btn1, btn2, btn3, extbtn;	//{^Rg[
		//`ƂEaselIuWFNg쐬iGraphicsAPenABrushIuWFNg쐬j
		Easel easel = new Easel();			//`sEaselIuWFNg

		[STAThread]
		public static void Main()
		{
			AppForm ap = new AppForm();
			Application.Run(ap);
		}

		public AppForm()
		{
			Assembly myOwn = Assembly.GetEntryAssembly();
			this.Icon = Icon.ExtractAssociatedIcon(myOwn.Location);	//vOACRtH[ɂ
			this.Size = new Size(640, 480);
			this.MinimumSize = new Size(320, 190);
			this.Text = "Easel";
			this.Load += AppForm_Load;
		}

		private void AppForm_Load(object sender, EventArgs e)
		{
			//{^1
			btn1 = new Button();
			btn1.Location = new Point(ClientSize.Width - btn1.Width - 10, 10);
			btn1.Text = "{^1";
			btn1.Anchor = (AnchorStyles.Top | AnchorStyles.Right);
			btn1.Click += Button1_Click;
			this.Controls.Add(btn1);

			//{^2{^
			btn2 = new Button();
			btn2.Location = new Point(ClientSize.Width - btn2.Width - 10, btn1.Height + 20);
			btn2.Text = "{^2";
			btn2.Anchor = (AnchorStyles.Top | AnchorStyles.Right);
			btn2.Click += Button2_Click;
			this.Controls.Add(btn2);

			//{^3{^
			btn3 = new Button();
			btn3.Location = new Point(ClientSize.Width - btn3.Width - 10, btn1.Height + btn2.Height + 30);
			btn3.Text = "{^3";
			btn3.Anchor = (AnchorStyles.Top | AnchorStyles.Right);
			btn3.Click += Button3_Click;
			this.Controls.Add(btn3);

			//I{^
			extbtn = new Button();
			extbtn.Location = new Point(ClientSize.Width - extbtn.Width - 10, ClientSize.Height - extbtn.Height - 20);
			extbtn.Text = "I";
			extbtn.Anchor = (AnchorStyles.Bottom | AnchorStyles.Right);
			extbtn.Click += Button4_Click;
			this.Controls.Add(extbtn);

			//sN`[{bNXRg[ in pl
			panel = new Panel();		//t[ƂȂPanelIuWFNg̍쐬
			panel.BorderStyle = BorderStyle.Fixed3D;
			panel.Location = new Point(10, 10);
			panel.Width = ClientSize.Width - btn1.Width - 30;
			panel.Height = ClientSize.Height - 20;
			panel.AutoScroll = true;			//XN[o[t
			panel.Anchor = (AnchorStyles.Top | AnchorStyles.Left | AnchorStyles.Bottom | AnchorStyles.Right);
			picBox = new PictureBox();			//g̒PictureIuWFNg̍쐬
			picBox.Location = new Point(0, 0);	//g̈ʒu
			picBox.SizeMode = PictureBoxSizeMode.AutoSize;	//摜TCYPictureBox̑傫ύX
			picBox.Image = easel.Canvas;		//PictureBoxEaselIuWFNg\t
			panel.Controls.Add(picBox);			//picBoxpanel̎qɂ
			//FormTPictureBoxPanelǉ
			this.Controls.Add(panel);
		}

		//I
		protected override void OnFormClosing(FormClosingEventArgs e)
		{
			base.OnFormClosing(e);
			DialogResult dr = MessageBox.Show("I܂H", "mF", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
			if(dr == DialogResult.No)
			{
				e.Cancel = true;
			}
			else
				//PictureBox̃}l[Wh \[XƃA}l[Wh \[X
				picBox.Dispose();
		}

		private void Button1_Click(object sender, EventArgs e)
		{
			//{^1
			easel.Clear(SystemColors.Control);
			//{^Rg[̕`
			ControlPaint.DrawButton(easel.gHandle, 10, 10, 50, 20, ButtonState.Normal);
			//LvV{^Rg[̕{^̕`
			ControlPaint.DrawCaptionButton(easel.gHandle, 70, 10, 15, 15, CaptionButton.Close, ButtonState.Pushed);
			//`FbN{bNXRg[̕`
			ControlPaint.DrawCheckBox(easel.gHandle, 30, 40, 15, 15, ButtonState.All);
			//R{{bNXRg[̃hbv_E{^̕`
			ControlPaint.DrawComboButton(easel.gHandle, 50, 40, 15, 15, ButtonState.Normal);
			//IvV{^Rg[̕`
			ControlPaint.DrawRadioButton(easel.gHandle, 70, 40, 15, 15, ButtonState.Checked);
			//XN[o[Rg[̃XN[{^̕`
			ControlPaint.DrawScrollButton(easel.gHandle, 90, 40, 15, 15, ScrollButton.Max,
			ButtonState.Checked);
			//3Xe[g`FbN{bNXRg[̕`
			ControlPaint.DrawMixedCheckBox(easel.gHandle, 110, 40, 15, 15,
			ButtonState.Checked);
			//j[ڂ̃Rg[̃`FbN}[N̕`
			ControlPaint.DrawMenuGlyph(easel.gHandle, new Rectangle(130, 40, 15, 15), MenuGlyph.Checkmark);
			//{^X^CRg[̗֊s̕`
			ControlPaint.DrawBorder(easel.gHandle, new Rectangle(10, 60, 50, 20),
			Color.White, ButtonBorderStyle.Inset);
			//Rg[3DX^C̗֊s̕`
			ControlPaint.DrawBorder3D(easel.gHandle, new Rectangle(70, 60, 50, 20),
			Border3DStyle.Raised, Border3DSide.All);
			//.NET Framework 2.0ȍ~:rWAX^C̗֊s̕`
			ControlPaint.DrawVisualStyleBorder(easel.gHandle, new Rectangle(10, 10, 100, 100));
			//ReiRg[̃OunhOt̕`
			ControlPaint.DrawContainerGrabHandle(easel.gHandle, new Rectangle(10, 90, 15, 15));
			//W̑Iڂ̃OunhOt̕`
			ControlPaint.DrawGrabHandle(easel.gHandle, new Rectangle(30, 90, 15, 15), true, true);
			//tH[̃TCYObv̕`
			ControlPaint.DrawSizeGrip(easel.gHandle, Color.White, new Rectangle(50, 90, 15, 15));
			//tH[JXlp`̕`
			ControlPaint.DrawFocusRectangle(easel.gHandle, new Rectangle(10, 110, 40, 40));
			//1sNZ̓_ō\ꂽObh̕`
			ControlPaint.DrawGrid(easel.gHandle, new Rectangle(60, 110, 40, 40), new Size(8, 5), Color.White);
			//ʂɕ\郍bNꂽIڂ̘g̕`
			ControlPaint.DrawLockedFrame(easel.gHandle, new Rectangle(110, 110, 40, 40), true);
			//W̑Iڂ̘g̕`
			ControlPaint.DrawSelectionFrame(easel.gHandle, true, new Rectangle(10, 160, 40, 40), new Rectangle(20, 170, 20, 20), Color.White);
			//Easelɕ\
			picBox.Image = easel.Canvas;
		}

		private void Button2_Click(object sender, EventArgs e)
		{
			//{^2
			easel.Clear(SystemColors.Window);
			//ʒu(10, 10)200x160̒``
			easel.Box(10, 10, 200, 160);
			//ʒu(100, 100)100x80̎lp`
			easel.Box(220, 10, 320, 110, true);
			//~`
			easel.Circle(200, 200, 100);
			easel.Circle(200, 200, 30, true);
			//~(Jnpx 0xAXC[vpx 90x)`
			easel.Arced(10, 20, 100, 80, 0, 90);
			//Easelɕ\
			easel.PrintText("邹[I", 50, 300, new StringFormat(StringFormatFlags.NoWrap));
			//EaselEaselNX̃rbg}bv\
			picBox.Image = easel.Canvas;
		}

		private void Button3_Click(object sender, EventArgs e)
		{
			//{^3
			//ʒu(0, 0)100x100Bitmap擾
			easel.GetBMP(picBox, 0, 0, 99, 99);
			//ʒu(100, 100)100x100Bitmap\
			easel.PutBMP(100, 100);
			//VXeACR擾Ĉʒu(200, 200)ɕ\
			Image img = Image.FromFile(".\\Icon.ico");
			easel.PutBMP(img, 200, 200, 232, 232);
			picBox.Image = easel.Canvas;
		}

		private void Button4_Click(object sender, EventArgs e)
		{
			//I
			Close();
		}
	}
}
