/////////////////////////////////////
// csFileList.cs for DLL
// Copyright (c) 06/19/2023 by ysama
/////////////////////////////////////
using System;
using System.Collections;
using System.Collections.Generic;
using System.Windows.Forms;
using System.Drawing;
using System.Reflection;		//Assemblyg
using System.Resources;			//\[X֌WNX̎gp̈
using System.IO;				//Stream֌WNX̎gp̈
using System.IO.Compression;	//ZipFileg
using System.Diagnostics;		//Processgp

namespace csFileList
{
/*	/////////////////////////////////////
	//Gg[|CgNX
	//ICu[iDLLjɂꍇA
	//MainAppNXׂč폜邱
	/////////////////////////////////////
	class MainApp
	{
		[STAThread]
		public static void Main()
		{
			//R}hCzŎ擾
			string[] cmds = System.Environment.GetCommandLineArgs();	//擪͎st@C
			if(cmds.Length > 1)
			{
				string[] args = new string[cmds.Length - 1];
				Array.Copy(cmds, 1, args, 0, cmds.Length - 1);
				Application.Run(new FileList(args));
			}
			else
				Application.Run(new FileList());
		}
	}
*/
	///////////////////
	// FileListNX
	///////////////////
	public partial class FileList : Form
	{
		//NXo[ϐ
		ToolStrip toolStrip;				//c[o[
		ToolStripButton[] toolStripButton;	//c[o[{^
		StatusStrip statusStrip;			//Xe[^Xo[
		ToolStripStatusLabel[] tssl;		//Xe[^Xo[x
		ListView file_List;					//t@CXgpXgr[
		string[] fn_args = null;			//R}hCQƂz

		public FileList(string[] fns = null)
		{
			this.Load += new EventHandler(MainForm_Load);
			this.Text = "FileList";
			this.ClientSize = new Size(640, 341);	//Size = (656, 380);
			this.MinimumSize = new Size(656, 380);	//ŏTCY
			this.BackColor = SystemColors.Window;
			if(fns != null)
				fn_args = fns;
		}

		//WM_CREATE
		private void MainForm_Load(object sender, EventArgs e)
		{
			//c[o[ƃXe[^Xo[쐬
			SetBars();
			//Rg[쐬
			InitControls();
		}
/*
		//WM_CLOSE|DLL̏ꍇ͕sv
		protected override void OnFormClosing(FormClosingEventArgs e)
		{
			base.OnFormClosing(e);
			DialogResult dr = MessageBox.Show("I܂H", "mF", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
			if(dr == DialogResult.No)
			{
				e.Cancel = true;
			}
		}
*/
		//c[o[ƃXe[^Xo[̐ݒ
		protected void SetBars()
		{
			//tH[̃CAEgꎞ~
			this.SuspendLayout();
			//c[o[̔zu
			//ToolStripNXCX^X̐
			this.toolStrip = new ToolStrip();
			//c[o[̃CAEgꎞ~
			this.toolStrip.SuspendLayout();
			//ToolStripButtonz쐬
			this.toolStripButton = new ToolStripButton[9];
			//{vO̖ߍ݃\[X̃\[X}l[W[쐬
			Assembly asm = Assembly.GetExecutingAssembly();
			ResourceManager rm = new ResourceManager("csFileList", asm);
			//ACRtH[ɂ
			this.Icon = (Icon)rm.GetObject("Icon");
			//c[o[rbg}bv̓ǂݍ
			ImageList imgList = new ImageList();
			imgList.ImageSize = new Size(16, 16);
			imgList.Images.AddStrip((Bitmap)rm.GetObject("ToolBar"));
			imgList.TransparentColor = Color.White;
			//ToolStripButton[0]쐬
			this.toolStripButton[0] = new ToolStripButton();
			this.toolStripButton[0].Text = "t@CXgJ(&O)";				//eLXgݒ
			this.toolStripButton[0].Image = (Bitmap)imgList.Images[0];				//摜ݒ
			this.toolStripButton[0].DisplayStyle = ToolStripItemDisplayStyle.Image;	//摜\̂
			this.toolStripButton[0].Click += OnOpen_Click;							//ClickCxgnhǉ
			this.toolStrip.Items.Add(this.toolStripButton[0]);						//{^ǉ
			//ToolStripButton[1]쐬
			this.toolStripButton[1] = new ToolStripButton();
			this.toolStripButton[1].Text = "t@CXg̕ۑ(&S)";				//eLXgݒ
			this.toolStripButton[1].Image = (Bitmap)imgList.Images[1];				//摜ݒ
			this.toolStripButton[1].DisplayStyle = ToolStripItemDisplayStyle.Image;	//摜\̂
			this.toolStripButton[1].Click += OnSave_Click;							//ClickCxgnhǉ
			this.toolStripButton[1].Enabled = false;								//Ԃ͖
			this.toolStrip.Items.Add(this.toolStripButton[1]);						//{^ǉ
			//Zp[^[}
			this.toolStrip.Items.Add(new ToolStripSeparator());
			//ToolStripButton[2]쐬
			this.toolStripButton[2] = new ToolStripButton();
			this.toolStripButton[2].Text = "I(&X)";								//eLXgݒ
			this.toolStripButton[2].Image = (Bitmap)imgList.Images[2];				//摜ݒ
			this.toolStripButton[2].DisplayStyle = ToolStripItemDisplayStyle.Image;	//摜\̂
			this.toolStripButton[2].Click += OnExit_Click;							//ClickCxgnhǉ
			this.toolStrip.Items.Add(this.toolStripButton[2]);						//{^ǉ
			//Zp[^[}
			this.toolStrip.Items.Add(new ToolStripSeparator());
			//ToolStripButton[3]쐬
			this.toolStripButton[3] = new ToolStripButton();
			this.toolStripButton[3].Text = "t@Cǉ(&A)";					//eLXgݒ
			this.toolStripButton[3].Image = (Bitmap)imgList.Images[3];				//摜ݒ
			this.toolStripButton[3].DisplayStyle = ToolStripItemDisplayStyle.Image;	//摜\̂
			this.toolStripButton[3].Click += OnAdd_Click;							//ClickCxgnhǉ
			this.toolStrip.Items.Add(this.toolStripButton[3]);						//{^ǉ
			//ToolStripButton[4]쐬
			this.toolStripButton[4] = new ToolStripButton();
			this.toolStripButton[4].Text = "t@CO(&R)";					//eLXgݒ
			this.toolStripButton[4].Image = (Bitmap)imgList.Images[4];				//摜ݒ
			this.toolStripButton[4].DisplayStyle = ToolStripItemDisplayStyle.Image;	//摜\̂
			this.toolStripButton[4].Click += OnRemove_Click;						//ClickCxgnhǉ
			this.toolStripButton[4].Enabled = false;								//Ԃ͖
			this.toolStrip.Items.Add(this.toolStripButton[4]);						//{^ǉ
			//Zp[^[}
			this.toolStrip.Items.Add(new ToolStripSeparator());
			//ToolStripButton[5]쐬
			this.toolStripButton[5] = new ToolStripButton();
			this.toolStripButton[5].Text = "폜(&D)";							//eLXgݒ
			this.toolStripButton[5].Image = (Bitmap)imgList.Images[5];				//摜ݒ
			this.toolStripButton[5].DisplayStyle = ToolStripItemDisplayStyle.Image;	//摜\̂
			this.toolStripButton[5].Click += OnDelete_Click;						//ClickCxgnhǉ
			this.toolStripButton[5].Enabled = false;								//Ԃ͖
			this.toolStrip.Items.Add(this.toolStripButton[5]);						//{^ǉ
			//ToolStripButton[6]쐬
			this.toolStripButton[6] = new ToolStripButton();
			this.toolStripButton[6].Text = "Rs[(&C)";					//eLXgݒ
			this.toolStripButton[6].Image = (Bitmap)imgList.Images[6];				//摜ݒ
			this.toolStripButton[6].DisplayStyle = ToolStripItemDisplayStyle.Image;	//摜\̂
			this.toolStripButton[6].Click += OnCopy_Click;							//ClickCxgnhǉ
			this.toolStripButton[6].Enabled = false;								//Ԃ͖
			this.toolStrip.Items.Add(this.toolStripButton[6]);						//{^ǉ
			//ToolStripButton[7]쐬
			this.toolStripButton[7] = new ToolStripButton();
			this.toolStripButton[7].Text = "ړ(&M)";								//eLXgݒ
			this.toolStripButton[7].Image = (Bitmap)imgList.Images[7];				//摜ݒ
			this.toolStripButton[7].DisplayStyle = ToolStripItemDisplayStyle.Image;	//摜\̂
			this.toolStripButton[7].Click += OnMove_Click;							//ClickCxgnhǉ
			this.toolStripButton[7].Enabled = false;								//Ԃ͖
			this.toolStrip.Items.Add(this.toolStripButton[7]);						//{^ǉ
			//ToolStripButton[8]쐬
			this.toolStripButton[8] = new ToolStripButton();
			this.toolStripButton[8].Text = "k(&P)";								//eLXgݒ
			this.toolStripButton[8].Image = (Bitmap)imgList.Images[8];				//摜ݒ
			this.toolStripButton[8].DisplayStyle = ToolStripItemDisplayStyle.Image;	//摜\̂
			this.toolStripButton[8].Click += OnCompress_Click;						//ClickCxgnhǉ
			this.toolStripButton[8].Enabled = false;								//Ԃ͖
			this.toolStrip.Items.Add(this.toolStripButton[8]);						//{^ǉ
			//c[o[̐ݒ
			this.Controls.Add(this.toolStrip);
			//c[o[̃CAEgĊJ
			this.toolStrip.ResumeLayout(false);
			this.toolStrip.PerformLayout();
			//Xe[^Xo[̔zu
			//StatusStripNXCX^X̐
			this.statusStrip = new StatusStrip();
			//Xe[^Xo[̃CAEgꎞ~
			this.statusStrip.SuspendLayout();
			//Xe[^Xo[ɃplƃeLXgǉ
			tssl = new ToolStripStatusLabel[3];
			tssl[0] = new ToolStripStatusLabel();
			tssl[0].BorderSides = ToolStripStatusLabelBorderSides.All;
			tssl[0].BorderStyle = Border3DStyle.SunkenInner;
			tssl[0].BackColor = SystemColors.Control;
			tssl[0].Text = "FileList Ver. 1.0";
			tssl[0].AutoSize = true;
			tssl[0].TextAlign = ContentAlignment.MiddleLeft;
			tssl[1] = new ToolStripStatusLabel();
			tssl[1].BorderSides = ToolStripStatusLabelBorderSides.All;
			tssl[1].BorderStyle = Border3DStyle.SunkenInner;
			tssl[1].BackColor = SystemColors.Control;
			tssl[1].Text = "iIt@Cj";
			tssl[1].ToolTipText = "iIt@Cj";	//ToolTipݒ
			tssl[1].AutoSize = true;
			tssl[1].TextAlign = ContentAlignment.MiddleLeft;
			tssl[2] = new ToolStripStatusLabel();
			tssl[2].BorderSides = ToolStripStatusLabelBorderSides.All;
			tssl[2].BorderStyle = Border3DStyle.SunkenInner;
			tssl[2].BackColor = SystemColors.Control;
			tssl[2].Text = "iIt@Cj";
			tssl[2].ToolTipText = "iIt@Cj";	//ToolTipݒ
			tssl[2].Spring = true;
			tssl[2].TextAlign = ContentAlignment.MiddleLeft;
			statusStrip.Items.AddRange(tssl);
			statusStrip.ShowItemToolTips = true;		//ToolTip\
			this.Controls.Add(this.statusStrip);		//StatusStrip(Xe[^Xo[)ǉ
			//Xe[^Xo[̃CAEgĊJ
			this.statusStrip.ResumeLayout(false);
			this.statusStrip.PerformLayout();
			//CtH[̃CAEgĊJ
			this.ResumeLayout(false);
			this.PerformLayout();
		}

		//Rg[̐ݒ
		protected void InitControls()
		{
			/////////////////////
			//Rg[̔zu
			/////////////////////
			//Xgr[̐ƃvpeB̐ݒ
			file_List = new ListView();
			file_List.Size = new Size(ClientSize.Width - 20, ClientSize.Height - toolStrip.Height - 10);	//TCY
			file_List.Location = new Point(10,  toolStrip.Height);	//ʒu
			file_List.Anchor = (AnchorStyles.Top | AnchorStyles.Left | AnchorStyles.Bottom | AnchorStyles.Right);
			file_List.FullRowSelect = true;				//sI
			file_List.GridLines = true;					//ObhC̕\
			file_List.MultiSelect = true;				//I
			file_List.HoverSelection = false;			//|CgőIł悤ɂ
			file_List.Activation = ItemActivation.OneClick;	//VONbNI
			file_List.CheckBoxes = false;				//`FbN{bNXL
			file_List.View = View.Details;				//Xgr[̕\@
			//Cxgnh̒ǉ
			file_List.ColumnClick += new ColumnClickEventHandler(OnLV_ColumnClick);
			file_List.ItemSelectionChanged += new ListViewItemSelectionChangedEventHandler(OnLV_SelectionChanged);
			//wb_[`
			file_List.Columns.Add("t@C", 200, HorizontalAlignment.Left);
			file_List.Columns.Add("t@CpX", 416, HorizontalAlignment.Left);
			//Drag and Drop̃Cxgnh̒ǉ
			file_List.DragEnter += new DragEventHandler(LV_DragEnter);
			file_List.DragDrop += new DragEventHandler(LV_DragDrop);
			file_List.AllowDrop = true;
			//FormListViewǉ
			this.Controls.Add(file_List);
			//RXgN^[it@CpXAjꍇ
			if(fn_args != null)
			{
				foreach(string fn in fn_args)
				{
					//t@C݂邩AtH[_[ł͂ȂA`FbN
					if(!File.Exists(fn))
					{
						MessageBox.Show("̃t@C݂͑܂B\r\n" + fn, "", MessageBoxButtons.OK, MessageBoxIcon.Error);
						continue;
					}
					ListViewItem item = file_List.Items.Add(Path.GetFileName(fn));
					item.SubItems.Add(Path.GetDirectoryName(fn));
				}
				//c[o[{^L
				ChangeToolBarStatus(true);
				//t@CXV
				ShowNumOfFiles();
			}
			else
				//c[o[{^
				ChangeToolBarStatus(false);
		}

		//////////////////////////
		//c[o[֘A\bh
		//////////////////////////
		//ut@CXgJv
		private void OnOpen_Click(object sender, EventArgs e)
		{
			DialogResult dr = MessageBox.Show("t@CXgւ܂i͂jA܂\r\nǉ܂ijH", "mF", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
			if(dr == DialogResult.Yes)
			{
				file_List.Items.Clear();				//ւ̏ꍇAXgr[̍ڂS폜
			}
			OpenFileDialog ofDlg = new OpenFileDialog();
			ofDlg.Filter = "Aot@C(*.alb)|*.alb|vCXgt@C(*.plf)|*.plf|ׂẴt@C(*.*)|*.*";	//t@CtB^[̎w
			ofDlg.FilterIndex = 1;						//t@CtB^[CfbNX̎w
			ofDlg.RestoreDirectory = true;				//_CAO{bNXOɌ݂̃fBNg𕜌悤ɂ
			ofDlg.CheckFileExists = true;				//݂Ȃt@C̖Ow肳ꂽƂx\
			ofDlg.CheckPathExists = true;				//݂ȂpXw肳ꂽƂx\
			ofDlg.InitialDirectory = @".\";				//ftHg̃tH_w肷
			ofDlg.Title = "t@CXgJ";		//_CAÕ^Cgw肷
			if(ofDlg.ShowDialog() == DialogResult.OK)	//_CAO\
			{
				//t@C("shift_jis")J
				using(StreamReader sr = new StreamReader(ofDlg.FileName, System.Text.Encoding.GetEncoding("shift_jis")))
				{
					//1s
					while(!sr.EndOfStream){
						string line = sr.ReadLine();
						//J}Ŕzvf𕪂iŏ̗vft@CpXAOƂj
		    			string[] fns = line.Split(',');
		    			//1vf̃t@CpXA'"'ŊĂ΍폜
		    			string fn = fns[0].Trim('"');
						//t@C݂邩AtH[_[ł͂ȂA`FbN
						if(!File.Exists(fn))
						{
							MessageBox.Show("̃t@C݂͑܂B\r\n" + fn, "", MessageBoxButtons.OK, MessageBoxIcon.Error);
							continue;
						}
						ListViewItem item = file_List.Items.Add(Path.GetFileName(fn));
						item.SubItems.Add(Path.GetDirectoryName(fn));
					}
					sr.Close();
				}
				if(file_List.Items.Count > 0)
				{
					//c[o[{^L
					ChangeToolBarStatus(true);
					//t@CXV
					ShowNumOfFiles();
 				}
 			}
			else
			{
				MessageBox.Show("LZ܂B", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
			//IuWFNgj
			ofDlg.Dispose();
		}

		//ut@CXgۑv
		private void OnSave_Click(object sender, EventArgs e)
		{
			//Iꂽt@CpXAfilesɓZ߂
			string files = "";
			foreach(ListViewItem item in file_List.Items)
			{
				files += "\"" + item.SubItems[1].Text + "\\" + item.SubItems[0].Text + "\"\r\n";
			}
			//݃t@Cw
			SaveFileDialog sfDlg = new SaveFileDialog();
			sfDlg.Filter = "Aot@C(*.alb)|*.alb|vCXgt@C(*.plf)|*.plf|ׂẴt@C(*.*)|*.*";	//t@CtB^[̎w
			sfDlg.FilterIndex = 3;						//t@CtB^[CfbNX̎w
			sfDlg.RestoreDirectory = true;				//_CAO{bNXOɌ݂̃fBNg𕜌悤ɂ
			sfDlg.CheckPathExists = true;				//݂ȂpXw肳ꂽƂx\
			sfDlg.InitialDirectory = @".\";				//ftHg̃tH_w肷
			sfDlg.Title = "t@CXgۑ";		//_CAÕ^Cgw肷
			if(sfDlg.ShowDialog() == DialogResult.OK)	//_CAO\
			{
				//Xg[ŏ
				using(StreamWriter sw = new StreamWriter(sfDlg.FileName, false, System.Text.Encoding.GetEncoding("shift_jis")))	//falséu㏑wv
				{
					sw.Write(files);
					sw.Close();
				}
 			}
			else
			{
				MessageBox.Show("LZ܂B", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
			//IuWFNgj
			sfDlg.Dispose();
		}

		//uIv
		private void OnExit_Click(object sender, EventArgs e)
		{
			Close();
		}

		//ut@Cǉv
		private void OnAdd_Click(object sender, EventArgs e)
		{
			OpenFileDialog ofDlg = new OpenFileDialog();
			ofDlg.Filter = "ׂẴt@C(*.*)|*.*";	//t@CtB^[̎w
			ofDlg.FilterIndex = 1;						//t@CtB^[CfbNX̎w
			ofDlg.RestoreDirectory = true;				//_CAO{bNXOɌ݂̃fBNg𕜌悤ɂ
			ofDlg.CheckFileExists = true;				//݂Ȃt@C̖Ow肳ꂽƂx\
			ofDlg.CheckPathExists = true;				//݂ȂpXw肳ꂽƂx\
			ofDlg.Multiselect = true;					//t@C̑Is
			ofDlg.InitialDirectory = @".\";				//ftHg̃tH_w肷
			ofDlg.Title = "t@CJ";				//_CAÕ^Cgw肷
			if(ofDlg.ShowDialog() == DialogResult.OK)	//_CAO\
			{
				foreach(string fn in ofDlg.FileNames)	//It@CRNV̕\
				{
					ListViewItem item = file_List.Items.Add(Path.GetFileName(fn));
					item.SubItems.Add(Path.GetDirectoryName(fn));
				}
				if(file_List.Items.Count > 0)
				{
					//c[o[{^L
					ChangeToolBarStatus(true);
					//t@CXV
					ShowNumOfFiles();
 				}
 			}
			else
			{
				MessageBox.Show("LZ܂B", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
			//IuWFNgj
			ofDlg.Dispose();
		}

		//ut@COv
		private void OnRemove_Click(object sender, EventArgs e)
		{
			if(file_List.SelectedItems.Count == 0)
			{
				MessageBox.Show("ڂIĂ܂B", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
				return;
			}
			else
			{
				DialogResult dr = MessageBox.Show("I" + file_List.FocusedItem.Text + "ij폜܂H", "mF", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
				if(dr == DialogResult.Yes)
				{
					foreach(ListViewItem item in file_List.SelectedItems)
					{
						//IꂽACe폜
						item.Remove();
					}
					if(file_List.Items.Count == 0)
						//c[o[{^𖳌
						ChangeToolBarStatus(false);
					//t@CXV
					ShowNumOfFiles();
				}
			}
		}

		//u폜v
		private void OnDelete_Click(object sender, EventArgs e)
		{
			DialogResult dr = MessageBox.Show("Xg̑St@C폜܂H\r\nӁF폜t@C̃Xg͗\߁ut@CXgۑvō쐬ĂB", "mF", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
			if(dr == DialogResult.Yes)
			{
				foreach(ListViewItem item in file_List.Items)
				{
					//St@C̍폜
					try
					{
						File.Delete(item.SubItems[1].Text + "\\" + item.SubItems[0].Text);
						item.Remove();	//t@C̓Xg폜
					}
					catch
					{
						MessageBox.Show(item.SubItems[1].Text + "\\" + item.SubItems[0].Text + "\r\n̍폜Ɏs܂B", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
						continue;
					}
				}
			}
		}

		//uRs[v
		private void OnCopy_Click(object sender, EventArgs e)
		{
			//utH[_[Jv
			FolderBrowserDialog fbDlg = new FolderBrowserDialog();
			fbDlg.Description = "Rs[̃tH_[IA܂͍쐬ĂB";	//_CAO̐
			fbDlg.SelectedPath = ".\\";					//ftHg̃tH_[
			if(fbDlg.ShowDialog() == DialogResult.OK)	//tH_I_CAO\
			{
				foreach(ListViewItem item in file_List.Items)
				{
					//St@C̃Rs[
					try
					{
						//ɓt@Cꍇ̓G[ƂȂiFile.Copy(FromFile, ToFile, false)j
						File.Copy(item.SubItems[1].Text + "\\" + item.SubItems[0].Text, fbDlg.SelectedPath + "\\" + item.SubItems[0].Text);
						item.Remove();	//t@C̓Xg폜
					}
					catch
					{
						MessageBox.Show(item.SubItems[1].Text + "\\" + item.SubItems[0].Text + "\r\ñRs[Ɏs܂B", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
						continue;
					}
				}
			}
			else
			{
				MessageBox.Show("LZ܂B", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
			//IuWFNgj
			fbDlg.Dispose();
		}

		//uړv
		private void OnMove_Click(object sender, EventArgs e)
		{
			//utH[_[Jv
			FolderBrowserDialog fbDlg = new FolderBrowserDialog();
			fbDlg.Description = "ړ̃tH_[IA܂͍쐬ĂB";	//_CAO̐
			fbDlg.SelectedPath = ".\\";					//ftHg̃tH_[
			if(fbDlg.ShowDialog() == DialogResult.OK)	//tH_I_CAO\
			{
				foreach(ListViewItem item in file_List.Items)
				{
					//St@C̈ړ
					try
					{
						File.Move(item.SubItems[1].Text + "\\" + item.SubItems[0].Text, fbDlg.SelectedPath + "\\" + item.SubItems[0].Text);
						item.Remove();	//t@C̓Xg폜
					}
					catch
					{
						MessageBox.Show(item.SubItems[1].Text + "\\" + item.SubItems[0].Text + "\r\ñRs[Ɏs܂B", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
						continue;
					}
				}
			}
			else
			{
				MessageBox.Show("LZ܂B", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
			//IuWFNgj
			fbDlg.Dispose();
		}

		//ukv
		private void OnCompress_Click(object sender, EventArgs e)
		{
			//Zipt@C쐬p̎btH[_[̍쐬
			string temp = ".\\Temp";
			Directory.CreateDirectory(temp);
			//St@C̃Rs[
			foreach(ListViewItem item in file_List.Items)
			{
				try
				{
					//ɓt@CꍇG[oȂׂɏ㏑
					File.Copy(item.SubItems[1].Text + "\\" + item.SubItems[0].Text, temp + "\\" + item.SubItems[0].Text, true);
					item.Remove();	//t@C̓Xg폜
				}
				catch
				{
					MessageBox.Show(item.SubItems[1].Text + "\\" + item.SubItems[0].Text + "\r\n̈kɎs܂B", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
					continue;
				}
			}
			//utH[_[Jv
			FolderBrowserDialog fbDlg = new FolderBrowserDialog();
			fbDlg.Description = "k̃tH_[IA܂͍쐬ĂB";	//_CAO̐
			fbDlg.SelectedPath = ".\\";					//ftHg̃tH_[
			if(fbDlg.ShowDialog() == DialogResult.OK)	//tH_I_CAO\
			{	//Zipt@C̍쐬
				/*	ӁFZipFile̎gpɂ,
					(1) "using System.IO.Compression;"ƁA
					(2) System.IO.Compression.FileSystemւ̎Q
					ǉKvB*/
				ZipFile.CreateFromDirectory(temp, fbDlg.SelectedPath + "\\CompressedFileList.zip");
			}
			else
			{
				MessageBox.Show("LZ܂B", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
			//IuWFNgj
			fbDlg.Dispose();
			//tempSt@C̍폜
			DirectoryInfo temp_dir = new DirectoryInfo(temp);
			foreach(FileInfo file in temp_dir.GetFiles())
			{
				file.Delete();
			}
			//temptH_[̍폜
			temp_dir.Delete(true);
		}

		///////////////////////////
		//Rg[֘A\bh
		///////////////////////////
		//file_List̃RNbNꂽ
		private void OnLV_ColumnClick(object sender, ColumnClickEventArgs e)
		{
			//ListViewItemSorterw肷
			file_List.ListViewItemSorter = new ListViewItemComparer(e.Column);
			//At݂ɕёւiListViewItemSorterݒ肷SortIɌĂяoj
		}

		//file_List̃ACeύXꂽ
		private void OnLV_SelectionChanged(Object sender, ListViewItemSelectionChangedEventArgs e)
		{
			if(file_List.SelectedItems.Count == 0)			//IԂ̃`FbN
			{
				tssl[2].Text = "iIt@Cj";
				tssl[2].ToolTipText = "iIt@Cj";	//ToolTipݒ
			}
			else
			{
				tssl[2].Text = e.Item.Text;
				tssl[2].ToolTipText = e.Item.Text;			//ToolTipݒ
			}
		}

		//file_ListɃhbOꂽ
		private void LV_DragEnter(object sender, DragEventArgs e)
		{
			if(e.Data.GetDataPresent(DataFormats.FileDrop))
				e.Effect = DragDropEffects.Copy;
			else
				e.Effect = DragDropEffects.None;
		}

		//file_ListViewɃhbvꂽƂ
		private void LV_DragDrop(object sender, DragEventArgs e)
		{
			//hbvꂽt@CpX擾
			string[] ddlist =  (string[])e.Data.GetData(DataFormats.FileDrop, false);
			//hbvꂽf[^Xgr[ɒǉ
			foreach(string fn in ddlist)
			{
				//t@C݂邩AtH[_[ł͂ȂA`FbN
				if(!File.Exists(fn))
				{
					MessageBox.Show("̃t@C݂͑܂B\r\n" + fn, "", MessageBoxButtons.OK, MessageBoxIcon.Error);
					continue;
				}
				ListViewItem item = file_List.Items.Add(Path.GetFileName(fn));
				item.SubItems.Add(Path.GetDirectoryName(fn));
 			}
			//c[o[{^L
			ChangeToolBarStatus(true);
			//t@CXV
			ShowNumOfFiles();
		}

		///////////////////////
		//FileListʃ\bh
		///////////////////////
		//c[o[{^̏ԂLA
		private void ChangeToolBarStatus(bool flag)
		{
			this.toolStripButton[1].Enabled = flag;
			for(int i = 4; i < 9; i++)
				this.toolStripButton[i].Enabled = flag;
		}

		//t@CXV
		private void ShowNumOfFiles()
		{
			tssl[1].Text = "t@CF" + file_List.Items.Count.ToString();
			tssl[1].ToolTipText = "t@CF" + file_List.Items.Count.ToString();	//ToolTipݒ
		}

		//t@CXgf[^擾iDLLŗpj
		public string[] GetFileList()
		{
			//t@CXgf[^np
			string[] flData = new string[file_List.Items.Count];
			for(int i = 0; i < file_List.Items.Count; i++)
			{
				flData[i] = file_List.Items[i].SubItems[1].Text + "\\" + file_List.Items[i].SubItems[0].Text;
			}
			return flData;
		}

		//FileListNXCX^X̃\[XJpDispose()\bhiMicrosoft Docsj
		public void Dispose(int i = 0)
		{
			//A}l[Wh\[X̊J
			Dispose(true);
			//K[x[WRNViI}j
			GC.SuppressFinalize(this);
		}
	}
}

///////////////////////////////////////////
//ListView̍ڂ̕ёւɎgpNX
///////////////////////////////////////////
public class ListViewItemComparer : IComparer
{
	private int m_column;
	private static int m_order = 1;	//Ă΂邽тɐAtコtO

	//ListViewItemComparerNX̃RXgN^
	public ListViewItemComparer(int col)
	{
		m_column = col;
		m_order *= -1;	//ListViewItemComparerĂ΂xɐAtύX
	}

	//xy菬Ƃ̓}CiX̐A傫Ƃ̓vX̐AƂ0Ԃ
	public int Compare(object x, object y)
	{
		//ListViewItem̎擾
		ListViewItem itemx = (ListViewItem) x;
		ListViewItem itemy = (ListViewItem) y;
		//xy𕶎ƂĔr
		return string.Compare(itemx.SubItems[m_column].Text, itemy.SubItems[m_column].Text) * m_order;
	}
}
