//////////////////////
// FormSDISkelton.cs
//////////////////////
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Windows.Forms;
using System.Drawing;
using System.Drawing.Imaging;
using System.Linq;
using System.Text;
using System.Reflection;		//Assemblyg
using System.Resources;			//\[X֌WNX̎gp̈
using System.IO;				//Stream֌WNX̎gp̈

///////////////////////////
//Gg[|CgNX
///////////////////////////
class MainApp
{
	[STAThread]
	public static void Main()
	{
		Application.Run(new MainWnd());
	}
}

///////////////////////
//CtH[NX
///////////////////////
public partial class MainWnd : Form
{
	//NXo[ϐ
	ToolStrip toolStrip;						//c[o[
	ToolStripButton[] toolStripButton;			//c[o[{^
	StatusStrip statusStrip;					//Xe[^Xo[
	ToolStripStatusLabel[] tssl;				//Xe[^Xo[x

	public MainWnd()
	{
		Assembly myOwn = Assembly.GetEntryAssembly();
		this.Icon = Icon.ExtractAssociatedIcon(myOwn.Location);	//vOACRtH[ɂ
		this.Load += new EventHandler(MainForm_Load);
		this.Text = "MainWindow Name";
		this.ClientSize = new Size(640, 480);
		this.MinimumSize = new Size(480, 360);
		this.BackColor = SystemColors.Window;
	}

	//WM_CREATE
	private void MainForm_Load(object sender, EventArgs e)
	{
		//j[쐬
		SetMenu();
		//c[o[ƃXe[^Xo[Rg[쐬
		SetControls();
	}

	//WM_CLOSE
	protected override void OnFormClosing(FormClosingEventArgs e)
	{
		base.OnFormClosing(e);
		DialogResult dr = MessageBox.Show("I܂H", "mF", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
		if(dr == DialogResult.No)
		{
			e.Cancel = true;
		}
	}

	//j[̐ݒ
	protected void SetMenu()
	{
		//Cj[쐬
		MainMenu menu = new MainMenu();
		Menu = menu;
		//j[ACet
		MenuItem miFile = new MenuItem();		//ut@Cvj[
		miFile.Text = "t@C(&F)";
		miFile.Index = 0;
		menu.MenuItems.Add(miFile);
		MenuItem miEdit = new MenuItem();		//uҏWvj[
		miEdit.Text = "ҏW(&E)";
		miEdit.Index = 1;
		menu.MenuItems.Add(miEdit);
		MenuItem miWnd = new MenuItem();		//ȗvj[
		miWnd.Text = "̑(&O)";
		miWnd.Index = 2;
		miWnd.MdiList = true;
		menu.MenuItems.Add(miWnd);
		MenuItem miHelp = new MenuItem();		//uwvvj[
		miHelp.Text = "wv(&H)";
		miHelp.Index = 3;
		menu.MenuItems.Add(miHelp);
		MenuItem miNew = new MenuItem();		//uVKvj[ACe
		miNew.Text = "VK(&N)";
		miNew.Index = 0;
		miNew.Click += OnNew_Click;
		miNew.Shortcut = Shortcut.CtrlN;
		miFile.MenuItems.Add(miNew);
		MenuItem miOpen = new MenuItem();		//uJvj[ACe
		miOpen.Text = "J(&O)";
		miOpen.Index = 1;
		miOpen.Click += OnOpen_Click;
		miOpen.Shortcut = Shortcut.CtrlO;
		miFile.MenuItems.Add(miOpen);
		MenuItem miSave = new MenuItem();		//uۑvj[ACe
		miSave.Text = "ۑ(&S)";
		miSave.Index = 2;
		miSave.Click += OnSave_Click;
		miSave.Shortcut = Shortcut.CtrlS;
		miFile.MenuItems.Add(miSave);
		MenuItem miSaveAs = new MenuItem();		//uOtĕۑvj[ACe
		miSaveAs.Text = "Otĕۑ(&A)";
		miSaveAs.Index = 3;
		miSaveAs.Click += OnSaveAs_Click;
		miSave.Shortcut = Shortcut.CtrlA;
		miFile.MenuItems.Add(miSaveAs);
		miFile.MenuItems.Add("-");				//Zp[^[
		MenuItem miExit = new MenuItem();		//uIvj[ACe
		miExit.Text = "I(&X)";
		miExit.Index = 4;
		miExit.Click += OnExit_Click;
		miExit.Shortcut = Shortcut.CtrlX;
		miFile.MenuItems.Add(miExit);
		MenuItem miCut = new MenuItem();		//u؂vj[ACe
		miCut.Text = "؂(&T)";
		miCut.Index = 0;
		miCut.Click += OnCut_Click;
		miCut.Shortcut = Shortcut.CtrlT;
		miEdit.MenuItems.Add(miCut);
		MenuItem miCopy = new MenuItem();		//uRs[vj[ACe
		miCopy.Text = "Rs[(&C)";
		miCopy.Index = 1;
		miCopy.Click += OnCopy_Click;
		miCopy.Shortcut = Shortcut.CtrlC;
		miEdit.MenuItems.Add(miCopy);
		MenuItem miPaste = new MenuItem();		//u\tvj[ACe
		miPaste.Text = "\t(&P)";
		miPaste.Index = 2;
		miPaste.Click += OnPaste_Click;
		miPaste.Shortcut = Shortcut.CtrlP;
		miEdit.MenuItems.Add(miPaste);
		miEdit.MenuItems.Add("-");				//Zp[^[
		MenuItem miFont = new MenuItem();		//utHgvj[ACe
		miFont.Text = "tHg(&F)";
		miFont.Index = 3;
		miFont.Click += OnFont_Click;
		miFont.Shortcut = Shortcut.CtrlF;
		miEdit.MenuItems.Add(miFont);
		miEdit.MenuItems.Add("-");				//Zp[^[
		MenuItem miFind = new MenuItem();		//uvj[ACe
		miFind.Text = "(&F)";
		miFind.Index = 4;
		miFind.Click += OnFind_Click;
		miFind.Shortcut = Shortcut.CtrlF;
		miEdit.MenuItems.Add(miFind);
		MenuItem miReplace = new MenuItem();	//uuvj[ACe
		miReplace.Text = "u(&R)";
		miReplace.Index = 5;
		miReplace.Click += OnReplace_Click;
		miReplace.Shortcut = Shortcut.CtrlR;
		miEdit.MenuItems.Add(miReplace);
		MenuItem miHowtoUse = new MenuItem();	//ugvj[ACe
		miHowtoUse.Text = "g(&U)";
		miHowtoUse.Index = 0;
		miHowtoUse.Click += OnHowtoUse_Click;
		miHelp.MenuItems.Add(miHowtoUse);
		MenuItem miVer = new MenuItem();		//uo[Wvj[ACe
		miVer.Text = "o[W(&V)";
		miVer.Index = 1;
		miVer.Click += OnVersion_Click;
		miVer.Shortcut = Shortcut.CtrlV;
		miHelp.MenuItems.Add(miVer);
	}

	//c[o[ƃXe[^Xo[Rg[̐ݒ
	protected void SetControls()
	{
		//tH[̃CAEgꎞ~
		this.SuspendLayout();
		//ToolStripNXCX^X̐
		this.toolStrip = new ToolStrip();
		//c[o[̃CAEgꎞ~
		this.toolStrip.SuspendLayout();
		//ToolStripButtonz쐬
		this.toolStripButton = new ToolStripButton[12];
		//{vO̖ߍ݃\[X̃\[X}l[W[쐬
		Assembly asm = Assembly.GetExecutingAssembly();
		ResourceManager rm = new ResourceManager("FormSDISkelton", asm);
		//c[o[rbg}bv̓ǂݍ
		ImageList imgList = new ImageList();
		imgList.ImageSize = new Size(16, 15);
		imgList.Images.AddStrip((Bitmap)rm.GetObject("ToolBar"));
		imgList.TransparentColor = Color.White;
		//ToolStripButton[0]쐬
		this.toolStripButton[0] = new ToolStripButton();
		this.toolStripButton[0].Text = "VK쐬(&N)";							//eLXgݒ
		this.toolStripButton[0].Image = (Bitmap)imgList.Images[0];				//摜ݒ
		this.toolStripButton[0].DisplayStyle = ToolStripItemDisplayStyle.Image;	//摜\̂
		this.toolStripButton[0].Click += OnNew_Click;							//ClickCxgnhǉ
		this.toolStrip.Items.Add(this.toolStripButton[0]);						//{^ǉ
		//ToolStripButton[1]쐬
		this.toolStripButton[1] = new ToolStripButton();
		this.toolStripButton[1].Text = "J(&O)";								//eLXgݒ
		this.toolStripButton[1].Image = (Bitmap)imgList.Images[1];				//摜ݒ
		this.toolStripButton[1].DisplayStyle = ToolStripItemDisplayStyle.Image;	//摜\̂
		this.toolStripButton[1].Click += OnOpen_Click;							//ClickCxgnhǉ
		this.toolStrip.Items.Add(this.toolStripButton[1]);						//{^ǉ
		//ToolStripButton[2]쐬
		this.toolStripButton[2] = new ToolStripButton();
		this.toolStripButton[2].Text = "ۑ(&S)";								//eLXgݒ
		this.toolStripButton[2].Image = (Bitmap)imgList.Images[2];				//摜ݒ
		this.toolStripButton[2].DisplayStyle = ToolStripItemDisplayStyle.Image;	//摜\̂
		this.toolStripButton[2].Click += OnSave_Click;							//ClickCxgnhǉ
		this.toolStrip.Items.Add(this.toolStripButton[2]);						//{^ǉ
		//Zp[^[}
		this.toolStrip.Items.Add(new ToolStripSeparator());
		//ToolStripButton[3]쐬
		this.toolStripButton[3] = new ToolStripButton();
		this.toolStripButton[3].Text = "I(&X)";								//eLXgݒ
		this.toolStripButton[3].Image = (Bitmap)imgList.Images[3];				//摜ݒ
		this.toolStripButton[3].DisplayStyle = ToolStripItemDisplayStyle.Image;	//摜\̂
		this.toolStripButton[3].Click += OnExit_Click;							//ClickCxgnhǉ
		this.toolStrip.Items.Add(this.toolStripButton[3]);						//{^ǉ
		//Zp[^[}
		this.toolStrip.Items.Add(new ToolStripSeparator());
		//ToolStripButton[4]쐬
		this.toolStripButton[4] = new ToolStripButton();
		this.toolStripButton[4].Text = "؂(&T)";							//eLXgݒ
		this.toolStripButton[4].Image = (Bitmap)imgList.Images[4];				//摜ݒ
		this.toolStripButton[4].DisplayStyle = ToolStripItemDisplayStyle.Image;	//摜\̂
		this.toolStripButton[4].Click += OnCut_Click;							//ClickCxgnhǉ
		this.toolStrip.Items.Add(this.toolStripButton[4]);						//{^ǉ
		//ToolStripButton[5]쐬
		this.toolStripButton[5] = new ToolStripButton();
		this.toolStripButton[5].Text = "Rs[(&C)";							//eLXgݒ
		this.toolStripButton[5].Image = (Bitmap)imgList.Images[5];				//摜ݒ
		this.toolStripButton[5].DisplayStyle = ToolStripItemDisplayStyle.Image;	//摜\̂
		this.toolStripButton[5].Click += OnCopy_Click;							//ClickCxgnhǉ
		this.toolStrip.Items.Add(this.toolStripButton[5]);						//{^ǉ
		//ToolStripButton[6]쐬
		this.toolStripButton[6] = new ToolStripButton();
		this.toolStripButton[6].Text = "\t(&P)";							//eLXgݒ
		this.toolStripButton[6].Image = (Bitmap)imgList.Images[6];				//摜ݒ
		this.toolStripButton[6].DisplayStyle = ToolStripItemDisplayStyle.Image;	//摜\̂
		this.toolStripButton[6].Click += OnPaste_Click;							//ClickCxgnhǉ
		this.toolStrip.Items.Add(this.toolStripButton[6]);						//{^ǉ
		//Zp[^[}
		this.toolStrip.Items.Add(new ToolStripSeparator());
		//ToolStripButton[7]쐬
		this.toolStripButton[7] = new ToolStripButton();
		this.toolStripButton[7].Text = "tHg(&F)";							//eLXgݒ
		this.toolStripButton[7].Image = (Bitmap)imgList.Images[7];				//摜ݒ
		this.toolStripButton[7].DisplayStyle = ToolStripItemDisplayStyle.Image;	//摜\̂
		this.toolStripButton[7].Click += OnFont_Click;							//ClickCxgnhǉ
		this.toolStrip.Items.Add(this.toolStripButton[7]);						//{^ǉ
		//Zp[^[}
		this.toolStrip.Items.Add(new ToolStripSeparator());
		//ToolStripButton[8]쐬
		this.toolStripButton[8] = new ToolStripButton();
		this.toolStripButton[8].Text = "(&F)";								//eLXgݒ
		this.toolStripButton[8].Image = (Bitmap)imgList.Images[8];				//摜ݒ
		this.toolStripButton[8].DisplayStyle = ToolStripItemDisplayStyle.Image;	//摜\̂
		this.toolStripButton[8].Click += OnFind_Click;							//ClickCxgnhǉ
		this.toolStrip.Items.Add(this.toolStripButton[8]);						//{^ǉ
		//ToolStripButton[9]쐬
		this.toolStripButton[9] = new ToolStripButton();
		this.toolStripButton[9].Text = "u(&R)";								//eLXgݒ
		this.toolStripButton[9].Image = (Bitmap)imgList.Images[9];				//摜ݒ
		this.toolStripButton[9].DisplayStyle = ToolStripItemDisplayStyle.Image;	//摜\̂
		this.toolStripButton[9].Click += OnReplace_Click;						//ClickCxgnhǉ
		this.toolStrip.Items.Add(this.toolStripButton[9]);						//{^ǉ
		//Zp[^[}
		this.toolStrip.Items.Add(new ToolStripSeparator());
		//ToolStripButton[10]쐬
		this.toolStripButton[10] = new ToolStripButton();
		this.toolStripButton[10].Text = "g(&U)";							//eLXgݒ
		this.toolStripButton[10].Image = (Bitmap)imgList.Images[10];			//摜ݒ
		this.toolStripButton[10].DisplayStyle = ToolStripItemDisplayStyle.Image;	//摜\̂
		this.toolStripButton[10].Click += OnHowtoUse_Click;						//ClickCxgnhǉ
		this.toolStrip.Items.Add(this.toolStripButton[10]);						//{^ǉ
		//ToolStripButton[11]쐬
		this.toolStripButton[11] = new ToolStripButton();
		this.toolStripButton[11].Text = "o[W(&V)";					//eLXgݒ
		this.toolStripButton[11].Image = (Bitmap)imgList.Images[11];			//摜ݒ
		this.toolStripButton[11].DisplayStyle = ToolStripItemDisplayStyle.Image;	//摜\̂
		this.toolStripButton[11].Click += OnVersion_Click;						//ClickCxgnhǉ
		this.toolStrip.Items.Add(this.toolStripButton[11]);						//{^ǉ
		//c[o[̐ݒ
		this.Controls.Add(this.toolStrip);
		//c[o[̃CAEgĊJ
		this.toolStrip.ResumeLayout(false);
		this.toolStrip.PerformLayout();

		//StatusStripNXCX^X̐
		this.statusStrip = new StatusStrip();
		//Xe[^Xo[ɃplƃeLXgǉ
		tssl = new ToolStripStatusLabel[3];
		tssl[0] = new ToolStripStatusLabel();
		tssl[0].BorderSides = ToolStripStatusLabelBorderSides.All;
		tssl[0].BorderStyle = Border3DStyle.SunkenInner;
		tssl[0].BackColor = SystemColors.Control;
		tssl[0].Text = "FormMDISkelton Ver. 1.0";
		tssl[0].AutoSize = true;
		tssl[0].TextAlign = ContentAlignment.MiddleLeft;
		tssl[1] = new ToolStripStatusLabel();
		tssl[1].BorderSides = ToolStripStatusLabelBorderSides.All;
		tssl[1].BorderStyle = Border3DStyle.SunkenInner;
		tssl[1].BackColor = SystemColors.Control;
		tssl[1].Text = "ibZ[WPj";
		tssl[1].AutoSize = true;
		tssl[1].TextAlign = ContentAlignment.MiddleLeft;
		tssl[2] = new ToolStripStatusLabel();
		tssl[2].BorderSides = ToolStripStatusLabelBorderSides.All;
		tssl[2].BorderStyle = Border3DStyle.SunkenInner;
		tssl[2].BackColor = SystemColors.Control;
		tssl[2].Text = "ibZ[WQj";
		tssl[2].ToolTipText = "ibZ[WQj";	//ToolTipݒ
		tssl[2].Spring = true;
		tssl[2].TextAlign = ContentAlignment.MiddleLeft;
		statusStrip.Items.AddRange(tssl);
		statusStrip.ShowItemToolTips = true;		//ToolTip\
		this.Controls.Add(this.statusStrip);		//StatusStrip(Xe[^Xo[)ǉ
		//CtH[̃CAEgĊJ
		this.ResumeLayout(false);
		this.PerformLayout();
	}

	//uVKv
	private void OnNew_Click(object sender, EventArgs e)
	{
		MessageBox.Show("݂܂AHł", "H", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
	}

	//ut@CJv
	private void OnOpen_Click(object sender, EventArgs e)
	{
		DialogResult dr = MessageBox.Show("C#t@CJ܂Hiu͂vj\r\nƂẴt@CłHiuvj\r\n͒~܂HiuLZvj", "t@CފmF", MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question);
		OpenFileDialog ofDlg = new OpenFileDialog();
		ofDlg.AddExtension = true;	//gqt
		switch(dr)
		{
		case DialogResult.Yes:
			ofDlg.FileName = "*.cs";	//gq
			ofDlg.FilterIndex = 1;		//t@CtB^[CfbNX
			break;
		case DialogResult.No:
			ofDlg.FileName = "*.*";		//gq
			ofDlg.FilterIndex = 2;		//t@CtB^[CfbNX
			break;
		default:
			return;
		}
		//t@CtB^[̎w
		ofDlg.Filter = "C#t@C(*.cs)|*.cs|Ẵt@C(*.*)|*.*";
		ofDlg.RestoreDirectory = true;	//fBNg֕A
		ofDlg.CheckFileExists = true;	//t@C̑݃`FbN
		ofDlg.CheckPathExists = true;	//t@CpX̑݃`FbN
		ofDlg.InitialDirectory = ".";	// ftHg̃tH_[̎w
		ofDlg.Title = "t@CJ";	//_CAÕ^Cgw肷
		if(ofDlg.ShowDialog() == DialogResult.OK)	//_CAO\
		{
		}
		else
		{
			MessageBox.Show("LZ܂B", "LZ", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
		}
		// IuWFNgj
		ofDlg.Dispose();
	}

	//uۑv
	private void OnSave_Click(object sender, EventArgs e)
	{
		MessageBox.Show("݂܂AHł", "H", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
	}

	//uOtĕۑv
	private void OnSaveAs_Click(object sender, EventArgs e)
	{
		MessageBox.Show("݂܂AHł", "H", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
	}

	//uIv
	private void OnExit_Click(object sender, EventArgs e)
	{
		Close();	//CmFOnClosing\bhōs
	}

	//u؂v
	private void OnCut_Click(object sender, EventArgs e)
	{
		MessageBox.Show("݂܂AHł", "H", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
	}

	//uRs[v
	private void OnCopy_Click(object sender, EventArgs e)
	{
		MessageBox.Show("݂܂AHł", "H", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
	}

	//u\tv
	private void OnPaste_Click(object sender, EventArgs e)
	{
		MessageBox.Show("݂܂AHł", "H", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
	}

	//utHgv
	private void OnFont_Click(object sender, EventArgs e)
	{
		MessageBox.Show("݂܂AHł", "H", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
	}

	//uv
	private void OnFind_Click(object sender, EventArgs e)
	{
		MessageBox.Show("݂܂AHł", "H", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
	}

	//uuv
	private void OnReplace_Click(object sender, EventArgs e)
	{
		MessageBox.Show("݂܂AHł", "H", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
	}

	//ugv
	private void OnHowtoUse_Click(object sender, EventArgs e)
	{
		MessageBox.Show("gł", "j[ACe", MessageBoxButtons.OK, MessageBoxIcon.Information);
	}

	//uo[Wv
	private void OnVersion_Click(object sender, EventArgs e)
	{
		VersionDlg verDlg = new VersionDlg(this.Icon);
		verDlg.ShowDialog();
	}
/*
	//Btn1ꂽꍇ̏
	static void OnBtn1Click(object sender, EventArgs e)
	{
	}

	//Btn2ꂽꍇ̏
	static void OnBtn2Click(object sender, EventArgs e)
	{
	}

*/
}

/////////////////////
//Version _CAO
/////////////////////
class VersionDlg : Form
{
	public VersionDlg(Icon ico)
	{
		//_CAȎݒ
		this.Text = "o[V";
		this.ClientSize = new Size(320, 100);
		this.MaximizeBox = false;		// ő剻{^
		this.MinimizeBox = false;		// ŏ{^
		this.ShowInTaskbar = false;		//^XNo[\
		this.FormBorderStyle = FormBorderStyle.FixedDialog;		// ẼX^C
		this.StartPosition = FormStartPosition.CenterParent;	// etH[̒ɔzu
		//Rg[̑ݒ
		Button btnOK = new Button();
		btnOK.Size = new Size(40, 28);
		btnOK.Location = new Point(ClientSize.Width - btnOK.Width - 10, (ClientSize.Height - btnOK.Height) / 2);
		btnOK.Text = "OK";
		btnOK.Click += new EventHandler(OnOK_Click);
		Label imglabel = new Label();
		imglabel.Size = new Size(40, 40);
		imglabel.Location = new Point(10, (ClientSize.Height - imglabel.Height) / 2);
		imglabel.BorderStyle = BorderStyle.Fixed3D;
		imglabel.Image = ico.ToBitmap();	//ẽVXeACR
		Label label = new Label();
		label.Size = new Size(ClientSize.Width - imglabel.Width - btnOK.Width - 40, ClientSize.Height- 20);
		label.Location = new Point(imglabel.Width + 20, (ClientSize.Height - label.Height) / 2);
		label.BorderStyle = BorderStyle.Fixed3D;
		label.Text = "C# SDI Skelton Version 1.0\r\nCopyright (c) 2023 by Ysama\r\n(written in Microsoft C#)";
		label.TextAlign = ContentAlignment.MiddleCenter;
		label.Font = new Font("Times New Roman", 10, FontStyle.Bold);
		this.Controls.Add(btnOK);
		this.Controls.Add(imglabel);
		this.Controls.Add(label);
	}

	private void OnOK_Click(object sender, EventArgs e)
	{
		Close();
	}
}
