///////////////////////////////////////
// ResReader.cs - Resource File Reader
// Copyright (c) 2022 by Ysama
///////////////////////////////////////

using System;
using System.Collections;
using System.Windows.Forms;
using System.Drawing;
using System.Drawing.Imaging;
using System.Reflection;		//Assemblyg
using System.Resources;			//\[X֌WNX̎gp̈
using System.IO;				//Stream֌WNX̎gp̈

//Gg[|CgNX
class WinMain
{
	[STAThread]
	public static void Main()
	{
		MainForm mf = new MainForm();
		Application.Run(mf);
	}
}

///////////////////////
//CtH[NX
///////////////////////
public partial class MainForm : Form
{
	//NXo[ϐ
	ToolStrip toolStrip;						//c[o[
	ToolStripButton[] toolStripButton;			//c[o[{^
	StatusStrip statusStrip;					//Xe[^Xo[
	ToolStripStatusLabel[] tssl;				//Xe[^Xo[x
	ListView listView;							//Xgr[
	bool FileType = true;						//t@Cށi*.resources|trueA*.resx|falsej
	string ResFileName = "";					//ǂݍރ\[Xt@C

	//RXgN^[
	public MainForm()
	{
		Assembly myOwn = Assembly.GetEntryAssembly();
		this.Icon = Icon.ExtractAssociatedIcon(myOwn.Location);	//vOACRtH[ɂ
		this.Load += new EventHandler(MainForm_Load);
		this.Text = "ResReader";
		this.ClientSize = new Size(724, 262);
		this.MinimumSize = new Size(372, 258);
		this.BackColor = SystemColors.Window;
	}

	//WM_CREATE
	private void MainForm_Load(object sender, EventArgs e)
	{
		//j[쐬
		SetMenu();
		//c[o[ƃXe[^Xo[쐬
		SetBars();
		//Xgr[쐬
		SetListView();
	}

	//j[̐ݒ
	protected void SetMenu()
	{
		//j[쐬
		MainMenu menu = new MainMenu();
		Menu = menu;
		//j[ACet
		MenuItem miFile = new MenuItem();		//ut@Cvj[
		miFile.Text = "t@C(&F)";
		miFile.Index = 0;
		menu.MenuItems.Add(miFile);
		MenuItem miHelp = new MenuItem();		//uwvvj[
		miHelp.Text = "wv(&H)";
		miHelp.Index = 1;
		menu.MenuItems.Add(miHelp);
		MenuItem miOpen = new MenuItem();		//uJvj[ACe
		miOpen.Text = "J(&O)";
		miOpen.Index = 0;
		miOpen.Click += OnOpen_Click;
		miOpen.Shortcut = Shortcut.CtrlO;
		miFile.MenuItems.Add(miOpen);
		MenuItem miSave = new MenuItem();		//uۑvj[ACe
		miSave.Text = "ۑ(&S)";
		miSave.Index = 1;
		miSave.Click += OnSave_Click;
		miSave.Shortcut = Shortcut.CtrlS;
		miFile.MenuItems.Add(miSave);
		miFile.MenuItems.Add("-");				//Zp[^[
		MenuItem miExit = new MenuItem();		//uIvj[ACe
		miExit.Text = "I(&X)";
		miExit.Index = 2;
		miExit.Click += OnExit_Click;
		miExit.Shortcut = Shortcut.CtrlX;
		miFile.MenuItems.Add(miExit);
		MenuItem miHowtoUse = new MenuItem();	//ugvj[ACe
		miHowtoUse.Text = "g(&U)";
		miHowtoUse.Index = 0;
		miHowtoUse.Click += OnHowtoUse_Click;
		miHelp.MenuItems.Add(miHowtoUse);
		MenuItem miVer = new MenuItem();		//uo[Wvj[ACe
		miVer.Text = "o[W(&V)";
		miVer.Index = 1;
		miVer.Click += OnVersion_Click;
		miVer.Shortcut = Shortcut.CtrlV;
		miHelp.MenuItems.Add(miVer);
	}

	//c[o[ƃXe[^Xo[̐ݒ
	protected void SetBars()
	{
		//tH[̃CAEgꎞ~
		this.SuspendLayout();
		//ToolStripNXCX^X̐
		this.toolStrip = new ToolStrip();
		//c[o[̃CAEgꎞ~
		this.toolStrip.SuspendLayout();
		//ToolStripButtonz쐬
		this.toolStripButton = new ToolStripButton[5];
		//{vO̖ߍ݃\[XiResReaderj̃\[X}l[W[쐬
		Assembly asm = Assembly.GetExecutingAssembly();
		ResourceManager rm = new ResourceManager("ResReader", asm);
		//ToolStripButton[0]쐬
		this.toolStripButton[0] = new ToolStripButton();
		this.toolStripButton[0].Text = "J(&O)";								//eLXgݒ
		this.toolStripButton[0].Image = (Bitmap)rm.GetObject("bmpOpen");		//摜ݒ
		this.toolStripButton[0].DisplayStyle = ToolStripItemDisplayStyle.Image;	//摜\̂
		this.toolStripButton[0].Click += OnOpen_Click;							//ClickCxgnhǉ
		this.toolStrip.Items.Add(this.toolStripButton[0]);						//{^ǉ
		//ToolStripButton[1]쐬
		this.toolStripButton[1] = new ToolStripButton();
		this.toolStripButton[1].Text = "ۑ(&S)";								//eLXgݒ
		this.toolStripButton[1].Image = (Bitmap)rm.GetObject("bmpSave");		//摜ݒ
		this.toolStripButton[1].DisplayStyle = ToolStripItemDisplayStyle.Image;	//摜\̂
		this.toolStripButton[1].Click += OnSave_Click;							//ClickCxgnhǉ
		this.toolStrip.Items.Add(this.toolStripButton[1]);						//{^ǉ
		//Zp[^[}
		this.toolStrip.Items.Add(new ToolStripSeparator());
		//ToolStripButton[2]쐬
		this.toolStripButton[2] = new ToolStripButton();
		this.toolStripButton[2].Text = "I(&X)";								//eLXgݒ
		this.toolStripButton[2].Image = (Bitmap)rm.GetObject("bmpExit");		//摜ݒ
		this.toolStripButton[2].DisplayStyle = ToolStripItemDisplayStyle.Image;	//摜\̂
		this.toolStripButton[2].Click += OnExit_Click;							//ClickCxgnhǉ
		this.toolStrip.Items.Add(this.toolStripButton[2]);						//{^ǉ
		//Zp[^[}
		this.toolStrip.Items.Add(new ToolStripSeparator());
		//ToolStripButton[3]쐬
		this.toolStripButton[3] = new ToolStripButton();
		this.toolStripButton[3].Text = "g(&U)";							//eLXgݒ
		this.toolStripButton[3].Image = (Bitmap)rm.GetObject("bmpHelp");		//摜ݒ
		this.toolStripButton[3].DisplayStyle = ToolStripItemDisplayStyle.Image;	//摜\̂
		this.toolStripButton[3].Click += OnHowtoUse_Click;						//ClickCxgnhǉ
		this.toolStrip.Items.Add(this.toolStripButton[3]);						//{^ǉ
		//ToolStripButton[4]쐬
		this.toolStripButton[4] = new ToolStripButton();
		this.toolStripButton[4].Text = "o[W(&V)";					//eLXgݒ
		this.toolStripButton[4].Image = (Bitmap)rm.GetObject("bmpVersion");		//摜ݒ
		this.toolStripButton[4].DisplayStyle = ToolStripItemDisplayStyle.Image;	//摜\̂
		this.toolStripButton[4].Click += OnVersion_Click;						//ClickCxgnhǉ
		this.toolStrip.Items.Add(this.toolStripButton[4]);						//{^ǉ
		//c[o[̐ݒ
		this.Controls.Add(this.toolStrip);
		//c[o[̃CAEgĊJ
		this.toolStrip.ResumeLayout(false);
		this.toolStrip.PerformLayout();

		//StatusStripNXCX^X̐
		this.statusStrip = new StatusStrip();
		//Xe[^Xo[ɃplƃeLXgǉ
		tssl = new ToolStripStatusLabel[3];
		tssl[0] = new ToolStripStatusLabel();
		tssl[0].BorderSides = ToolStripStatusLabelBorderSides.All;
		tssl[0].BorderStyle = Border3DStyle.SunkenInner;
		tssl[0].BackColor = SystemColors.Control;
		tssl[0].Text = "ResReader Version 1.0";
		tssl[0].AutoSize = true;
		tssl[0].TextAlign = ContentAlignment.MiddleLeft;
		tssl[1] = new ToolStripStatusLabel();
		tssl[1].BorderSides = ToolStripStatusLabelBorderSides.All;
		tssl[1].BorderStyle = Border3DStyle.SunkenInner;
		tssl[1].BackColor = SystemColors.Control;
		tssl[1].Text = "iI\[Xt@Cj";
		tssl[1].AutoSize = true;
		tssl[1].TextAlign = ContentAlignment.MiddleLeft;
		tssl[2] = new ToolStripStatusLabel();
		tssl[2].BorderSides = ToolStripStatusLabelBorderSides.All;
		tssl[2].BorderStyle = Border3DStyle.SunkenInner;
		tssl[2].BackColor = SystemColors.Control;
		tssl[2].Text = "i\[Xt@Cj";
		tssl[2].ToolTipText = "i\[Xt@Cj";	//ToolTipݒ
		tssl[2].Spring = true;
		tssl[2].TextAlign = ContentAlignment.MiddleLeft;
		statusStrip.Items.AddRange(tssl);
		statusStrip.ShowItemToolTips = true;			//ToolTip\
		this.Controls.Add(this.statusStrip);	//StatusStrip(Xe[^Xo[)ǉ

		//CtH[̃CAEgĊJ
		this.ResumeLayout(false);
		this.PerformLayout();
	}

	protected void SetListView()
	{
		//Xgr[
		listView = new ListView();
		//E
		listView.BorderStyle = BorderStyle.Fixed3D;
		//ʒu
		listView.Location = new Point(0, toolStrip.Height);
		//TCY
		listView.Width = ClientSize.Width;
		listView.Height = ClientSize.Height - toolStrip.Height - statusStrip.Height;
		//AJ[Œ
		listView.Anchor = (AnchorStyles.Top | AnchorStyles.Left | AnchorStyles.Bottom | AnchorStyles.Right);
		//sI
		listView.FullRowSelect = true;
		//ObhC̕\
		listView.GridLines = true;
		//ёւ\
		listView.Sorting = SortOrder.Ascending;
		//|CgőIł悤ɂ
		listView.HoverSelection = false;
		//VONbNI
		listView.Activation = ItemActivation.OneClick;
		//`FbN{bNXL
		listView.CheckBoxes = false;
		//Xgr[̕\@
		listView.View = View.Details;
		//Cxgnh̒ǉ
		listView.ItemActivate += new EventHandler(ListView_ItemActivate);
		listView.ColumnClick += new ColumnClickEventHandler(ListView_ColumnClick);
		listView.ItemSelectionChanged += new ListViewItemSelectionChangedEventHandler(ListView_ItemChanged);
		//wb_[`
		ColumnHeader columnNo = new ColumnHeader{Text = "O", Width = 100};
		ColumnHeader columnType = new ColumnHeader{Text = "", Width = 60};
		ColumnHeader columnData = new ColumnHeader{Text = "f[^", Width = 558};
		ColumnHeader[] colHeaderRegValue = {columnNo, columnType, columnData};	//wb_[ݒ
		listView.Columns.AddRange(colHeaderRegValue);	//wb_[ǉ
		//FormListViewǉ
		this.Controls.Add(listView);
	}

	private void ListView_ItemActivate(object sender, EventArgs e)
	{
		//ACeANeBuɂȂ
		ListView lv = (ListView)sender;
		//tH[JX̂ACeText\
		tssl[1].Text = lv.FocusedItem.Text;
	}

	private void ListView_ColumnClick(object sender, ColumnClickEventArgs e)
	{
		//ListViewItemSorterw肷
		listView.ListViewItemSorter = new ListViewItemComparer(e.Column);
		//ёւiListViewItemSorterݒ肷SortIɌĂяoj
	}

	private void ListView_ItemChanged(object sender, ListViewItemSelectionChangedEventArgs e)
	{
		//tH[JX̂ACeText\
		ListView lv = (ListView)sender;
		tssl[1].Text = lv.FocusedItem.Text;
	}

	//I
	protected override void OnFormClosing(FormClosingEventArgs e)
	{
		base.OnFormClosing(e);
		DialogResult dr = MessageBox.Show("I܂H", "mF", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
		if(dr == DialogResult.No)
		{
			e.Cancel = true;
		}
	}

	//ut@CJv
	private void OnOpen_Click(object sender, EventArgs e)
	{
		DialogResult dr = MessageBox.Show(".resourcest@CJ܂Hiu͂vj\r\nƂ.resxt@CłHiuvj\r\n~܂HiuLZvj", "t@CފmF", MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question);
		switch(dr)
		{
		case DialogResult.Yes:
			MessageBox.Show(".resourcest@CJ܂B", "t@CJ", MessageBoxButtons.OK, MessageBoxIcon.Information);
			FileType = true;
			break;
		case DialogResult.No:
			MessageBox.Show(".resxt@CJ܂B", "t@CJ", MessageBoxButtons.OK, MessageBoxIcon.Information);
			FileType = false;
			break;
		default:
			return;
		}
		OpenFileDialog ofDlg = new OpenFileDialog();
		ofDlg.AddExtension = true;	//gqt
		if(FileType)				//gqw
			ofDlg.FileName = "*.resources";
		else
			ofDlg.FileName = "*.resx";
		//t@CtB^[̎w
		ofDlg.Filter = "\[Xt@C(*.resources)|*.resources|XML\[Xt@C(*.resx)|*.resx";
		if(FileType)	//t@CtB^[CfbNX̎w
			ofDlg.FilterIndex = 1;
		else
			ofDlg.FilterIndex = 2;
		ofDlg.RestoreDirectory = true;	//fBNg֕A
		ofDlg.CheckFileExists = true;	//t@C̑݃`FbN
		ofDlg.CheckPathExists = true;	//t@CpX̑݃`FbN
		ofDlg.InitialDirectory = ".";	// ftHg̃tH_[̎w
		ofDlg.Title = "t@CJ";	//_CAÕ^Cgw肷
		if(ofDlg.ShowDialog() == DialogResult.OK)	//_CAO\
		{
			ResFileName = ofDlg.FileName;		//\[Xt@C̃pXAۑ
			tssl[2].Text = ResFileName;			//Xe[^Xo[Ƀt@CpXA\
			tssl[2].ToolTipText = ResFileName;	//Xe[^Xo[c[`bvɃt@CpXAݒ
			listView.Items.Clear();				//̃Xgr[̃f[^
			if(FileType)
			{	//*.resourcest@C̓ǂݍ(usinggDispose)
				using(ResourceReader resReader = new ResourceReader(ResFileName))
				{
					IDictionaryEnumerator iDict = resReader.GetEnumerator();
					string str;
					ListViewItem add_item;
					while(iDict.MoveNext())
					{
						str = String.Format("{0}", iDict.Key);
						add_item = listView.Items.Add(str);
						str = String.Format("{0}", iDict.Value.GetType().Name);
						add_item.SubItems.Add(str);
						str = String.Format("{0}", iDict.Value);
						add_item.SubItems.Add(str);
					}
				}
			}
			else
			{	//*.resxt@C̓ǂݍ(usinggDispose)
				using (ResXResourceReader resxReader = new ResXResourceReader(ResFileName))
				{
					IDictionaryEnumerator iDict = resxReader.GetEnumerator();
					string str;
					ListViewItem add_item;
					while(iDict.MoveNext())
					{
						str = String.Format("{0}", iDict.Key);
						add_item = listView.Items.Add(str);
						str = String.Format("{0}", iDict.Value.GetType().Name);
						add_item.SubItems.Add(str);
						str = String.Format("{0}", iDict.Value);
						add_item.SubItems.Add(str);
					}
				}
			}
		}
		else
		{
			MessageBox.Show("LZ܂B", "LZ", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
		}
		// IuWFNgj
		ofDlg.Dispose();
	}

	//uۑv
	private void OnSave_Click(object sender, EventArgs e)
	{
		//IꂽsmF
		if(listView.SelectedItems.Count == 0)
			MessageBox.Show("f[^IĂ܂", "G[", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
		else
		{
			//IꂽACeۑ
			foreach(ListViewItem item in listView.SelectedItems)
			{
				SaveDlg savedlg = new SaveDlg(item.SubItems[0].Text, item.SubItems[1].Text, item.SubItems[2].Text, FileType, ResFileName);
				savedlg.ShowDialog();
				//ׂĂString\[X".restext"t@CƂĕۑ
				if(savedlg.ResType == "StrResCollection")
				{
					string res_str = "";
					foreach(ListViewItem str_item in listView.Items)
					{
						if(str_item.SubItems[1].Text == "String")
						{
							res_str += (str_item.SubItems[0].Text + "=" + str_item.SubItems[2].Text + "\n");
						}
					}
					//Text\[X̕ۑ
					string path = savedlg.ResData;
					path = Path.ChangeExtension(path, ".restext");
					using(StreamWriter sw = new StreamWriter(path))
					{
						sw.Write(res_str);
						sw.Close();
					}
				}
				savedlg.Dispose();
			}
		}
	}

	//uIv
	private void OnExit_Click(object sender, EventArgs e)
	{
		Close();	//CmFOnClosing\bhōs
	}

	//ugv
	private void OnHowtoUse_Click(object sender, EventArgs e)
	{
		MessageBox.Show("gł", "j[ACe", MessageBoxButtons.OK, MessageBoxIcon.Information);
	}

	//uo[Wv
	private void OnVersion_Click(object sender, EventArgs e)
	{
		VersionDlg verDlg = new VersionDlg(this.Icon);
		verDlg.ShowDialog();
		verDlg.Dispose();
	}
}

///////////////////////////////////////////
//ListView̍ڂ̕ёւɎgpNX
///////////////////////////////////////////
public class ListViewItemComparer : IComparer
{
	private int m_column;

	// ListViewItemComparerNX̃RXgN^
	public ListViewItemComparer(int col)
	{
		m_column = col;
	}

	//xy菬Ƃ̓}CiX̐A傫Ƃ̓vX̐AƂ0Ԃ
	public int Compare(object x, object y)
	{
		//ListViewItem̎擾
		ListViewItem itemx = (ListViewItem) x;
		ListViewItem itemy = (ListViewItem) y;
		//xy𕶎ƂĔr
		return string.Compare(itemx.SubItems[m_column].Text, itemy.SubItems[m_column].Text);
	}
}

/////////////////////////
//\[Xۑ_CAO
/////////////////////////
class SaveDlg : Form
{
	//vpeB
	string m_Name = "";
	public string ResName
	{
		get
		{
			return m_Name;
		}
		set
		{
			m_Name = value;
		}
	}

	protected string m_Type = "";
	public string ResType
	{
		get
		{
			return m_Type;
		}
		set
		{
			m_Type = value;
		}
	}

	protected string m_Data = "";
	public string ResData
	{
		get
		{
			return m_Data;
		}
		set
		{
			m_Data = value;
		}
	}

	//\[Xt@Cƃ^Cv
	bool FileType = true;
	string ResFileName = "";

	//_CAÕRg[
	Button BtnOK;
	Button BtnCancel;
	Label labelName;
	TextBox txbName;
	GroupBox gBox;
	RadioButton rdBtnImg;
	RadioButton rdBtnFile;
	RadioButton rdBtnStr;
	Button BtnShow;
	Label labelData;
	Button BtnSelFile;
	TextBox txbPath;

	public SaveDlg(string arg_name, string arg_type, string arg_data, bool arg_ftype, string arg_filename)
	{
		//̋L^
		m_Name = arg_name;
		m_Type = arg_type;
		m_Data = arg_data;
		FileType = arg_ftype;
		ResFileName = arg_filename;

		//_CAȎݒ
		this.Text = "\[Xۑ_CAO";
		this.ClientSize = new Size(320, 220);
		this.MaximizeBox = false;		// ő剻{^
		this.MinimizeBox = false;		// ŏ{^
		this.ShowInTaskbar = false;		//^XNo[\
		this.FormBorderStyle = FormBorderStyle.FixedDialog;		// ẼX^C
		this.StartPosition = FormStartPosition.CenterParent;	// etH[̒ɔzu

		//Rg[̑ݒ
		BtnOK = new Button();
		BtnOK.TabIndex = 2;
		BtnOK.Location = new Point(20, ClientSize.Height - BtnOK.Height - 10);
		BtnOK.Text = "OK";
		BtnOK.AutoSize = true;
		BtnOK.Click += new EventHandler(OnOK_Click);

		BtnCancel = new Button();
		BtnCancel.TabIndex = 3;
		BtnCancel.Location = new Point(ClientSize.Width - BtnCancel.Width - 20, ClientSize.Height - BtnCancel.Height - 10);
		BtnCancel.Text = "Cancel";
		BtnCancel.AutoSize = true;
		BtnCancel.Click += new EventHandler(OnCancel_Click);

		labelName = new Label();
		labelName.Text = "\[X";
		labelName.Location = new Point(10, 10);
		labelName.AutoSize = true;

		txbName = new TextBox();
		txbName.Text = m_Name;
		txbName.ReadOnly = true;
		txbName.BorderStyle = BorderStyle.Fixed3D;
		txbName.Location = new Point(20 + labelName.Width, 10);
		txbName.Size = new Size(ClientSize.Width - labelName.Width - 30, 16);

		gBox = new GroupBox();
		gBox.Text = "\[X敪";
		gBox.Location = new Point(5, labelName.Height + 10);
		gBox.Size = new Size(ClientSize.Width - 10, 40);

		rdBtnImg = new RadioButton();
		rdBtnImg.Location = new Point(10, 15);
		rdBtnImg.Size = new Size(80, 16);
		rdBtnImg.Text = "C[W";
		rdBtnImg.AutoCheck = false;
		if(m_Type == "Bitmap" || m_Type == "Icon")
			rdBtnImg.Checked = true;

		rdBtnFile = new RadioButton();
		rdBtnFile.Location = new Point(gBox.Width / 3 + 10, 15);
		rdBtnFile.Size = new Size(80, 16);
		rdBtnFile.Text = "t@C";
		rdBtnFile.AutoCheck = false;
		if(m_Type == "Byte[]" || m_Type == "Metafile" || m_Type == "MemoryStream" || m_Type == "PinnedBufferMemoryStream")
			rdBtnFile.Checked = true;

		rdBtnStr = new RadioButton();
		rdBtnStr.Location = new Point(gBox.Width * 2 / 3 + 20, 15);
		rdBtnStr.Size = new Size(80, 16);
		rdBtnStr.Text = "";
		rdBtnStr.AutoCheck = false;
		if(m_Type == "String")
			rdBtnStr.Checked = true;

		BtnShow = new Button();
		BtnShow.TabIndex = 0;
		BtnShow.Location = new Point(ClientSize.Width - BtnShow.Width - 20, labelName.Height + gBox.Height + 15);
		BtnShow.Text = "\";
		BtnShow.AutoSize = true;
		BtnShow.Click += new EventHandler(OnShow_Click);

		labelData = new Label();
		labelData.Text = "\[Xf[^";
		labelData.Location = new Point(10, labelName.Height + gBox.Height + 20);
		labelData.AutoSize = true;

		BtnSelFile = new Button();
		BtnSelFile.TabIndex = 1;
		BtnSelFile.Location = new Point(10, labelName.Height + gBox.Height + labelData.Height + 20);
		BtnSelFile.Size = new Size(ClientSize.Width - 20, 24);
		BtnSelFile.Text = "ۑt@C̎w";
		BtnSelFile.Click += new EventHandler(OnSelFIle_Click);

		txbPath = new TextBox();
		txbPath.Multiline = true;
		txbPath.Text = "";
		txbPath.ReadOnly = true;
		txbPath.BorderStyle = BorderStyle.Fixed3D;
		txbPath.Location = new Point(10, labelName.Height + gBox.Height + labelData.Height + BtnSelFile.Height + 20);
		txbPath.Size = new Size(ClientSize.Width - 20, 48);

		this.Controls.Add(labelName);
		this.Controls.Add(txbName);
		this.Controls.Add(gBox);
		gBox.Controls.Add(rdBtnImg);
		gBox.Controls.Add(rdBtnFile);
		gBox.Controls.Add(rdBtnStr);
		this.Controls.Add(BtnShow);
		this.Controls.Add(labelData);
		this.Controls.Add(BtnSelFile);
		this.Controls.Add(txbPath);
		this.Controls.Add(BtnOK);
		this.Controls.Add(BtnCancel);
	}

	protected void OnShow_Click(object sender, EventArgs e)
	{
		if(FileType)	//*.resourcest@C
		{
			//ResourceSet쐬
			ResourceSet rs = new ResourceSet(ResFileName);
			if(m_Type == "Bitmap")
			{
				//Bitmap\[X̓ǂݍ
				Image img = (Bitmap)rs.GetObject(m_Name);
				ImgShow imgdlg = new ImgShow(img);
				imgdlg.ShowDialog();
				imgdlg.Dispose();
			}
			else if(m_Type == "Icon")
			{
				//Icon\[X̓ǂݍ
				Image img = ((Icon)rs.GetObject(m_Name)).ToBitmap();
				ImgShow imgdlg = new ImgShow(img);
				imgdlg.ShowDialog();
				imgdlg.Dispose();
			}
			else if(m_Type == "String")
			{
				StrShow strdlg = new StrShow(m_Data);
				strdlg.ShowDialog();
				strdlg.Dispose();
			}
			else if(m_Type == "Byte[]" || m_Type == "Metafile" || m_Type == "MemoryStream" || m_Type == "PinnedBufferMemoryStream")
			{
				StrShow strdlg = new StrShow(m_Data);
				strdlg.ShowDialog();
				strdlg.Dispose();
			}
			else
				MessageBox.Show("@ȃC[W\[Xł", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
			rs.Dispose();
		}
		else			//*.resxt@C
		{
			//ResXResourceSet쐬
			ResXResourceSet rsx = new ResXResourceSet(ResFileName);
			if(m_Type == "Bitmap")
			{
				//Bitmap\[X̓ǂݍ
				Image img = (Bitmap)rsx.GetObject(m_Name);
				ImgShow imgdlg = new ImgShow(img);
				imgdlg.ShowDialog();
				imgdlg.Dispose();
			}
			else if(m_Type == "Icon")
			{
				//Icon\[X̓ǂݍ
				Image img = ((Icon)rsx.GetObject(m_Name)).ToBitmap();
				ImgShow imgdlg = new ImgShow(img);
				imgdlg.ShowDialog();
				imgdlg.Dispose();
			}
			else if(m_Type == "String")
			{
				StrShow strdlg = new StrShow(m_Data);
				strdlg.ShowDialog();
				strdlg.Dispose();
			}
			else if(m_Type == "Byte[]" || m_Type == "Metafile" || m_Type == "MemoryStream" || m_Type == "PinnedBufferMemoryStream")
			{
				StrShow strdlg = new StrShow(m_Data);
				strdlg.ShowDialog();
				strdlg.Dispose();
			}
			else
				MessageBox.Show("@ȃC[W\[Xł", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
			rsx.Dispose();
		}
	}

	protected void OnSelFIle_Click(object sender, EventArgs e)
	{
		SaveFileDialog sfDlg = new SaveFileDialog();
		//t@CtB^[̎w
		sfDlg.Filter = "C[Wt@C|*.bmp;*.ico|eLXgt@C(*.txt, *.restext)|*.txt;*.restext|ׂẴt@C(*.*)|*.*";
		//t@CtB^[CfbNX̎w
		if(m_Type == "Bitmap" || m_Type == "Icon")
			sfDlg.FilterIndex = 1;
		else if(m_Type == "String")
			sfDlg.FilterIndex = 2;
		else
			sfDlg.FilterIndex = 3;
		//_CAO{bNXOɌ݂̃fBNg𕜌悤ɂ
		sfDlg.RestoreDirectory = true;
		//݂ȂpXw肳ꂽƂx\
		sfDlg.CheckPathExists = true;
		// ftHg̃tH_w肷
		sfDlg.InitialDirectory = @".";
		//_CAÕ^Cgw肷
		sfDlg.Title = "ۑt@C̎w";
		//_CAO\
		if(sfDlg.ShowDialog() == DialogResult.OK)
		{
			txbPath.Text = sfDlg.FileName;
 		}
		else
		{
			txbPath.Text = "";
			MessageBox.Show("ۑt@C̎w肪LZ܂B", "LZ", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
		}
		// IuWFNgj
		sfDlg.Dispose();
	}

	protected void OnOK_Click(object sender, EventArgs e)
	{
		if(String.IsNullOrEmpty(txbPath.Text))
		{
			MessageBox.Show("ۑt@Cw肳Ă܂B", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
			return;
		}
		if(FileType)	//*.resourcest@C
		{
			//ResourceSet쐬
			ResourceSet rs = new ResourceSet(ResFileName);
			if(m_Type == "Bitmap")
			{
				//Bitmap\[X̕ۑ
				Image img = (Bitmap)rs.GetObject(m_Name);
				img.Save(txbPath.Text, ImageFormat.Bmp);
			}
			else if(m_Type == "Icon")
			{
				//Icon\[X̕ۑ
				Image img = ((Icon)rs.GetObject(m_Name)).ToBitmap();
				img.Save(txbPath.Text, ImageFormat.Icon);
			}
			else if(m_Type == "String")
			{
				//ׂĂ̕񃊃\[X擾t@Co͂I
				DialogResult dr = MessageBox.Show("wo̓t@C\".restext\"ɕύXAׂĂ̕񃊃\[X܂Ƃ߂ďo͂܂H", "restextt@Co͊mF", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
				if(dr == DialogResult.Yes)
				{
					m_Name = m_Type = "StrResCollection";
					m_Data = txbPath.Text;
				}
				else
				{
					//Text\[X̕ۑ
					using (StreamWriter sw = new StreamWriter(txbPath.Text))
					{
						sw.WriteLine(m_Data);
						sw.Close();
					}
				}
			}
			else if(m_Type == "Byte[]")
			{
				//Byte[]\[X̕ۑ
				Byte[] bytes = (Byte[])rs.GetObject(m_Name);
				File.WriteAllBytes (txbPath.Text, bytes);
			}
			else if(m_Type == "Metafile")
			{
				Metafile metaFile = (Metafile)rs.GetObject(m_Name);
				Image img = (Metafile)metaFile;
				img.Save(txbPath.Text, ImageFormat.Wmf);
			}
			else if(m_Type == "MemoryStream")
			{
				using (FileStream file = new FileStream(txbPath.Text, FileMode.Create, FileAccess.Write))	//FileMode.Create͊̃t@CΏ㏑
				{
					MemoryStream mStream = (MemoryStream)rs.GetObject(m_Name);
					mStream.WriteTo(file);
				}
				/* MemoryStream\[X̕ۑ̑̕@
				MemoryStream mStream = (MemoryStream)rsx.GetObject(m_Name);
				File.WriteAllBytes(txbPath.Text, mStream.ToArray()); 
				*/
			}
			else if(m_Type == "PinnedBufferMemoryStream")
			{
				ResourceReader rr = new ResourceReader(ResFileName);
				string resType = "";
				byte[] resData;
				rr.GetResourceData(m_Name, out resType, out resData);
				try
				{
					BinaryWriter bWriter = new BinaryWriter(new FileStream(txbPath.Text, FileMode.Create));	//FileMode.Create͊̃t@CΏ㏑
					bWriter.Write(resData);	//o邪0oCgt@CɂȂĂB
				}
				catch
				{}
				finally
				{
					MessageBox.Show("PinnedBufferMemoryStream\[X͕ی삳ĂAANZX̌`ɃLXgł܂B", "ۑs\", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				}
				/*
				//ResourceSetł͑ΉłȂ̂ŁAResourceReaderGetResourceData\bhgĂ݂炷Ȃ茈܂I
				ResourceReader rr = new ResourceReader(ResFileName);
				string resType = "";
				byte[] resData;
				rr.GetResourceData(m_Name, out resType, out resData);
				resType = String.Format("Resource Type: {0} and the Size : {1}", resType, resData.Length);
				MessageBox.Show(resType, "PinnedBufferMemoryStream ", MessageBoxButtons.OK, MessageBoxIcon.Information);
				//gpꂽp[^[Lł͂܂B
				//ꏊ System.Drawing.Image.FromStream(Stream stream, Boolean useEmbeddedColorManagement, Boolean validateImageData)
				MemoryStream mstream = new MemoryStream(resData);
				Image img = Image.FromStream(mstream);
				ImgShow imgdlg = new ImgShow(img);
				imgdlg.ShowDialog();

				//ImageConverter imgconv = new ImageConverter();
				//Image img = (Image)imgconv.ConvertFrom(resData);
				*/

				/* http://www.dotnetframework.org/default.aspx/4@0/4@0/DEVDIV_TFS/Dev10/Releases/RTMRel/ndp/clr/src/BCL/System/IO/PinnedBufferMemoryStream@cs/1305376/PinnedBufferMemoryStream@cs
					ɂunmanagedMemoryStreamhNXȂ̂ŁAōs邩Ǝv̂łu'System.IO.PinnedBufferMemoryStream' ̓ANZXłȂی샌xɂȂĂ܂vG[o܂B
				using (FileStream file = new FileStream(txbPath.Text, FileMode.Create, FileAccess.Write))	//FileMode.Create͊̃t@CΏ㏑
				{
					PinnedBufferMemoryStream pbms  = (PinnedBufferMemoryStream)rs.GetObject(m_Name);
					pbms.WriteTo(file);
				}
				dȂ̂ŁAMemoryStreamœǂގ܂B
				using(FileStream file = new FileStream(txbPath.Text, FileMode.Create, FileAccess.Write))	//FileMode.Create͊̃t@CΏ㏑
				{
					MemoryStream mStream = (MemoryStream)rs.GetObject(m_Name);
					mStream.WriteTo(file);
				}
				uSystem.InvalidCastException: ^ 'System.IO.PinnedBufferMemoryStream' ̃IuWFNg^ 'System.IO.MemoryStream' ɃLXgł܂vG[o܂B
				PinnedBufferMemoryStream pbms  = (PinnedBufferMemoryStream)rs.GetObject(m_Name);
				File.WriteAllBytes(txbPath.Text, pbms.ToArray()); 
				_BuPinnedBufferMemoryStreamv͕ی삳ĂAg܂B
				*/
			}
			else
				MessageBox.Show("@ȃC[W\[Xł", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
			rs.Dispose();
		}
		else			//*.resxt@C
		{
			//ResXResourceSet쐬
			ResXResourceSet rsx = new ResXResourceSet(ResFileName);
			if(m_Type == "Bitmap")
			{
				//Bitmap\[X̓ǂݍ
				Image img = (Bitmap)rsx.GetObject(m_Name);
				img.Save(txbPath.Text, ImageFormat.Bmp);
			}
			else if(m_Type == "Icon")
			{
				//Icon\[X̓ǂݍ
				Image img = ((Icon)rsx.GetObject(m_Name)).ToBitmap();
				img.Save(txbPath.Text, ImageFormat.Icon);
			}
			else if(m_Type == "String")
			{
				//ׂĂ̕񃊃\[X擾t@Co͂I
				DialogResult dr = MessageBox.Show("wo̓t@C\".restext\"ɕύXAׂĂ̕񃊃\[X܂Ƃ߂ďo͂܂H", "restextt@Co͊mF", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
				if(dr == DialogResult.Yes)
				{
					m_Name = m_Type = "StrResCollection";
					m_Data = txbPath.Text;
				}
				else
				{
					//Text\[X̕ۑ
					using (StreamWriter sw = new StreamWriter(txbPath.Text))
					{
						sw.WriteLine(m_Data);
						sw.Close();
					}
				}
			}
			else if(m_Type == "Byte[]")
			{
				//Byte[]\[X̕ۑ
				Byte[] bytes = (Byte[])rsx.GetObject(m_Name);
				File.WriteAllBytes(txbPath.Text, bytes);
			}
			else if(m_Type == "Metafile")
			{
				Metafile metaFile = (Metafile)rsx.GetObject(m_Name);
				Image img = (Metafile)metaFile;
				img.Save(txbPath.Text, ImageFormat.Wmf);
			}
			else if(m_Type == "MemoryStream")
			{
				// Case 2 MemoryStream\[X̕ۑiۑmF|jpgt@Cgpj
				using (FileStream file = new FileStream(txbPath.Text, FileMode.Create, FileAccess.Write))	//FileMode.Create͊̃t@CΏ㏑
				{
					MemoryStream mStream = (MemoryStream)rsx.GetObject(m_Name);
					mStream.WriteTo(file);
				}
				/* MemoryStream\[Xۑ鑼̕@
				MemoryStream mStream = (MemoryStream)rsx.GetObject(m_Name);
				File.WriteAllBytes(txbPath.Text, mStream.ToArray()); 
				*/
			}
			else if(m_Type == "PinnedBufferMemoryStream")
			{
				//ResXResourceReaderNX͂邪AGetResourceData\bhȂ̂ŏȗBi*.resxt@Cł"PinnedBufferMemoryStream"͏oȂ̂ŎIɖȂB
				MessageBox.Show("PinnedBufferMemoryStream\[X͕ی삳ĂAANZX̌`ɃLXgł܂B", "ۑs\", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				//http://www.dotnetframework.org/default.aspx/4@0/4@0/DEVDIV_TFS/Dev10/Releases/RTMRel/ndp/clr/src/BCL/System/IO/PinnedBufferMemoryStream@cs/1305376/PinnedBufferMemoryStream@cs
				
			}
			else
				MessageBox.Show("@ȃC[W\[Xł", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
			rsx.Dispose();
		}
		Close();
	}

	protected void OnCancel_Click(object sender, EventArgs e)
	{
		Close();
	}
}

///////////////////////
//ImgShow _CAO
///////////////////////
class ImgShow : Form
{
	public ImgShow(Image img)
	{
		//\pEBhEtH[̍쐬
		this.Size = new Size(300, 300);
		this.Text = "摜\[Xf[^";	//^Cg
		this.MaximizeBox = false;			// ő剻{^
		this.MinimizeBox = false;			// ŏ{^
		this.StartPosition = FormStartPosition.CenterScreen;	//ʒɔzu
		this.ShowInTaskbar = false;			//^XNo[\
		this.ShowInTaskbar = false;			//^XNo[\
		//\psN`[{bNX̍쐬
		PictureBox picbox = new PictureBox();
		picbox.Bounds = this.RestoreBounds;
		picbox.BorderStyle = BorderStyle.Fixed3D;
		picbox.Image = img;					//\pBitmapf[^̐ݒ
		picbox.SizeMode = PictureBoxSizeMode.StretchImage;
		picbox.Anchor = AnchorStyles.Top | AnchorStyles.Bottom | AnchorStyles.Left | AnchorStyles.Right;
		picbox.Click += new EventHandler(Dlg_OnClick);
		this.Controls.Add(picbox);			//sN`[{bNXEBhEɒt
	}

	private void Dlg_OnClick(Object sender, EventArgs e)
	{
		Close();
		Dispose();
	}
}

///////////////////////
//StrShow _CAO
///////////////////////
class StrShow : Form
{
	public StrShow(string str)
	{
		//\pEBhEtH[̍쐬
		this.Size = new Size(360, 180);
		this.Text = "̑\[Xf[^";	//^Cg
		this.MaximizeBox = false;		// ő剻{^
		this.MinimizeBox = false;		// ŏ{^
		this.StartPosition = FormStartPosition.CenterScreen;	//ʒɔzu
		this.ShowInTaskbar = false;		//^XNo[\
		//\peLXg{bNX̍쐬
		TextBox txtbox = new TextBox();
		txtbox.Bounds = this.RestoreBounds;
		txtbox.ScrollBars = ScrollBars.Vertical;
		txtbox.Multiline = true;
		txtbox.ReadOnly = true;
		txtbox.BorderStyle = BorderStyle.Fixed3D;
		txtbox.Text = str;				//\pstrf[^
		txtbox.Click += new EventHandler(Dlg_OnClick);
		txtbox.Anchor = AnchorStyles.Top | AnchorStyles.Bottom | AnchorStyles.Left | AnchorStyles.Right;
		this.Controls.Add(txtbox);		//eLXg{bNXEBhEɒt
	}

	private void Dlg_OnClick(object sender, EventArgs e)
	{
		Close();
		Dispose();
	}
}

/////////////////////
//Version _CAO
/////////////////////
class VersionDlg : Form
{
	public VersionDlg(Icon ico)
	{
		//_CAȎݒ
		this.Text = "o[V";
		this.ClientSize = new Size(320, 100);
		this.MaximizeBox = false;		// ő剻{^
		this.MinimizeBox = false;		// ŏ{^
		this.ShowInTaskbar = false;		//^XNo[\
		this.FormBorderStyle = FormBorderStyle.FixedDialog;		// ẼX^C
		this.StartPosition = FormStartPosition.CenterParent;	// etH[̒ɔzu
		//Rg[̑ݒ
		Button btnOK = new Button();
		btnOK.Size = new Size(40, 28);
		btnOK.Location = new Point(ClientSize.Width - btnOK.Width - 10, (ClientSize.Height - btnOK.Height) / 2);
		btnOK.Text = "OK";
		btnOK.Click += new EventHandler(OnOK_Click);
		Label imglabel = new Label();
		imglabel.Size = new Size(40, 40);
		imglabel.Location = new Point(10, (ClientSize.Height - imglabel.Height) / 2);
		imglabel.BorderStyle = BorderStyle.Fixed3D;
		imglabel.Image = ico.ToBitmap();	//ẽVXeACR
		Label label = new Label();
		label.Size = new Size(ClientSize.Width - imglabel.Width - btnOK.Width - 40, ClientSize.Height- 20);
		label.Location = new Point(imglabel.Width + 20, (ClientSize.Height - label.Height) / 2);
		label.BorderStyle = BorderStyle.Fixed3D;
		label.Text = "ResReader Version 1.0\r\nCopyright (c) 2022 by Ysama\r\n(written in Microsoft C#)";
		label.TextAlign = ContentAlignment.MiddleCenter;
		label.Font = new Font("Times New Roman", 10, FontStyle.Bold);
		this.Controls.Add(btnOK);
		this.Controls.Add(imglabel);
		this.Controls.Add(label);
	}

	private void OnOK_Click(object sender, EventArgs e)
	{
		Close();
	}
}
