//////////////////
// Text2Speech.cs
//////////////////
using System;
using System.Windows.Forms;
using System.Drawing;		//Sizeg
using System.IO;			//StreamReaderg
using System.Text;			//Encodingg
using System.Speech.Synthesis;
using System.Speech.AudioFormat;
//RpC"/reference:C:\Windows\Microsoft.NET\assembly\GAC_MSIL\System.Speech\v4.0_4.0.0.0__31bf3856ad364e35\System.Speech.dll"IvVKv

//̂SpeechLib.dll悤
//https://learn.microsoft.com/en-us/previous-versions/windows/desktop/ms720177(v=vs.85)
//https://www.valuestar.work/news/archives/44
//https://petile.com/mahoroba/e1590.html
//using SpeechLib;
//SpVoice sp = new SpeechLib.SpVoice();
//sp.Speak("eXg");

namespace Text2Speech
{
	public partial class AppForm : Form
	{
		//tH[̃Rg[
		TextBox txtBox;
		Button clrBtn, rdBtn, spBtn, sltBtn, swBtn, extBtn;
		//Xs[`VZTCU[
		SpeechSynthesizer synth;

		[STAThread]
		public static void Main()
		{
			AppForm ap = new AppForm();
			Application.Run(ap);
		}

		public AppForm()
		{
			this.Size = new Size(640, 480);
			this.MinimumSize = new Size(320, 260);
			this.Text = "System.Speech Test";
			this.Load += AppForm_Load;
		}

		private void AppForm_Load(object sender, EventArgs e)
		{
			//Clear{^
			clrBtn = new Button();
			clrBtn.Location = new Point(ClientSize.Width - clrBtn.Width - 10, 10);
			clrBtn.Text = "͏";
			clrBtn.Anchor = (AnchorStyles.Top | AnchorStyles.Right);
			clrBtn.Click += Button1_Click;
			this.Controls.Add(clrBtn);

			//Read{^
			rdBtn = new Button();
			rdBtn.Location = new Point(ClientSize.Width - rdBtn.Width - 10, clrBtn.Height + 20);
			rdBtn.Text = "ǂݍ";
			rdBtn.Anchor = (AnchorStyles.Top | AnchorStyles.Right);
			rdBtn.Click += Button2_Click;
			this.Controls.Add(rdBtn);

			//Speech{^
			spBtn = new Button();
			spBtn.Location = new Point(ClientSize.Width - spBtn.Width - 10, clrBtn.Height + rdBtn.Height + 30);
			spBtn.Text = "ǂݏグ";
			spBtn.Anchor = (AnchorStyles.Top | AnchorStyles.Right);
			spBtn.Click += Button3_Click;
			this.Controls.Add(spBtn);

			//Select{^
			sltBtn = new Button();
			sltBtn.Location = new Point(ClientSize.Width - sltBtn.Width - 10, clrBtn.Height + rdBtn.Height + spBtn.Height  + 40);
			sltBtn.Text = "I";
			sltBtn.Anchor = (AnchorStyles.Top | AnchorStyles.Right);
			sltBtn.Click += Button4_Click;
			this.Controls.Add(sltBtn);

			//Show{^
			swBtn = new Button();
			swBtn.Location = new Point(ClientSize.Width - swBtn.Width - 10, clrBtn.Height + rdBtn.Height + spBtn.Height + sltBtn.Height + 50);
			swBtn.Text = "ڍ";
			swBtn.Anchor = (AnchorStyles.Top | AnchorStyles.Right);
			swBtn.Click += Button5_Click;
			this.Controls.Add(swBtn);

			//Exit{^
			extBtn = new Button();
			extBtn.Location = new Point(ClientSize.Width - extBtn.Width - 10, ClientSize.Height - extBtn.Height - 20);
			extBtn.Text = "I";
			extBtn.Anchor = (AnchorStyles.Bottom | AnchorStyles.Right);
			extBtn.Click += Button6_Click;
			this.Controls.Add(extBtn);

			//eLXg{bNX
			txtBox = new TextBox();
			//ʒu
			txtBox.Location = new Point(10, 10);
			txtBox.Anchor = (AnchorStyles.Top | AnchorStyles.Left | AnchorStyles.Bottom | AnchorStyles.Right);
			//TCY
			txtBox.Width = ClientSize.Width - clrBtn.Width - 30;
			txtBox.Height = ClientSize.Height - 20;
			//̑vpeB
			txtBox.Multiline = true;
			txtBox.ScrollBars = ScrollBars.Both;
			txtBox.WordWrap= true;
			txtBox.Font = new Font(txtBox.Font.OriginalFontName, 12f);	//tHgTCYύX
			//FormTextBoxǉ
			this.Controls.Add(txtBox);

			//Xs[`VZTCU[̏
			try
			{
				//CX^X̍쐬
				synth = new SpeechSynthesizer();
				//o͂ftHgfoCXɂ
				synth.SetOutputToDefaultAudioDevice();
			}
			catch
			{
				MessageBox.Show("Xs[`VZTCU[g܂B", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
				//I
				Close();
			}
		}

		//I
		protected override void OnFormClosing(FormClosingEventArgs e)
		{
			base.OnFormClosing(e);
			DialogResult dr = MessageBox.Show("I܂H", "mF", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
			if(dr == DialogResult.No)
			{
				e.Cancel = true;
			}
			else
			{
				//݃yfBỎL[LZ
				synth.SpeakAsyncCancelAll();
				//\[X̊J
				synth.Dispose();
			}
		}

		private void Button1_Click(object sender, EventArgs e)
		{
			//txtBoxNA
			txtBox.Clear();
		}

		private void Button2_Click(object sender, EventArgs e)
		{
			//txtBoxɃt@Cǂ
			OpenFileDialog ofDlg = new OpenFileDialog();
			ofDlg.FileName = "*.*";						//t@C̎w
			ofDlg.Filter = "ׂẴt@C(*.*)|*.*";	//t@CtB^[̎w
			ofDlg.FilterIndex = 1;						//t@CtB^[CfbNX̎w
			ofDlg.RestoreDirectory = true;				//_CAO{bNXOɌ݂̃fBNg𕜌悤ɂ
			ofDlg.CheckFileExists = true;				//݂Ȃt@C̖Ow肳ꂽƂx\
			ofDlg.CheckPathExists = true;				//݂ȂpXw肳ꂽƂx\
			ofDlg.Multiselect = true;					//t@C̑Is
			ofDlg.InitialDirectory = @".\";				// ftHg̃tH_w肷
			ofDlg.Title = "t@CJ";				//_CAÕ^Cgw肷
			if(ofDlg.ShowDialog() == DialogResult.OK)	//_CAO\
			{
				//StreamReadertxtBox"Shift_JIS"t@Cǂݍ
				StreamReader sr = new StreamReader(ofDlg.FileName, Encoding.GetEncoding("Shift_JIS"));
 				txtBox.Text = sr.ReadToEnd();
				sr.Close();
			}
			else
			{
				MessageBox.Show("LZ܂B", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
			// IuWFNgj
			ofDlg.Dispose();
		}

		private void Button3_Click(object sender, EventArgs e)
		{
			DialogResult dr;	//MessageBox̉
			//̏󋵂mF
			if(synth.State != SynthesizerState.Ready)	//0 - SynthesizerState.ReadyA1 - SynthesizerState.SpeakingA2 - SynthesizerState.Paused
			{
				string str = (synth.State == SynthesizerState.Speaking) ? "ǂݏグłBf܂H" : "ǂݏグ~łBf܂H";
				dr = MessageBox.Show(str, "mF", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
				if(dr == DialogResult.Yes)
				{
					//ׂẴyfBOǂݏグ𒆒f
					synth.SpeakAsyncCancelAll();
					//ReadyɂȂ܂Ł`[v
					while(synth.State != SynthesizerState.Ready);
				}
				else
					return;		//uǂݏグvLZ
			}
			//ʐݒ
			synth.Volume = 50;	//0 - 100Őݒ
			//ݒ
			synth.Rate = 0;	//-10 - 10Őݒ
			//A񓯊̑I
			dr = MessageBox.Show("œǂ݂܂Hi͂jA\r\n񓯊ɂ܂Hij", "mF", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
			if(dr == DialogResult.Yes)
			{
				dr = MessageBox.Show("SSMLœǂ݂܂Hi͂jA\r\nTextɂ܂Hij", "mF", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
				if(dr == DialogResult.Yes)
					//SSMLeLXgɂǂݏグ
					synth.SpeakSsml(txtBox.Text);	//SSMLǂݏグ|fłȂ
				else
					//eLXgǂݏグ
					synth.Speak(txtBox.Text);		//ǂݏグ|fłȂ
			}
			else
			{
				dr = MessageBox.Show("SSMLœǂ݂܂Hi͂jA\r\nTextɂ܂Hij", "mF", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
				if(dr == DialogResult.Yes)
				{
					//SSMLeLXgɂǂݏグ
					synth.SpeakSsmlAsync(txtBox.Text);	//񓯊ǂݏグ|fł
					//SSMLeLXgPromptǂݏグ
					//Prompt pmt= new Prompt(txtBox.Text);
					//synth.SpeakAsync(pmt);			//񓯊ǂݏグ|fł
				}
				else
					//eLXgɂǂݏグ
					synth.SpeakAsync(txtBox.Text);	//񓯊ǂݏグ|fł
			}
		}

		private void Button4_Click(object sender, EventArgs e)
		{
			//CXg[ꂽ̗
			foreach (InstalledVoice voice in synth.GetInstalledVoices())
			{
				string Voice = "";
				VoiceInfo vinfo = voice.VoiceInfo;
				//leLXg{bNXɕ\
				Voice += "Name:	" + vinfo.Name + "\r\n";
				Voice += "Culture:	" + vinfo.Culture + "\r\n";
				Voice += "Age:	" + vinfo.Age + "\r\n";
				Voice += "Gender:	" + vinfo.Gender + "\r\n";
				DialogResult dr = MessageBox.Show(Voice + "̉ł낵łH", "mF", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
				if(dr == DialogResult.Yes)
				{
					synth.SelectVoice(vinfo.Name);		//̐ݒ
					break;;
				}
			}
		}

		private void Button5_Click(object sender, EventArgs e)
		{
			string buff = txtBox.Text;	//݂̃eLXgޔ
			txtBox.Clear();				//݂̃eLXg
			//CXg[ꂽ̗񋓁ỉ݂ synth.Voice vpeBŎ擾łj
			foreach (InstalledVoice voice in synth.GetInstalledVoices())
			{
				string Voice = "";						//(SelectVoice(String) gj
				VoiceInfo vinfo = voice.VoiceInfo;
				//leLXg{bNXɕ\
				Voice += "Name:		" + vinfo.Name + "\r\n";
				Voice += "Culture:		" + vinfo.Culture + "\r\n";
				Voice += "Age:		" + vinfo.Age + "\r\n";
				Voice += "Gender:		" + vinfo.Gender + "\r\n";
				Voice += "Description:	" + vinfo.Description + "\r\n";
				Voice += "ID:		" + vinfo.Id + "\r\n";
				Voice += "Enabled:		" + voice.Enabled + "\r\n";
				txtBox.Text += "\r\n" + Voice;
				//tH[}bgiAudio Formatj𒲂ׂ
				string AudioFormats = "tH[}bg\r\n";	//Voice.SupportedAudioFormats|T|[gI[fBI`̃RNV
				foreach (SpeechAudioFormatInfo fmt in vinfo.SupportedAudioFormats)
				{
					AudioFormats += String.Format("{0}\r\n", fmt.EncodingFormat.ToString());
				}
				if(vinfo.SupportedAudioFormats.Count != 0)
				{
					txtBox.Text += AudioFormats + "\r\n";
				}
				else
				{
					txtBox.Text += "tH[}bg\r\npł鉹tH[}bg܂B" + "\r\n";
				}
				//̑𓾂
				string AdditionalInfo = "̑\r\n";
				foreach (string key in vinfo.AdditionalInfo.Keys)
				{
					AdditionalInfo += String.Format("{0}: {1}\n", key, vinfo.AdditionalInfo[key]);
					}
				txtBox.Text += AdditionalInfo + "\r\n\r\n";
			}
			DialogResult dr = MessageBox.Show("eLXg𕜌܂H", "mF", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
			if(dr == DialogResult.Yes)
			{
				txtBox.Text = buff;
			}
		}

		private void Button6_Click(object sender, EventArgs e)
		{
			//I
			Close();
		}
	}
}
