///////////////////////////////////////////////
//SpeechRecognitionEnginẽeXg|Windows
///////////////////////////////////////////////
using System;
using System.Windows;
using System.Windows.Controls;		//Rg[𗘗p
using System.Windows.Media.Imaging;	//BitmapFramegp
using System.Speech.Recognition;	//FGW

namespace SpeechRecognitionWin
{
	///////////////////////////
	//Gg[|CgNX
	///////////////////////////
	class MainApp
	{
		[STAThread]
		public static void Main()
		{
			MainWindow mwnd = new MainWindow();
			Application ap = new Application();
			ap.Run(mwnd);
		}
	}

	public partial class MainWindow : Window
	{
		//MainWindowNX̕ϐ
		SpeechRecognitionEngine recEng;	//FGW
		TextBox TBox;					//eLXg{bNX
		ListBox LBox;					//Xg{bNX
		Button extBtn;					//I{^

		//RXgN^[
		public MainWindow()
		{
			//this.Icon = BitmapFrame.Create(new Uri("Icon.ico", UriKind.Relative));	//tH[_[Icon.icoǂŎgp
			this.WindowStyle = WindowStyle.ThreeDBorderWindow;
			this.Background = SystemColors.WindowBrush;
			this.WindowStartupLocation = WindowStartupLocation.CenterScreen;
			this.Width = 525;
			this.Height = 350;
			this.ResizeMode = ResizeMode.CanResizeWithGrip;
			this.ShowActivated = true;							//ANeBuԂŏ\邩ǂ|Kl true
			this.ShowInTaskbar = true;							//^XNo|Ƀ{^\邩ۂ
			this.Title = "Speech Recognition";
			this.Loaded += Window_Loaded;
		}
		
		//WM_CREATE
		private void Window_Loaded(object sender, EventArgs e)
		{
			//Rg[̐ݒ
			InitControls();
			//CXg[Ă鉹FGWŃCX^X𐶐
			recEng = new SpeechRecognitionEngine(SelectEngine());
			//DictationGrammar (fBNeBVp̎)̒ǉ
			recEng.LoadGrammar(new DictationGrammar());
			try
			{
				//FGWւ̓͐ݒ
				recEng.SetInputToDefaultAudioDevice();
				//񓯊FpAFs
				recEng.RecognizeAsync(RecognizeMode.Multiple);
			}
			catch
			{
				MessageBox.Show("Wo͂܂", "G[", MessageBoxButton.OK, MessageBoxImage.Error);
			}
			//FCxgnh[
			recEng.SpeechRecognized += new EventHandler<SpeechRecognizedEventArgs>(recEng_SpeechRecognized);
			//recEng.SpeechRecognized += recEng_SpeechRecognized;
			//Cxgnh[
			recEng.SpeechHypothesized += new EventHandler<SpeechHypothesizedEventArgs>(recEng_SpeechHypothesized);
			//recEng.SpeechHypothesized += recEng_SpeechHypothesized;
		}

		//CXg[ꂽFGW\AI
		public RecognizerInfo SelectEngine()
		{
			//SFGWXg{bNXɕ\
			foreach(RecognizerInfo ri in SpeechRecognitionEngine.InstalledRecognizers())
			{
				LBox.Items.Add(ri.Culture.Name);
			}
			//FGW̑I
			RecognizerInfo info = null;
			while(info == null)	//IȂIȂ
			{
				//CXg[ꂽFGWɕ\
				foreach(RecognizerInfo ri in SpeechRecognitionEngine.InstalledRecognizers())
				{
					MessageBoxResult result = MessageBox.Show(
									"ȉ̃GW܂B\r\n\r\n" + 
									ri.Name + " : " + ri.Culture.Name + 
									"\r\n\r\nI܂HiLZ|Ij", "FGW", 
									MessageBoxButton.YesNoCancel, MessageBoxImage.Question);
					if(result == MessageBoxResult.Yes)	//I
					{
						info = ri;
						MessageBox.Show(ri.Culture.Name + " ŉFJn܂B", "ʒm", MessageBoxButton.OK, MessageBoxImage.Information);
						break;
					}
					else if(result == MessageBoxResult.Cancel)	//I
					{
						Close();
					}
				}
			}
			return info;
		}

		//Rg[̐ݒ
		public void InitControls()
		{
			//ObhiGridj쐬
			Grid grid = new Grid();
			//c쐬E`
			ColumnDefinition colL = new ColumnDefinition();
			ColumnDefinition colR = new ColumnDefinition();
			colL.Width = new GridLength(this.Width / 2, GridUnitType.Pixel);
			//colL.Width = GridLength.Auto;
			colR.Width = GridLength.Auto;
			grid.ColumnDefinitions.Add(colL);
			grid.ColumnDefinitions.Add(colR);
			//eLXg{bNX쐬
			TBox = new TextBox();
			//ʒuAtHgTCYƂ̑ݒ
			TBox.Margin = new Thickness(5, 5, 5, 5);
			TBox.FontSize = 12;
			TBox.HorizontalAlignment = HorizontalAlignment.Left;
			TBox.TextWrapping = TextWrapping.NoWrap;
			TBox.HorizontalScrollBarVisibility = ScrollBarVisibility.Visible;
			TBox.VerticalScrollBarVisibility = ScrollBarVisibility.Visible;
			//ObhɂeLXg{bNXo^
			Grid.SetColumn(TBox, 0);		//GridNX̐ÓI\bhł_ɒ
			grid.Children.Add(TBox);
			//hbNpliDockPanelj쐬
			DockPanel dPanel = new DockPanel();
			//x𐶐
			Label lbl = new Label();
			lbl.Content = "PCɃCXg[Ă鉹FGW";
			lbl.HorizontalAlignment = HorizontalAlignment.Center;
			DockPanel.SetDock(lbl, Dock.Top);	//DockPanelNX̐ÓI\bhł_ɒ
			dPanel.Children.Add(lbl);
			//Xg{bNX𐶐
			LBox = new ListBox();
			LBox.SelectionMode = SelectionMode.Single;
			LBox.Margin = new Thickness(10, 10, 10, 10);
			LBox.HorizontalAlignment = HorizontalAlignment.Stretch;
			LBox.VerticalAlignment = VerticalAlignment.Stretch;
			DockPanel.SetDock (LBox, Dock.Top);	//DockPanelNX̐ÓI\bhł_ɒ
			dPanel.Children.Add(LBox);
			//I{^𐶐
			extBtn = new Button();
			extBtn.Width = 60;
			extBtn.Height = 24;
			extBtn.Margin = new Thickness(10, 10, 10, 10);	//\ Thickness(, , E, )
			extBtn.HorizontalAlignment = HorizontalAlignment.Stretch;	//HorizontalAlignment.Right;
			extBtn.VerticalAlignment = VerticalAlignment.Bottom;
			extBtn.Content = "I";
			extBtn.Click += extBtn_Click;
			DockPanel.SetDock (extBtn, Dock.Bottom);	//DockPanelNX̐ÓI\bhł_ɒ
			dPanel.Children.Add(extBtn);
			//ObhEɃhbNplo^
			Grid.SetColumn(dPanel, 1);			//GridNX̐ÓI\bhł_ɒ
			grid.Children.Add(dPanel);
			//MainWindowgridǉ
			this.Content = grid;
		}

		//I
		protected override void OnClosed(EventArgs e)
		{
			base.OnClosed(e);
			//IɉFGWJB
			recEng.Dispose();
		}

		//F̏
		void recEng_SpeechRecognized(object sender, SpeechRecognizedEventArgs e)
		{
			this.TBox.Text = "FF" + e.Result.Text + "(" + e.Result.Confidence + ")\r\n" + this.TBox.Text;
		}

		//莞̏
		void recEng_SpeechHypothesized(object sender, SpeechHypothesizedEventArgs e)
		{
			this.TBox.Text = "F" + e.Result.Text + "("+ e.Result.Confidence + ")\r\n" + this.TBox.Text;
		}

		//I{^NbN̏
		void extBtn_Click(object sender, RoutedEventArgs e)
		{
			Close();
		}
	}
}
